"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var L = require("leaflet");
var leaflet_geosearch_1 = require("leaflet-geosearch");
var utils_1 = require("./utils");
var globals_1 = require("./globals");
var dependency_utils_1 = require("./dependency-utils");
var noUiSlider = require("nouislider");
function getSubControlName(name, subName) {
    return (name !== undefined) ? name + "." + subName : subName;
}
function LajiMapWithControls(Base) {
    var LajiMapWithControls = /** @class */ (function (_super) {
        __extends(LajiMapWithControls, _super);
        function LajiMapWithControls() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LajiMapWithControls.prototype.getOptionKeys = function () {
            var _this = this;
            return __assign(__assign({}, _super.prototype.getOptionKeys.call(this)), { controlSettings: "setControlsWarn", controls: ["setControls", function () { return _this.controlSettings; }], customControls: ["setCustomControls", function () {
                        return _this._customControls === undefined
                            ? _this._customControls
                            : _this._customControls.map(function (_a) {
                                var _custom = _a._custom, rest = __rest(_a, ["_custom"]);
                                return __assign({}, rest);
                            });
                    }] });
        };
        LajiMapWithControls.prototype._setLang = function () {
            var _this = this;
            // Original strings are here: https://github.com/Leaflet/Leaflet.draw/blob/master/src/Leaflet.draw.js
            var drawLocalizations = L.drawLocal.draw;
            var join = function () {
                var params = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    params[_i] = arguments[_i];
                }
                return _this._joinTranslations.apply(_this, params);
            };
            drawLocalizations.toolbar.buttons.marker = join("Add", "marker");
            ["polygon", "rectangle", "polyline", "circle"].forEach(function (featureType) {
                drawLocalizations.toolbar.buttons[featureType] = join("Draw", featureType);
            });
            drawLocalizations.toolbar.actions.title = join("Cancel", "drawPassiveVerb");
            drawLocalizations.toolbar.actions.text = join("Cancel");
            drawLocalizations.toolbar.finish.title = join("Finish", "drawPassiveVerb");
            drawLocalizations.toolbar.finish.text = join("Finish");
            drawLocalizations.toolbar.undo.title = join("Delete", "lastPointDrawn");
            drawLocalizations.toolbar.undo.text = join("Delete", "last", "point");
            drawLocalizations.handlers.circle.tooltip.start = join("Click", "and", "drag", "toDrawCircle");
            drawLocalizations.handlers.marker.tooltip.start = join("ClickMapToPlaceMarker");
            drawLocalizations.handlers.polygon.tooltip.start = join("ClickToStartDrawingShape");
            drawLocalizations.handlers.polygon.tooltip.cont = join("ClickToContinueDrawingShape");
            drawLocalizations.handlers.polygon.tooltip.end = join("ClickToEndDrawingShape");
            drawLocalizations.handlers.polyline.tooltip.start = join("ClickToStartDrawingPolyline");
            drawLocalizations.handlers.polyline.tooltip.cont = join("ClickToContinueDrawingPolyline");
            drawLocalizations.handlers.polyline.tooltip.end = join("ClickToEndDrawingPolyline");
            drawLocalizations.handlers.polyline.error = join("shapeEdgesCannotCross") + "!";
            drawLocalizations.handlers.rectangle.tooltip.start = join("Click", "and", "drag", "toDrawRectangle");
            drawLocalizations.handlers.simpleshape.tooltip.end = join("simpleShapeEnd");
            dependency_utils_1.provide(this, "translations");
        };
        LajiMapWithControls.prototype.setLang = function (lang) {
            if (!dependency_utils_1.depsProvided(this, "setLang", arguments))
                return;
            _super.prototype.setLang.call(this, lang, !"dontProvide");
            this._setLang();
        };
        LajiMapWithControls.prototype._initializeMapEvents = function () {
            var _this = this;
            _super.prototype._initializeMapEvents.call(this);
            var cancelDraw = function (_a) {
                var name = _a.name;
                if (name === "draw" || name === "zoom" || name === "layer")
                    return;
                if (!_this.drawControl)
                    return;
                _this.getFeatureTypes().forEach(function (featureType) {
                    var handlerContainer = _this.drawControl._toolbars.draw._modes[featureType];
                    if (handlerContainer && handlerContainer.handler._enabled) {
                        _this.drawControl._toolbars.draw._modes[featureType].handler.disable();
                    }
                });
                _this._clearEditable();
            };
            // TODO Poista kommentit kun laji.fi havaintokartan neliöllä rajaus bugi korjattu.
            // Jostain syystä draw:created -> this._onAdd ei triggeröidy.
            // this.map.on("draw:created", e => {
            // 	cancelDraw(e);
            // });
            this.map.on("controlClick", cancelDraw);
        };
        LajiMapWithControls.prototype._toggleLocate = function () {
            this._locateOn ? this._setLocateOff() : this._setLocateOn(!!"triggerEvent");
        };
        LajiMapWithControls.prototype._setLocateOn = function () {
            var params = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                params[_i] = arguments[_i];
            }
            _super.prototype._setLocateOn.apply(this, params);
            this._updateUserLocate(true);
        };
        LajiMapWithControls.prototype._setLocateOff = function () {
            _super.prototype._setLocateOff.call(this);
            this._updateUserLocate(false);
        };
        LajiMapWithControls.prototype._onLocationFound = function (e) {
            _super.prototype._onLocationFound.call(this, e);
            this._updateUserLocate(this._locateOn);
        };
        LajiMapWithControls.prototype.setTileLayers = function (options) {
            var provided = dependency_utils_1.isProvided(this, "tileLayer");
            _super.prototype.setTileLayers.call(this, options);
            if (!provided && dependency_utils_1.isProvided(this, "tileLayer")) {
                this._updateMapControls();
            }
        };
        LajiMapWithControls.prototype._updateUserLocate = function (value) {
            if (!dependency_utils_1.depsProvided(this, "_updateUserLocate", arguments))
                return;
            this._locateOn = value !== undefined ? value : this._locateOn;
            var button = this._controlButtons.location;
            if (!button)
                return;
            if (this._locateOn && button.className.indexOf(" on") === -1) {
                button.className = button.className + " on";
            }
            else if (!this._locateOn && button.className.indexOf(" on") !== -1) {
                button.className = button.className.replace(" on", "");
            }
            if (!this._located && button.className.indexOf(" locating") === -1) {
                button.className = button.className + " locating";
            }
            else if (this._located && button.className.indexOf(" locating") !== -1) {
                button.className = button.className.replace(" locating", "");
            }
        };
        LajiMapWithControls.prototype._updateMapControls = function () {
            var _this = this;
            if (!dependency_utils_1.depsProvided(this, "_updateMapControls", arguments))
                return;
            var controlContainerNode = this.container.querySelector(".leaflet-control-container");
            if (controlContainerNode.className.indexOf("leaflet-touch") === -1) {
                controlContainerNode.className += " leaflet-touch";
            }
            (this.controls || []).forEach(function (control) {
                if (control)
                    _this.map.removeControl(control);
            });
            this.controls = [];
            this.controlItems = [
                {
                    name: "layer",
                    control: function () { return _this._getLayerControl(); }
                },
                {
                    name: "location",
                    position: "topleft",
                    text: this.translations.Geolocate,
                    iconCls: "glyphicon glyphicon-screenshot",
                    fn: function () { return _this._toggleLocate(); },
                    contextMenu: false
                },
                {
                    name: "geocoding",
                    control: function () { return _this.getGoogleGeocodingControl(); },
                    dependencies: [
                        function () { return !!_this.googleApiKey; }
                    ]
                },
                {
                    name: "zoom",
                    control: function () { return _this.getZoomControl(); }
                },
                {
                    name: "scale",
                    control: function () { return L.control.scale({ metric: true, imperial: false }); }
                },
                {
                    name: "attribution",
                    control: function () { return L.control.attribution({ prefix: "" }); }
                },
                {
                    name: "coordinates",
                    control: function () { return _this._getCoordinatesControl(); }
                },
                {
                    name: "fullscreen",
                    position: "bottomright",
                    text: this.translations.MapFullscreen,
                    iconCls: "glyphicon glyphicon-resize-full",
                    fn: function () { return _this.toggleFullscreen(); }
                },
                {
                    name: "draw",
                    control: function () { return _this._getDrawControl(); },
                    dependencies: [
                        function () { return _this.drawIsEditable(); }
                    ]
                },
                {
                    name: "drawUtils",
                    dependencies: [
                        function () { return _this.drawIsAllowed(); }
                    ],
                    controls: [
                        {
                            name: "coordinateInput",
                            text: this.translations.AddFeatureByCoordinates,
                            iconCls: "laji-map-coordinate-input-glyph",
                            fn: function () { return _this.openCoordinatesInputDialog(); },
                            dependencies: [
                                function () { return (["marker", "rectangle"].some(function (type) {
                                    return _this.getDraw()[type] !== false;
                                })); },
                                function () { return _this.drawIsEditable(); }
                            ]
                        },
                        {
                            name: "copy",
                            text: this.translations.CopyDrawnFeatures,
                            iconCls: "glyphicon glyphicon-floppy-save",
                            fn: function () { return _this.openDrawCopyDialog(); }
                        },
                        {
                            name: "upload",
                            text: this.translations.UploadDrawnFeatures,
                            iconCls: "glyphicon glyphicon-floppy-open",
                            fn: function () { return _this.openDrawUploadDialog(); },
                            dependencies: [
                                function () { return _this.drawIsEditable(); }
                            ]
                        },
                        {
                            name: "clear",
                            text: this.translations.ClearMap,
                            iconCls: "glyphicon glyphicon-trash",
                            fn: function () {
                                var params = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    params[_i] = arguments[_i];
                                }
                                var container = document.createElement("div");
                                var translateHooks = [];
                                var yesButton = document.createElement("button");
                                yesButton.className = "btn btn-block btn-primary";
                                translateHooks.push(_this.addTranslationHook(yesButton, "Yes"));
                                yesButton.addEventListener("click", function (e) {
                                    _this.clearDrawData();
                                    _this._closeDialog(e);
                                });
                                var noButton = document.createElement("button");
                                noButton.className = "btn btn-block btn-primary";
                                translateHooks.push(_this.addTranslationHook(noButton, "No"));
                                noButton.addEventListener("click", function (e) { return _this._closeDialog(e); });
                                var question = document.createElement("h5");
                                translateHooks.push(_this.addTranslationHook(question, "ConfirmDrawClear"));
                                container.appendChild(question);
                                container.appendChild(yesButton);
                                container.appendChild(noButton);
                                _this._showDialog(container, function () {
                                    translateHooks.forEach(function (hook) {
                                        that.removeTranslationHook(hook);
                                    });
                                });
                                yesButton.focus();
                            },
                            dependencies: [
                                function () { return _this.drawIsEditable(); }
                            ]
                        },
                        {
                            name: "delete",
                            text: this.translations.DeleteFeature,
                            iconCls: "glyphicon glyphicon-remove-sign",
                            fn: function () {
                                var params = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    params[_i] = arguments[_i];
                                }
                                _this._startDrawRemove();
                            },
                            finishFn: function () {
                                var params = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    params[_i] = arguments[_i];
                                }
                                return _this._finishDrawRemove();
                            },
                            dependencies: [
                                function () { return _this.drawIsEditable(); }
                            ]
                        },
                        {
                            name: "reverse",
                            iconCls: "glyphicon glyphicon-sort",
                            text: this.translations.ReverseFeature,
                            fn: function () {
                                var params = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    params[_i] = arguments[_i];
                                }
                                _this._startDrawReverse();
                            },
                            finishFn: function () {
                                var params = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    params[_i] = arguments[_i];
                                }
                                return _this._finishDrawReverse();
                            },
                            dependencies: [
                                function () { return _this.getDraw().polyline !== false; },
                                function () { return _this.drawIsEditable(); }
                            ]
                        },
                        {
                            name: "undo",
                            text: this.translations.Undo,
                            iconCls: "laji-map-line-transect-undo-glyph",
                            fn: function () { return _this.drawUndo(); },
                            onAdd: function () { return _this.updateDrawUndoButton(); },
                            disabled: this._drawHistoryPointer <= 0,
                            dependencies: [
                                function () { return _this.drawIsEditable(); }
                            ]
                        },
                        {
                            name: "redo",
                            text: this.translations.Redo,
                            iconCls: "laji-map-line-transect-redo-glyph",
                            fn: function () { return _this.drawRedo(); },
                            onAdd: function () { return _this.updateDrawRedoButton(); },
                            disabled: this._drawHistoryPointer >= this._drawHistory.length - 1,
                            dependencies: [
                                function () { return _this.drawIsEditable(); }
                            ]
                        }
                    ]
                },
                {
                    name: "lineTransect",
                    controls: [
                        {
                            name: "split",
                            text: this.translations.SplitLine,
                            iconCls: "glyphicon glyphicon-scissors",
                            fn: function () { return _this.startLTLineSplit(); },
                            finishFn: function () { return _this.stopLTLineSplit(); },
                            eventName: "lineTransect:split"
                        },
                        {
                            name: "splitByMeters",
                            text: this.translations.SplitLineByMeters,
                            iconCls: "laji-map-line-transect-split-by-meters-glyph",
                            fn: function () { return _this.splitLTByMeters(); },
                            eventName: "lineTransect:split"
                        },
                        {
                            name: "deletePoints",
                            text: this.translations.ConnectSegments,
                            iconCls: "laji-map-line-transect-remove-point-glyph",
                            fn: function () { return _this.startRemoveLTPointMode(); },
                            finishFn: function () { return _this.stopRemoveLTPointMode(); },
                            eventName: "lineTransect:deletePoint"
                        },
                        {
                            name: "createPoint",
                            text: this.translations.CreatePoint,
                            iconCls: "laji-map-line-transect-create-point-glyph",
                            fn: function () { return _this.startLTPointAdd(); },
                            finishFn: function () { return _this.stopLTLineSplit(); },
                            eventName: "lineTransect:pointadd"
                        },
                        {
                            name: "shiftPoint",
                            text: this.translations.ShiftPoint,
                            iconCls: "laji-map-line-transect-shift-point-glyph",
                            fn: function () { return _this.startLTPointShift(); },
                            finishFn: function () { return _this.stopLTPointShift(); },
                            eventName: "lineTransect:pointshift"
                        },
                        {
                            name: "undo",
                            text: this.translations.Undo,
                            iconCls: "laji-map-line-transect-undo-glyph",
                            fn: function () { return _this.LTUndo(); },
                            onAdd: function () { return _this.updateLTUndoButton(); },
                            disabled: this._LTHistoryPointer <= 0
                        },
                        {
                            name: "redo",
                            text: this.translations.Redo,
                            iconCls: "laji-map-line-transect-redo-glyph",
                            fn: function () { return _this.LTRedo(); },
                            onAdd: function () { return _this.updateLTRedoButton(); },
                            disabled: !this._LTHistory || this._LTHistoryPointer >= this._LTHistory.length - 1
                        }
                    ],
                    dependencies: [
                        function () { return dependency_utils_1.isProvided(_this, "lineTransect"); },
                        function () { return _this._LTEditable; }
                    ],
                }
            ];
            var controlGroups = this.controlItems.reduce(function (groups, group) {
                if (group.controls)
                    groups[group.name] = group;
                return groups;
            }, {});
            if (this._customControls) {
                this._customControls = this._customControls.map(function (customControl) {
                    customControl = __assign(__assign({}, customControl), { _custom: true });
                    var target = customControl.group && controlGroups[customControl.group]
                        ? controlGroups[customControl.group].controls
                        : _this.controlItems;
                    target.push(customControl);
                    return customControl;
                });
            }
            var reducer = function (prefix) {
                if (prefix === void 0) { prefix = ""; }
                return function (byNames, controlItem) {
                    byNames["" + prefix + controlItem.name] = controlItem;
                    if (controlItem.controls) {
                        controlItem.controls.reduce(reducer(controlItem.name + "."), byNames);
                    }
                    return byNames;
                };
            };
            this._controlItemsByName = this.controlItems.reduce(reducer(), {});
            var that = this;
            function _createActionHandler(name, fn, eventName, text) {
                var cont = this.buttonActionContainer[name];
                var _that = this;
                function stop() {
                    fn();
                    that.map.off("controlClick", stopOnControlClick);
                    that._removeKeyListener(globals_1.ESC, stop);
                    if (_that.container.contains(cont))
                        _that.container.removeChild(cont);
                    if (eventName)
                        that.map.off(eventName);
                    if (_that.container.contains(cont))
                        _that.container.removeChild(cont);
                    Object.keys(_that.buttonActions[name]).forEach(function (_text) {
                        cont.removeChild(_that.buttonActions[name][_text]);
                    });
                    _that.buttonActions[name] = {};
                    that.activeControl = undefined;
                }
                function stopOnControlClick(_a) {
                    var _name = _a.name;
                    if (name !== _name && name !== "zoom" && name !== "layer")
                        stop();
                }
                if (!cont) {
                    this.buttonActionContainer[name] = L.DomUtil.create("ul", "leaflet-draw-actions");
                    cont = this.buttonActionContainer[name];
                }
                if (!this.buttonActions[name][text]) {
                    var buttonWrapper = L.DomUtil.create("li");
                    var button = that._createControlButton(this, buttonWrapper, stop);
                    that.addTranslationHook(button, text);
                    cont.appendChild(buttonWrapper);
                    that.map.on("controlClick", stopOnControlClick);
                    this.buttonActions[name][text] = buttonWrapper;
                }
                that._addKeyListener(globals_1.ESC, stop, undefined);
                if (eventName)
                    that.map.on(eventName, stop);
                var parentBtn = that._controlButtons[name];
                cont.style.top = parentBtn.offsetTop + "px";
                cont.style.display = "block";
                this.container.appendChild(cont);
                that.activeControl = name;
            }
            function _createFinishHandler(name, fn, eventName) {
                this._createActionHandler(name, fn, eventName, "Finish");
            }
            function _createCancelHandler(name, fn, eventName) {
                this._createActionHandler(name, fn, eventName, "Cancel");
            }
            this._controlButtons = {};
            function callback(fn, finishFn, cancelFn, name, eventName) {
                var _this = this;
                return function () {
                    var params = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        params[_i] = arguments[_i];
                    }
                    that.map.fire("controlClick", { name: name });
                    if (finishFn) {
                        fn.apply(void 0, params);
                        _this._createFinishHandler(name, finishFn, eventName);
                        cancelFn && _this._createCancelHandler(name, cancelFn, eventName);
                    }
                    else {
                        fn.apply(void 0, params);
                    }
                };
            }
            this.controlItems.filter(function (_a) {
                var control = _a.control, name = _a.name;
                return !control || _this._controlIsAllowed(name);
            }).forEach(function (_a) {
                var name = _a.name, control = _a.control, controls = _a.controls, position = _a.position, iconCls = _a.iconCls, fn = _a.fn, finishFn = _a.finishFn, cancelFn = _a.cancelFn, text = _a.text, eventName = _a.eventName, _onAdd = _a.onAdd;
                var leafletControl = (control ? control() : undefined) || (function () {
                    var onAdd = (controls) ?
                        function () {
                            var _this = this;
                            this.container = L.DomUtil.create("div", "leaflet-control laji-map-control leaflet-draw");
                            this.buttonContainer = L.DomUtil.create("div", "leaflet-bar laji-map-control", this.container);
                            this.buttonActionContainer = {};
                            this.buttonActions = {};
                            controls.forEach(function (_a) {
                                var subName = _a.name, subIconCls = _a.iconCls, subText = _a.text, subFn = _a.fn, subFinishFn = _a.finishFn, subCancelFn = _a.cancelFn, subEventName = _a.eventName, subOnAdd = _a.onAdd, _custom = _a._custom;
                                var buttonName = getSubControlName(name, subName);
                                _this.buttonActions[buttonName] = {};
                                if (!that._controlIsAllowed(buttonName, _custom))
                                    return;
                                that._controlButtons[buttonName] = that._createControlItem(_this, _this.buttonContainer, subIconCls, subText, callback.apply(_this, [subFn, subFinishFn, subCancelFn, buttonName, subEventName]), buttonName);
                                if (subOnAdd)
                                    subOnAdd();
                            });
                            return this.container;
                        } : function () {
                        var container = L.DomUtil.create("div", "leaflet-bar leaflet-control laji-map-control");
                        that._controlButtons[name] = that._createControlItem(this, container, iconCls, text, callback.apply(this, [fn, finishFn, cancelFn, name, eventName]), name);
                        if (_onAdd)
                            _onAdd();
                        return container;
                    };
                    var noneAllowed = controls
                        && !controls.filter(function (_a) {
                            var subName = _a.name, _custom = _a._custom;
                            return that._controlIsAllowed(getSubControlName(name, subName), _custom);
                        }).length;
                    if (noneAllowed) {
                        return;
                    }
                    var Control = L.Control.extend({
                        options: position ? { position: position } : undefined,
                        onAdd: onAdd,
                        _createActionHandler: _createActionHandler,
                        _createFinishHandler: _createFinishHandler,
                        _createCancelHandler: _createCancelHandler
                    });
                    return new Control();
                })();
                if (leafletControl)
                    _this._addControl(name, leafletControl);
            });
            // Hrefs cause map to scroll to top when a control is clicked. This is fixed below.
            function removeHref(className) {
                var elems = document.getElementsByClassName(className);
                for (var i = 0; i < elems.length; i++) { // tslint:disable-line
                    var elem = elems[i];
                    elem.removeAttribute("href");
                }
            }
            ["in", "out"].forEach(function (zoomType) {
                removeHref("leaflet-control-zoom-" + zoomType);
            });
            this.getFeatureTypes().forEach(function (featureType) {
                removeHref("leaflet-draw-draw-" + featureType);
            });
            removeHref("leaflet-control-layers-toggle");
            removeHref("leaflet-contextmenu-item");
            dependency_utils_1.provide(this, "controls");
        };
        LajiMapWithControls.prototype._updateDrawControls = function () {
            if (!dependency_utils_1.depsProvided(this, "_updateDrawControls", arguments))
                return;
            this._updateMapControls();
        };
        LajiMapWithControls.prototype.updateDrawData = function (item) {
            _super.prototype.updateDrawData.call(this, item);
            if (dependency_utils_1.isProvided(this, "draw")) {
                this._updateMapControls();
            }
        };
        LajiMapWithControls.prototype._updateCustomControls = function () {
            if (!dependency_utils_1.depsProvided(this, "_updateCustomControls", arguments))
                return;
            this._updateMapControls();
        };
        LajiMapWithControls.prototype._updateLineTransectControls = function () {
            if (!dependency_utils_1.depsProvided(this, "_updateLineTransectControls", arguments))
                return;
            this._updateMapControls();
        };
        LajiMapWithControls.prototype.setControlsWarn = function (controlSettings) {
            console.warn("laji-map warning: 'controlSettings' option is deprecated and will be removed in the future. 'controlSettings' option has been renamed 'controls'"); // tslint:disable-line
            this.setControls(controlSettings);
        };
        LajiMapWithControls.prototype.setControls = function (controlSettings) {
            var _controlSettings = JSON.parse(JSON.stringify(controlSettings));
            this.controlSettings = {
                draw: {
                    marker: true,
                    circle: true,
                    rectangle: true,
                    polygon: true,
                    polyline: true,
                },
                drawUtils: {
                    copy: false,
                    upload: false,
                    clear: false,
                    reverse: false,
                    delete: false,
                    undo: true,
                    redo: true,
                    coordinateInput: true,
                },
                layer: true,
                zoom: true,
                location: true,
                geocoding: true,
                coordinates: false,
                scale: true,
                attribution: true,
                fullscreen: false,
                lineTransect: {
                    split: true,
                    splitByMeters: true,
                    deleteSegment: true,
                    deletePoints: true,
                    createPoint: true,
                    shiftPoint: true,
                    undo: true,
                    redo: true
                },
            };
            if (!_controlSettings) {
                _controlSettings = Object.keys(this.controlSettings).reduce(function (settings, key) {
                    settings[key] = false;
                    return settings;
                }, {});
            }
            if (utils_1.isObject(_controlSettings)) {
                var subControlSettings_1 = _controlSettings;
                if ("draw" in subControlSettings_1 && !utils_1.isObject(subControlSettings_1.draw)) {
                    subControlSettings_1.drawUtils = subControlSettings_1.draw;
                }
                // BW compability for drawCopy etc, which were moved under controlSettings.draw
                ["copy", "upload", "clear", "reverse", "delete", "undo", "redo", "coordinateInput"].forEach(function (name) {
                    // Internally we use 'drawUtils' namespace, but for easier API we allow using 'draw'
                    // namespace for the utils.
                    if (utils_1.isObject(subControlSettings_1.draw) && name in subControlSettings_1.draw) {
                        if (!subControlSettings_1.drawUtils)
                            subControlSettings_1.drawUtils = {};
                        subControlSettings_1.drawUtils[name] = subControlSettings_1.draw[name];
                    }
                });
                if ("coordinateInput" in subControlSettings_1) {
                    console.error("laji-map error: controls.coordinateInput is deprecated and is removed. Please use controls.draw.coordinateInput"); // tslint:disable-line
                }
                var _loop_1 = function (setting) {
                    if (!(setting in this_1.controlSettings))
                        return "continue";
                    var newSetting = subControlSettings_1[setting];
                    if (this_1.controlSettings[setting].constructor === Object) {
                        if (subControlSettings_1[setting].constructor === Object) {
                            newSetting = __assign(__assign({}, this_1.controlSettings[setting]), subControlSettings_1[setting]);
                        }
                        else {
                            newSetting = Object.keys(this_1.controlSettings[setting]).reduce(function (subSettings, subSetting) {
                                subSettings[subSetting] = subControlSettings_1[setting];
                                return subSettings;
                            }, {});
                        }
                    }
                    this_1.controlSettings[setting] = newSetting;
                };
                var this_1 = this;
                for (var setting in subControlSettings_1) {
                    _loop_1(setting);
                }
                var drawContainsCoordinateInput = (this.controlSettings.draw
                    && utils_1.isObject(this.controlSettings.draw)
                    && "coordinateInput" in this.controlSettings.draw);
                if (drawContainsCoordinateInput) {
                    if (!utils_1.isObject(this.controlSettings.drawUtils)) {
                        this.controlSettings.drawUtils = {};
                        this.controlSettings.drawUtils.coordinateInput = this.controlSettings.draw.coordinateInput;
                    }
                }
            }
            dependency_utils_1.provide(this, "controlSettings");
        };
        LajiMapWithControls.prototype.setCustomControls = function (controls) {
            if (controls === void 0) { controls = []; }
            var _a = this._customControls, _customControls = _a === void 0 ? [] : _a;
            if (_customControls.length === 0 && controls.length === 0)
                return;
            this._customControls = controls;
            dependency_utils_1.provide(this, "customControls");
        };
        LajiMapWithControls.prototype._controlIsAllowed = function (name, custom) {
            var _this = this;
            if (custom === void 0) { custom = false; }
            var controlSettings = this.controlSettings;
            var controlIsOk = function (controlName) {
                if (controlName === undefined)
                    return true;
                var _a = name.split("."), parentControl = _a[0], subControl = _a[1];
                function dependenciesAreOk(controlItem) {
                    return (controlItem.dependencies || []).every(function (dependency) {
                        return (typeof dependency === "function") ? dependency() : controlIsOk(dependency);
                    });
                }
                if (!subControl) {
                    var controlItem_1 = _this._controlItemsByName[parentControl];
                    return (custom
                        || (controlItem_1
                            && controlSettings[parentControl]
                            && dependenciesAreOk(controlItem_1)
                            && (controlItem_1.constructor !== Object || Object.keys(controlItem_1).some(function (_name) { return controlItem_1[_name]; }))));
                }
                else {
                    return (controlSettings[parentControl] === true
                        || (controlSettings[parentControl].constructor === Object && (controlSettings[parentControl][subControl] || custom)))
                        && (controlSettings[parentControl][subControl] || custom)
                        && dependenciesAreOk(_this._controlItemsByName[parentControl])
                        && dependenciesAreOk(_this._controlItemsByName[parentControl + "." + subControl]);
                }
            };
            return controlIsOk(name);
        };
        LajiMapWithControls.prototype._addControl = function (name, control) {
            if (control && this._controlIsAllowed(name) || control._custom) {
                this.map.addControl(control);
                this.controls.push(control);
            }
        };
        LajiMapWithControls.prototype._createControlButton = function (that, container, fn, name) {
            var elem = L.DomUtil.create("a", name ? "button-" + name.replace(".", "_") : "", container);
            L.DomEvent.on(elem, "click", L.DomEvent.stopPropagation);
            L.DomEvent.on(elem, "mousedown", L.DomEvent.stopPropagation);
            L.DomEvent.on(elem, "click", L.DomEvent.preventDefault);
            L.DomEvent.on(elem, "click", that._refocusOnMap, that);
            L.DomEvent.on(elem, "click", fn);
            L.DomEvent.disableClickPropagation(container);
            return elem;
        };
        LajiMapWithControls.prototype._createControlItem = function (that, container, glyphName, title, fn, name) {
            var elem = this._createControlButton(that, container, fn, name);
            L.DomUtil.create("span", glyphName, elem);
            elem.title = title;
            return elem;
        };
        LajiMapWithControls.prototype._getDrawControl = function () {
            var _this = this;
            var drawOptions = {
                position: "topright",
                edit: {
                    featureGroup: this.getDraw().group,
                    edit: false,
                    remove: false
                },
                draw: {
                    circlemarker: false
                }
            };
            drawOptions.draw = __assign(__assign({}, drawOptions.draw), this.getFeatureTypes().reduce(function (options, type) {
                options[type] = (!_this.getDraw() || _this.getDraw()[type] === false || _this.controlSettings.draw[type] === false) ?
                    false : _this._getDrawOptionsForType(type);
                return options;
            }, {}));
            this.drawControl = new L.Control.Draw(drawOptions);
            return this.drawControl;
        };
        LajiMapWithControls.prototype._getCoordinatesControl = function () {
            var that = this;
            var CoordinateControl = L.Control.extend({
                options: {
                    position: "bottomleft"
                },
                onAdd: function () {
                    var container = L.DomUtil.create("div", "leaflet-bar leaflet-control laji-map-control laji-map-coordinates-control");
                    var table = L.DomUtil.create("table", undefined, container);
                    var visible = false;
                    container.style.display = "none";
                    var coordinateTypes = [
                        { name: "WGS84" },
                        { name: "YKJ" },
                        { name: "ETRS-TM35FIN" }
                    ];
                    coordinateTypes.forEach(function (coordinateType) {
                        var row = L.DomUtil.create("tr", undefined, table);
                        coordinateType.nameCell = L.DomUtil.create("td", undefined, row);
                        coordinateType.coordsCell = L.DomUtil.create("td", undefined, row);
                    });
                    that.map.on("mousemove", function (_a) {
                        var latlng = _a.latlng;
                        if (!visible) {
                            container.style.display = "block";
                            visible = true;
                        }
                        var _b = that.wrapGeoJSONCoordinate([latlng.lng, latlng.lat]), lng = _b[0], lat = _b[1];
                        var wgs84 = [lat, lng].map(function (c) { return c.toFixed(6); });
                        var ykj, etrsTm35Fin;
                        try {
                            ykj = utils_1.convertLatLng([lat, lng], "WGS84", "EPSG:2393");
                            etrsTm35Fin = utils_1.convertLatLng([lat, lng], "WGS84", "EPSG:3067");
                        }
                        catch (e) {
                            //
                        }
                        coordinateTypes.forEach(function (_a) {
                            var name = _a.name, nameCell = _a.nameCell, coordsCell = _a.coordsCell;
                            var coords = wgs84;
                            if (name === "YKJ")
                                coords = ykj;
                            else if (name === "ETRS-TM35FIN")
                                coords = etrsTm35Fin;
                            nameCell.innerHTML = "<strong>" + name + ":</strong>";
                            var coordsFormatted = undefined;
                            if (coords)
                                switch (name) {
                                    case "WGS84":
                                        coordsFormatted = coords.join(", ");
                                        break;
                                    case "YKJ":
                                        coordsFormatted = coords.join(":");
                                        break;
                                    case "ETRS-TM35FIN":
                                        coordsFormatted = "N=" + coords[0] + " E=" + coords[1];
                                }
                            coordsCell.innerHTML = coordsFormatted || "";
                            coordsCell.className = "monospace";
                        });
                    }).on("mouseout", function () {
                        container.style.display = "none";
                        visible = false;
                    });
                    return container;
                }
            });
            return new CoordinateControl();
        };
        LajiMapWithControls.prototype._getLayerControl = function () {
            if (!this._tileLayers) {
                return;
            }
            var that = this;
            var LayerControl = L.Control.extend({
                options: L.Control.Layers.prototype.options,
                initialize: function (options) {
                    L.Util.setOptions(this, options);
                },
                onAdd: function (map) {
                    var _this = this;
                    this._map = map;
                    this.__checkDisabledLayers = function () { return _this._checkDisabledLayers(); };
                    map.on("moveend", this.__checkDisabledLayers);
                    /* Code below copied from L.Control.Layers._initLayout() with some modifications */
                    var className = "laji-map-control-layers leaflet-control-layers", container = this._container = L.DomUtil.create("div", className), collapsed = this.options.collapsed;
                    var section = this._section = L.DomUtil.create("section", className + "-list");
                    // makes this work on IE touch devices by stopping it from firing a mouseout event when the touch is released
                    container.setAttribute("aria-haspopup", "true");
                    L.DomEvent.disableClickPropagation(container);
                    L.DomEvent.disableScrollPropagation(container);
                    if (collapsed) {
                        this._map.on("click", L.Control.Layers.prototype.collapse.bind(this), this);
                        if (!L.Browser.android) {
                            L.DomEvent.on(container, {
                                mouseenter: L.Control.Layers.prototype.expand.bind(this),
                                mouseleave: L.Control.Layers.prototype.collapse.bind(this)
                            }, this);
                        }
                    }
                    var link = this._layersLink = L.DomUtil.create("a", className + "-toggle", container);
                    link.href = "#";
                    link.title = "Layers";
                    if (L.Browser.touch) {
                        L.DomEvent.on(link, "click", L.DomEvent.stop);
                        L.DomEvent.on(link, "click", L.Control.Layers.prototype.expand, this);
                    }
                    else {
                        L.DomEvent.on(link, "focus", L.Control.Layers.prototype.expand, this);
                    }
                    container.appendChild(section);
                    /* end of copy */
                    this.translateHooks = [];
                    this.elems = {};
                    this.updateLayout();
                    this._map.on("tileLayersChange", this.updateListContainers, this);
                    this._map.on("tileLayersChange", this.updateLists, this);
                    this._map.on("tileLayersChange", this.updateActiveProj, this);
                    this._map.on("projectionChange", this.updateActiveProj, this);
                    return container;
                },
                onRemove: function () {
                    this.translateHooks.forEach(function (hook) {
                        that.removeTranslationHook(hook);
                    });
                    this._map.off("tileLayersChange", this.updateListContainers);
                    this._map.off("tileLayersChange", this.updateLists);
                    this._map.off("tileLayersChange", this.updateActiveProj);
                    this._map.off("projectionChange", this.updateActiveProj);
                    this._map.off("moveend", this.__checkDisabledLayers);
                },
                createListItem: function (name, layerOptions, available) {
                    var li = document.createElement("li");
                    var checkbox = document.createElement("input");
                    checkbox.type = "checkbox";
                    checkbox.addEventListener("change", function (e) {
                        var _a;
                        var layers = that._tileLayers.layers;
                        var _layerOptions = layers[name];
                        var _layer = __assign(__assign({}, that.tileLayers), that.overlaysByNames)[name];
                        that.setTileLayers(__assign(__assign({}, that._tileLayers), { active: that.finnishTileLayers[name]
                                ? "finnish"
                                : that.worldTileLayers[name]
                                    ? "world"
                                    : that._tileLayers.active, layers: __assign(__assign({}, layers), (_a = {}, _a[name] = __assign(__assign({}, _layerOptions), { visible: !_layerOptions.visible, opacity: !_layerOptions.visible && !_layerOptions.opacity
                                    ? (_layer.options.defaultOpacity || 1)
                                    : _layerOptions.opacity }), _a)) }));
                    });
                    var label = document.createElement("span");
                    this.translateHooks.push(that.addTranslationHook(label, utils_1.capitalizeFirstLetter(name)));
                    li.appendChild(label);
                    var checkboxContainer = document.createElement("div");
                    checkboxContainer.appendChild(checkbox);
                    li.appendChild(checkboxContainer);
                    var sliderInput = document.createElement("div");
                    li.appendChild(sliderInput);
                    var slider = noUiSlider.create(sliderInput, {
                        start: (that._tileLayers.layers[name] || { opacity: 0 }).opacity,
                        range: {
                            min: [0],
                            max: [1]
                        },
                        step: 0.01,
                        connect: [true, false],
                        behaviour: "snap"
                    });
                    var firstUpdated = false;
                    slider.on("update", function () {
                        var _a;
                        if (!firstUpdated) {
                            firstUpdated = true;
                            return;
                        }
                        if (that._internalTileLayersUpdate)
                            return;
                        var opacity = +slider.get();
                        var layers = that._tileLayers.layers;
                        var _layerOptions = layers[name];
                        var active = that.finnishTileLayers[name]
                            ? "finnish"
                            : that.worldTileLayers[name]
                                ? "world"
                                : that._tileLayers.active;
                        var prevActive = that._tileLayers.active || "finnish";
                        if (!_layerOptions.visible || active !== prevActive) {
                            that.setTileLayers(__assign(__assign({}, that._tileLayers), { active: active, layers: __assign(__assign({}, layers), (_a = {}, _a[name] = __assign(__assign({}, _layerOptions), { visible: true, opacity: opacity }), _a)) }));
                        }
                        else {
                            that._tileLayers.layers[name] = __assign(__assign({}, _layerOptions), { visible: true, opacity: opacity });
                            (that.tileLayers[name] || that.overlaysByNames[name]).setOpacity(opacity);
                        }
                    });
                    function disableSelect(e) {
                        e.preventDefault();
                    }
                    slider.on("start", function () {
                        document.addEventListener("selectstart", disableSelect);
                    });
                    slider.on("end", function () {
                        var _a;
                        document.removeEventListener("selectstart", disableSelect);
                        var opacity = +slider.get();
                        var layers = that._tileLayers.layers;
                        var _layerOptions = layers[name];
                        if (!opacity && _layerOptions.visible) {
                            that.setTileLayers(__assign(__assign({}, that._tileLayers), { layers: __assign(__assign({}, layers), (_a = {}, _a[name] = __assign(__assign({}, _layerOptions), { visible: false }), _a)) }));
                        }
                    });
                    this.elems[name] = { li: li, slider: slider, checkbox: checkbox };
                    if (!available) {
                        li.style.display = "none";
                    }
                    return li;
                },
                createList: function (tileLayers, availableLayers, label, className) {
                    var _this = this;
                    if (Object.keys(availableLayers).length === 0) {
                        return [undefined, undefined];
                    }
                    var list = document.createElement("fieldset");
                    className && L.DomUtil.addClass(list, className);
                    var innerList = document.createElement("ul");
                    var legend = document.createElement("legend");
                    var translationHook = that.addTranslationHook(legend, utils_1.capitalizeFirstLetter(label));
                    this.translateHooks.push(translationHook);
                    list.appendChild(legend);
                    list.appendChild(innerList);
                    Object.keys(tileLayers).sort(function (a, b) { return that._tileLayerOrder.indexOf(a) - that._tileLayerOrder.indexOf(b); }).forEach(function (name) {
                        innerList.appendChild(_this.createListItem(name, that._tileLayers.layers[name], availableLayers[name]));
                    });
                    this.layers = __assign(__assign({}, (this.layers || {})), tileLayers);
                    return [list, translationHook];
                },
                getFinnishList: function (createNew) {
                    if (createNew === void 0) { createNew = false; }
                    var availableLayers = that.getAvailableFinnishTileLayers();
                    if (Object.keys(availableLayers).length === 0) {
                        this.finnishList = undefined;
                        return [undefined, undefined];
                    }
                    if (this.finnishList) {
                        return [this.finnishList, this.finnishTranslationHook];
                    }
                    var _a = this.createList(that.finnishTileLayers, availableLayers, that._tileLayers.active === "finnish" ? "FinnishMaps" : "ActivateFinnishMaps", "finnish-list"), finnishList = _a[0], finnishTranslationHook = _a[1];
                    this.finnishList = finnishList;
                    this.finnishTranslationHook = finnishTranslationHook;
                    if (finnishList) {
                        if (this.worldList) {
                            this._section.insertBefore(finnishList, this.worldList);
                        }
                        else if (this.overlayList) {
                            this._section.insertBefore(finnishList, this.overlayList);
                        }
                        else {
                            this._section.appendChild(finnishList);
                        }
                    }
                    return [this.finnishList, this.finnishTranslationHook];
                },
                getWorldList: function () {
                    var availableLayers = that.getAvailableWorldTileLayers();
                    if (Object.keys(availableLayers).length === 0) {
                        this.worldList = undefined;
                        return [undefined, undefined];
                    }
                    if (this.worldList) {
                        return [this.worldList, this.worldTranslationHook];
                    }
                    var _a = this.createList(that.worldTileLayers, availableLayers, that._tileLayers.active === "world" ? "WorldMaps" : "ActivateWorldMaps", "world-list"), worldList = _a[0], worldTranslationHook = _a[1];
                    this.worldList = worldList;
                    this.worldTranslationHook = worldTranslationHook;
                    if (worldList) {
                        if (this.overlayList) {
                            this._section.insertBefore(worldList, this.overlayList);
                        }
                        else {
                            this._section.appendChild(worldList);
                        }
                    }
                    return [this.worldList, this.worldTranslationHook];
                },
                getOverlayList: function () {
                    var availableLayers = that.getAvailableOverlaysByNames();
                    if (Object.keys(availableLayers).length === 0) {
                        this.overlayList = undefined;
                        return undefined;
                    }
                    if (this.overlayList) {
                        return this.overlayList;
                    }
                    var overlayList = this.createList(that.overlaysByNames, that.getAvailableOverlaysByNames(), "Overlays", "overlay-list")[0];
                    this.overlayList = overlayList;
                    if (overlayList) {
                        this._section.appendChild(overlayList);
                    }
                },
                updateLayout: function () {
                    this.updateListContainers();
                    this.updateActiveProj();
                    this.updateLists();
                },
                updateActiveProj: function () {
                    var _this = this;
                    var activeProjName = that.activeProjName;
                    var lists = [this.finnishList, this.worldList];
                    var _a = activeProjName === "finnish"
                        ? lists
                        : lists.reverse(), activeList = _a[0], nonActiveList = _a[1];
                    if (activeList) {
                        L.DomUtil.addClass(activeList, "active-list");
                        L.DomUtil.removeClass(activeList, "nonactive-list");
                        activeList.querySelector("legend").tabIndex = 0;
                        if (!nonActiveList) {
                            L.DomUtil.addClass(activeList, "only-list");
                        }
                        else {
                            L.DomUtil.removeClass(activeList, "only-list");
                        }
                    }
                    if (nonActiveList) {
                        L.DomUtil.addClass(nonActiveList, "nonactive-list");
                        L.DomUtil.removeClass(nonActiveList, "active-list");
                        nonActiveList.querySelector("legend").tabIndex = 0;
                    }
                    this.translateHooks = this.translateHooks.filter(function (hook) { return hook !== _this.finnishTranslationHook && hook !== _this.worldTranslationHook; });
                    if (this.finnishList) {
                        this.finnishTranslationHook = that.addTranslationHook(this.finnishList.querySelector("legend"), !this.worldList
                            ? "Maps"
                            : activeProjName === "finnish"
                                ? "FinnishMaps"
                                : this._finnishDisabled
                                    ? "FinnishMapDisabledOutsideFinland"
                                    : "ActivateFinnishMaps");
                    }
                    if (this.worldList) {
                        this.worldTranslationHook = that.addTranslationHook(this.worldList.querySelector("legend"), !this.finnishList
                            ? "Maps"
                            : activeProjName === "world"
                                ? "WorldMaps"
                                : "ActivateWorldMaps");
                        this.translateHooks.push(this.finnishTranslationHook, this.worldTranslationHook);
                    }
                },
                updateListContainers: function () {
                    var _this = this;
                    var oldFinnish = this.finnishList;
                    var oldWorld = this.worldList;
                    var oldOverlayList = this.overlayList;
                    var finnishList = this.getFinnishList()[0];
                    var worldList = this.getWorldList()[0];
                    var overlayList = this.getOverlayList();
                    var lists = [
                        [oldFinnish, finnishList, "finnish"],
                        [oldWorld, worldList, "world"]
                    ];
                    __spreadArrays(lists, [[oldOverlayList, overlayList]]).forEach(function (_a) {
                        var oldList = _a[0], list = _a[1];
                        if (oldList && !list) {
                            oldList.parentElement.removeChild(oldList);
                        }
                    });
                    lists.filter(function (_a) {
                        var oldList = _a[0], list = _a[1];
                        return !oldList && list;
                    }).forEach(function (_a) {
                        var oldList = _a[0], list = _a[1], active = _a[2];
                        list.querySelector("legend").addEventListener("click", function (_a) {
                            var tagName = _a.target.tagName;
                            if (_this._finnishDisabled) {
                                return;
                            }
                            if (active === that._tileLayers.active) {
                                if (finnishList && active === "finnish") {
                                    active = "world";
                                }
                                else if (worldList && active === "world") {
                                    active = "finnish";
                                }
                            }
                            var worldLayers = that.getAvailableWorldTileLayers();
                            var finnishLayers = that.getAvailableFinnishTileLayers();
                            var checkLayer = function (name) { return !that._tileLayers.layers[name].visible; };
                            var ensureHasLayersIfProjChanged = function (_active, layers) {
                                var _a;
                                return active === _active
                                    && Object.keys(layers).every(checkLayer)
                                    && __assign(__assign({}, that._tileLayers.layers), (_a = {}, _a[that._tileLayerOrder.find(function (l) { return layers[l]; })] = true, _a));
                            };
                            var layerOptions = ensureHasLayersIfProjChanged("world", worldLayers)
                                || ensureHasLayersIfProjChanged("finnish", finnishLayers)
                                || that._tileLayers.layers;
                            that.setTileLayers(__assign(__assign({}, that._tileLayers), { active: active, layers: layerOptions }));
                        });
                    });
                },
                updateLists: function () {
                    var _this = this;
                    Object.keys(__assign(__assign({}, that.tileLayers), that.overlaysByNames)).forEach(function (name) {
                        var available = that._tileLayers.layers[name];
                        if (!_this.elems[name])
                            return;
                        _this.elems[name].li.style.display = available ? "block" : "none";
                        if (!available)
                            return;
                        var _a = that._tileLayers.layers[name], opacity = _a.opacity, visible = _a.visible;
                        var _b = _this.elems[name], slider = _b.slider, checkbox = _b.checkbox, li = _b.li;
                        that._internalTileLayersUpdate = true;
                        li.className = visible ? "active" : "";
                        slider.set(opacity);
                        that._internalTileLayersUpdate = false;
                        checkbox.checked = visible;
                    });
                },
                _checkDisabledLayers: function () {
                    var _this = this;
                    var latLng = this._map.getCenter();
                    if (!this.finnishList) {
                        return;
                    }
                    if (that._isOutsideFinland(latLng) && !this._finnishDisabled) {
                        this._finnishDisabled = true;
                        L.DomUtil.addClass(this.finnishList.querySelector("legend"), "disabled");
                        this.worldList && L.DomUtil.addClass(this.worldList.querySelector("legend"), "disabled");
                        this.translateHooks = this.translateHooks.filter(function (h) { return h !== _this.finnishTranslationHook; });
                        this.finnishTranslationHook = that.addTranslationHook(this.finnishList.querySelector("legend"), "FinnishMapDisabledOutsideFinland");
                        this.translateHooks.push(this.finnishTranslationHook);
                    }
                    else if (!that._isOutsideFinland(latLng) && this._finnishDisabled) {
                        this._finnishDisabled = false;
                        L.DomUtil.removeClass(this.finnishList.querySelector("legend"), "disabled");
                        this.worldList && L.DomUtil.removeClass(this.worldList.querySelector("legend"), "disabled");
                        this.translateHooks = this.translateHooks.filter(function (h) { return h !== _this.finnishTranslationHook; });
                        this.finnishTranslationHook = that.addTranslationHook(this.finnishList.querySelector("legend"), that.activeProjName === "finnish" ? "FinnishMaps" : "ActivateFinnishMaps");
                        this.translateHooks.push(this.finnishTranslationHook);
                    }
                }
            });
            return new LayerControl({ position: "topleft" });
        };
        LajiMapWithControls.prototype.getZoomControl = function () {
            var that = this;
            var ZoomControl = L.Control.Zoom.extend({
                onZoomClick: function () {
                    that.map.fire("controlClick", { name: "zoom" });
                },
                onAdd: function (map) {
                    var container = L.Control.Zoom.prototype.onAdd.call(this, map);
                    L.DomEvent.disableClickPropagation(container);
                    this._zoomInButton.addEventListener("click", this.onZoomClick);
                    this._zoomOutButton.addEventListener("click", this.onZoomClick);
                    return container;
                },
                onRemove: function (map) {
                    L.Control.Zoom.prototype.onRemove.call(this, map);
                    this._zoomInButton.removeEventListener("click", this.onZoomClick);
                    this._zoomOutButton.removeEventListener("click", this.onZoomClick);
                }
            });
            return new ZoomControl({
                zoomInTitle: this.translations.ZoomIn,
                zoomOutTitle: this.translations.ZoomOut
            });
        };
        LajiMapWithControls.prototype.setTileLayerOpacity = function (opacity, triggerEvent) {
            _super.prototype.setTileLayerOpacity.call(this, opacity, triggerEvent);
            if (!this._opacitySetBySlide && this._slider) {
                this._slider.set(opacity);
            }
            this._opacitySetBySlide = false;
        };
        LajiMapWithControls.prototype.setLineTransectGeometry = function (feature, undo) {
            _super.prototype.setLineTransectGeometry.call(this, feature, undo);
            this.updateLTUndoButton();
            this.updateLTRedoButton();
        };
        LajiMapWithControls.prototype.resetDrawUndoStack = function () {
            _super.prototype.resetDrawUndoStack.call(this);
            this.updateDrawUndoButton();
            this.updateDrawRedoButton();
        };
        LajiMapWithControls.prototype._updateDrawUndoStack = function (events, prevFeatureCollection, prevActiveIdx) {
            _super.prototype._updateDrawUndoStack.call(this, events, prevFeatureCollection, prevActiveIdx);
            this.updateDrawUndoButton();
            this.updateDrawRedoButton();
        };
        LajiMapWithControls.prototype.drawUndo = function () {
            _super.prototype.drawUndo.call(this);
            this.updateDrawUndoButton();
            this.updateDrawRedoButton();
        };
        LajiMapWithControls.prototype.drawRedo = function () {
            _super.prototype.drawRedo.call(this);
            this.updateDrawUndoButton();
            this.updateDrawRedoButton();
        };
        LajiMapWithControls.prototype._updateUndoButton = function (buttonName, history, historyPointer) {
            var undoButton = this._controlButtons && this._controlButtons[buttonName];
            if (!undoButton)
                return;
            if (historyPointer <= 0 && undoButton.className.indexOf("leaflet-disabled") === -1) {
                undoButton.className += " leaflet-disabled";
            }
            else if (historyPointer > 0
                && historyPointer < history.length
                && undoButton.className.indexOf("leaflet-disabled") !== -1) {
                undoButton.className = undoButton.className.replace(" leaflet-disabled", "");
            }
            if (this._contextMenuItems) {
                var contextMenuItem = this._contextMenuItems[buttonName];
                if (contextMenuItem)
                    this.map.contextmenu.setDisabled(contextMenuItem, historyPointer <= 0);
            }
        };
        LajiMapWithControls.prototype._updateRedoButton = function (buttonName, history, historyPointer) {
            var redoButton = this._controlButtons && this._controlButtons[buttonName];
            if (!redoButton)
                return;
            if (historyPointer >= history.length - 1 && redoButton.className.indexOf("leaflet-disabled") === -1) {
                redoButton.className += " leaflet-disabled";
            }
            else if (historyPointer >= 0
                && historyPointer < history.length - 1
                && redoButton.className.indexOf("leaflet-disabled") !== -1) {
                redoButton.className = redoButton.className.replace(" leaflet-disabled", "");
            }
            if (this._contextMenuItems) {
                var contextMenuItem = this._contextMenuItems[buttonName];
                if (contextMenuItem)
                    this.map.contextmenu.setDisabled(contextMenuItem, historyPointer >= history.length - 1);
            }
        };
        LajiMapWithControls.prototype.updateLTUndoButton = function () {
            if (!dependency_utils_1.depsProvided(this, "updateLTUndoButton", arguments))
                return;
            this._updateUndoButton("lineTransect.undo", this._LTHistory, this._LTHistoryPointer);
        };
        LajiMapWithControls.prototype.updateLTRedoButton = function () {
            if (!dependency_utils_1.depsProvided(this, "updateLTRedoButton", arguments))
                return;
            this._updateRedoButton("lineTransect.redo", this._LTHistory, this._LTHistoryPointer);
        };
        LajiMapWithControls.prototype.updateDrawUndoButton = function () {
            if (!dependency_utils_1.depsProvided(this, "updateDrawUndoButton", arguments))
                return;
            this._updateUndoButton("drawUtils.undo", this._drawHistory, this._drawHistoryPointer);
        };
        LajiMapWithControls.prototype.updateDrawRedoButton = function () {
            if (!dependency_utils_1.depsProvided(this, "updateDrawRedoButton", arguments))
                return;
            this._updateRedoButton("drawUtils.redo", this._drawHistory, this._drawHistoryPointer);
        };
        LajiMapWithControls.prototype.openCoordinatesInputDialog = function () {
            var _this = this;
            var that = this;
            var translateHooks = [];
            function createCoordinateInput(id, translationKey) {
                var input = utils_1.createTextInput();
                input.id = "laji-map-" + id;
                var label = document.createElement("label");
                label.setAttribute("for", input.id);
                translateHooks.push(that.addTranslationHook(label, translationKey));
                var row = document.createElement("div");
                row.className = "form-group row";
                var col = document.createElement("div");
                col.className = "col-xs-12";
                [label, input].forEach(function (elem) { return col.appendChild(elem); });
                row.appendChild(col);
                return row;
            }
            function formatter(input) {
                return function (e) {
                    var charCode = (typeof e.which === "undefined") ? e.keyCode : e.which;
                    if (charCode >= 48 && charCode <= 57) { // Is a number
                        // The input cursor isn't necessary at the EOL, but this validation works regardless.
                        inputValidate(e, input.value + String.fromCharCode(charCode));
                    }
                    else if (charCode === 58) { // is colon
                        lngInput.focus();
                        lngInput.select();
                    }
                };
            }
            var inputRegexp = that.getDraw().marker ? /^(-?[0-9]+(\.|,)?[0-9]*|-?)$/ : /^[0-9]*$/;
            function inputValidate(e, value) {
                if (!value.match(inputRegexp)) {
                    e && e.preventDefault && e.preventDefault();
                    return false;
                }
                return true;
            }
            var container = document.createElement("form");
            container.className = "laji-map-coordinates";
            var latLabelInput = createCoordinateInput("coordinate-input-lat", "Latitude");
            var lngLabelInput = createCoordinateInput("coordinate-input-lng", "Longitude");
            var latInput = latLabelInput.getElementsByTagName("input")[0];
            var lngInput = lngLabelInput.getElementsByTagName("input")[0];
            var submitButton = document.createElement("button");
            submitButton.setAttribute("type", "submit");
            submitButton.className = "btn btn-block btn-primary";
            translateHooks.push(this.addTranslationHook(submitButton, "Add"));
            submitButton.setAttribute("disabled", "disabled");
            var helpSpan = document.createElement("span");
            helpSpan.className = "help-block";
            function getHelpTxt() {
                var help = that.translations.Enter + " " + that.translations.yKJRectangle;
                var rectangleAllowed = that.getDraw().rectangle || that.getDraw().polygon;
                var or = that.translations.or;
                help += (rectangleAllowed && !that.getDraw().marker ? " " + or + " " : ", ") + that.translations.ETRSRectangle;
                if (that.getDraw().marker) {
                    help += " " + or + " " + (rectangleAllowed ? that.translations.wGS84PointCoordinates : that.translations.WGS84Coordinates); // tslint:disable-line
                }
                help += ".";
                return help;
            }
            translateHooks.push(this.addTranslationHook(helpSpan, getHelpTxt));
            var _a = this.createFormatDetectorElem({ displayFormat: false, displayErrors: false, allowGrid: that.getDraw().rectangle || that.getDraw().polygon }), validate = _a.validate, formatDetectorElem = _a.elem, unmountFormatDetector = _a.unmount;
            var inputValues = ["", ""];
            [latInput, lngInput].forEach(function (input, i) {
                var prevVal = "";
                input.addEventListener("keypress", formatter(input));
                input.onpaste = function (e) {
                    var matches = (e.clipboardData || window.clipboardData).getData("text")
                        .match(/-?[0-9]+((\.|,)?[0-9]+)/g) || ["", ""];
                    var _a = document.activeElement === lngInput
                        ? matches.reverse()
                        : matches, latMatch = _a[0], lngMatch = _a[1];
                    if ([latMatch, lngMatch].every(function (match) { return typeof match === "string" && match.length > 0; })) {
                        [[latInput, latMatch], [lngInput, lngMatch]].forEach(function (_a) {
                            var _input = _a[0], match = _a[1];
                            _input.value = match;
                            _input.oninput({ target: _input });
                        });
                        submitButton.focus();
                    }
                };
                input.oninput = function (e) {
                    var target = e.target;
                    var value = target.value.replace(",", ".").trim();
                    if (!inputValidate(e, value)) {
                        target.value = prevVal;
                    }
                    target.value = value;
                    prevVal = value;
                    inputValues[i] = value;
                    var _a = validate(inputValues[0] + ":" + inputValues[1] + "/"), valid = _a.valid, geoJSON = _a.geoJSON;
                    if (valid) {
                        submitButton.removeAttribute("disabled");
                    }
                    else {
                        submitButton.setAttribute("disabled", "disabled");
                    }
                };
            });
            function convert(coords, crs) {
                if (crs === void 0) { crs = "EPSG:2393"; }
                return utils_1.convertLatLng(coords, crs, "WGS84");
            }
            container.addEventListener("submit", function (e) {
                e.preventDefault();
                var latlngStr = [latInput.value, lngInput.value];
                var latlng = latlngStr.map(parseFloat);
                var isWGS84Coordinates = utils_1.validateLatLng(latlngStr, utils_1.wgs84Validator);
                var isETRS = utils_1.validateLatLng(latlngStr, utils_1.etrsTm35FinValidator);
                var isYKJ = utils_1.validateLatLng(latlngStr, utils_1.ykjValidator);
                var isYKJGrid = latlngStr[0].length === latlngStr[1].length && utils_1.validateLatLng(latlngStr, utils_1.ykjGridStrictValidator);
                var isETRSGrid = latlngStr[0].length === latlngStr[1].length && utils_1.validateLatLng(latlngStr, utils_1.etrsTm35FinGridStrictValidator);
                var geometry = {
                    type: "Point",
                    coordinates: ((isYKJ)
                        ? convert(latlng, "EPSG:2393")
                        : (isETRS)
                            ? convert(latlng, "EPSG:3067")
                            : (isWGS84Coordinates)
                                ? latlng
                                : []).reverse()
                };
                var feature = {
                    type: "Feature",
                    geometry: geometry,
                    properties: {}
                };
                if (isYKJGrid || isETRSGrid) {
                    var validator = isYKJGrid ? utils_1.ykjGridStrictValidator : utils_1.etrsTm35FinGridStrictValidator;
                    var latStart = +validator[0].formatter("" + latlng[0]);
                    var latEnd = +validator[0].formatter("" + (latlng[0] + 1));
                    var lngStart = +validator[1].formatter("" + latlng[1]);
                    var lngEnd = +validator[1].formatter("" + (latlng[1] + 1));
                    geometry.type = "Polygon";
                    geometry.coordinates = [[
                            [latStart, lngStart],
                            [latStart, lngEnd],
                            [latEnd, lngEnd],
                            [latEnd, lngStart],
                            [latStart, lngStart]
                        ].map(function (coordinatePair) { return utils_1.reverseCoordinate(convert(coordinatePair, isYKJGrid ? "EPSG:2393" : "EPSG:3067")); })];
                }
                var layer = _this._featureToLayer(_this.getDraw().getFeatureStyle)(feature);
                var isMarker = layer instanceof L.Marker;
                _this._onAdd(_this.drawIdx, layer, latInput.value + ":" + lngInput.value);
                var center = (isMarker) ? layer.getLatLng() : layer.getBounds().getCenter();
                _this.map.setView(center, _this.map.getZoom(), { animate: false });
                if (isMarker) {
                    if (_this.getDraw().cluster)
                        _this.getDraw().groupContainer.zoomToShowLayer(layer);
                    else
                        _this.setNormalizedZoom(9);
                }
                else {
                    _this.map.fitBounds(layer.getBounds());
                }
                _this._closeDialog(e);
            });
            container.appendChild(helpSpan);
            container.appendChild(latLabelInput);
            container.appendChild(lngLabelInput);
            container.appendChild(formatDetectorElem);
            container.appendChild(submitButton);
            this._showDialog(container, function () {
                translateHooks.forEach(function (hook) {
                    that.removeTranslationHook(hook);
                });
                unmountFormatDetector();
            });
            latInput.focus();
        };
        LajiMapWithControls.prototype.openDrawCopyDialog = function () {
            var _this = this;
            var table = document.createElement("table");
            table.className = "laji-map-draw-copy-table";
            var HTMLInput = utils_1.createTextArea(10, 50);
            HTMLInput.setAttribute("readonly", "readonly");
            HTMLInput.addEventListener("focus", HTMLInput.select);
            var features = this.getDraw().featureCollection.features.map(function (f) { return _this.formatFeatureOut(f); });
            var originalGeoJSON = __assign(__assign({}, this.getDraw().featureCollection), { features: features });
            var converterFor = function (proj) { return function (input) {
                var reprojected = utils_1.convertGeoJSON(input, "WGS84", proj);
                reprojected.crs = utils_1.getCRSObjectForGeoJSON(reprojected, proj);
                return reprojected;
            }; };
            var TOP = "TOP";
            var LEFT = "LEFT";
            var pipeline = [
                {
                    commands: {
                        "WGS84": utils_1.standardizeGeoJSON,
                        "YKJ": function (input) { return converterFor("EPSG:2393")(utils_1.standardizeGeoJSON(input)); },
                        "ETRS-TM35FIN": function (input) { return converterFor("EPSG:3067")(utils_1.standardizeGeoJSON(input)); }
                    },
                    position: TOP
                },
                {
                    commands: {
                        "GeoJSON": function (input) { return JSON.stringify(input, undefined, 2); },
                        "ISO 6709": utils_1.geoJSONToISO6709,
                        "WKT": utils_1.geoJSONToWKT
                    },
                    position: LEFT
                }
            ];
            var activeCommands = pipeline.map(function (_a) {
                var commands = _a.commands;
                return Object.keys(commands)[0];
            });
            var leftTabs = [];
            var topTabs = [];
            pipeline.forEach(function (_a, idx) {
                var commands = _a.commands, position = _a.position;
                var activeTab = undefined;
                function setActiveTab(tab, label) {
                    if (activeTab) {
                        activeTab.className = "";
                    }
                    activeTab = tab;
                    activeTab.className = "active";
                    activeCommands[idx] = label;
                }
                var tabs = document.createElement("ul");
                var tabContainer = (position === LEFT) ? (function () {
                    var _tabContainer = document.createElement("div");
                    _tabContainer.className = "tabs-left";
                    _tabContainer.appendChild(tabs);
                    return _tabContainer;
                })() : tabs;
                tabs.className = "nav nav-tabs";
                Object.keys(commands).map(function (label, _idx) {
                    var tab = document.createElement("li");
                    var text = document.createElement("a");
                    if (_idx === 0) {
                        setActiveTab(tab, label);
                    }
                    text.innerHTML = label;
                    tab.appendChild(text);
                    tab.addEventListener("click", function () {
                        var scrollTop = HTMLInput.scrollTop, scrollLeft = HTMLInput.scrollLeft;
                        setActiveTab(tab, label);
                        updateOutput();
                        HTMLInput.scrollTop = scrollTop;
                        HTMLInput.scrollLeft = scrollLeft;
                    });
                    return tab;
                }).forEach(function (tab) { return tabs.appendChild(tab); });
                var tabsArr = topTabs;
                if (position === LEFT)
                    tabsArr = leftTabs;
                tabsArr.push(tabContainer);
            });
            function updateOutput() {
                HTMLInput.value = pipeline.reduce(function (_output, _a, idx) {
                    var commands = _a.commands;
                    return commands[activeCommands[idx]](_output);
                }, originalGeoJSON);
                HTMLInput.focus();
                HTMLInput.select();
            }
            var rows = [
                [undefined, topTabs],
                [leftTabs, HTMLInput]
            ];
            var tBody = document.createElement("tbody");
            rows.forEach(function (row) {
                var tr = document.createElement("tr");
                row.forEach(function (items) { return (Array.isArray(items) ? items : [items])
                    .forEach(function (elem) {
                    var td = document.createElement("td");
                    td.appendChild(elem || document.createElement("div"));
                    tr.appendChild(td);
                }); });
                tBody.appendChild(tr);
            });
            table.appendChild(tBody);
            this._showDialog(table);
            updateOutput();
        };
        LajiMapWithControls.prototype.createFormatDetectorElem = function (options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            var _container = document.createElement("div");
            var formatContainer = document.createElement("div");
            var crsContainer = document.createElement("div");
            var formatInfo = document.createElement("span");
            var crsInfo = document.createElement("span");
            var formatValue = document.createElement("span");
            var crsValue = document.createElement("span");
            var geoJSONErrorsContainer = document.createElement("ul");
            var geoJSONWarningsContainer = document.createElement("ul");
            formatContainer.className = "form-group text-success format-info";
            crsContainer.className = "form-group text-success crs-info";
            geoJSONErrorsContainer.className = "geojson-validations";
            geoJSONWarningsContainer.className = "geojson-validations";
            _container.appendChild(formatContainer);
            _container.appendChild(crsContainer);
            _container.appendChild(geoJSONErrorsContainer);
            _container.appendChild(geoJSONWarningsContainer);
            formatContainer.appendChild(formatInfo);
            formatContainer.appendChild(formatValue);
            crsContainer.appendChild(crsInfo);
            crsContainer.appendChild(crsValue);
            var alert = undefined;
            var _a = options.displayFormat, displayFormat = _a === void 0 ? true : _a, _b = options.displayErrors, displayErrors = _b === void 0 ? true : _b, _c = options.allowGrid, allowGrid = _c === void 0 ? false : _c;
            var storedValue = "";
            var updateInfo = function (value) {
                if (value === void 0) { value = ""; }
                storedValue = value;
                var format, crs, valid, hasErrors, hasWarnings, fixedGeoJSON;
                formatInfo.innerHTML = _this.translations.DetectedFormat + ": ";
                crsInfo.innerHTML = _this.translations.DetectedCRS + ": ";
                [geoJSONWarningsContainer, geoJSONErrorsContainer].forEach(function (container) {
                    container.style.display = "none";
                    while (container.firstChild) {
                        container.removeChild(container.firstChild);
                    }
                });
                if (alert) {
                    _container.removeChild(alert);
                    alert = undefined;
                }
                try {
                    format = utils_1.detectFormat(value);
                    crs = utils_1.detectCRS(value, allowGrid);
                    if (crs === globals_1.EPSG2393String || crs === globals_1.EPSG2393WKTString) {
                        crs = "EPSG:2393";
                    }
                    else if (crs === globals_1.EPSG3067String || crs === globals_1.EPSG3067WKTString) {
                        crs = "EPSG:3067";
                    }
                    valid = utils_1.convertAnyToWGS84GeoJSON(value, !!"validate all");
                }
                catch (e) {
                    var addError = function (msg) {
                        if (!displayErrors) {
                            return;
                        }
                        alert = document.createElement("div");
                        alert.className = "alert alert-danger";
                        alert.innerHTML = msg;
                        _container.appendChild(alert);
                    };
                    if (e._lajiMapError) {
                        if (e.translationKey !== "GeoDataFormatDetectionError") {
                            addError(e.stringify(_this.translations));
                        }
                    }
                    else if (displayErrors && e._lajiMapGeoJSONConversionError) {
                        fixedGeoJSON = e.geoJSON;
                        e.errors.forEach(function (_e) {
                            var translationKey = _e.translationKey, fixable = _e.fixable, path = _e.path;
                            var target = fixable ? geoJSONWarningsContainer : geoJSONErrorsContainer;
                            var firstWarning = fixable && !hasWarnings;
                            if (fixable) {
                                hasWarnings = true;
                            }
                            else {
                                hasErrors = true;
                            }
                            if (format !== "GeoJSON") {
                                _e.path = undefined;
                            }
                            var errorElem = utils_1.renderLajiMapError(_e, _this.translations, "li");
                            errorElem.className = fixable ? "alert alert-warning" : "alert alert-danger";
                            if (firstWarning) {
                                var warningContainer = document.createElement("li");
                                var warningTitle = document.createElement("span");
                                warningTitle.innerHTML = _this.translations.GeoJSONUploadWarningsTitle;
                                warningTitle.className = "form-group text-warning warning-title";
                                warningContainer.appendChild(warningTitle);
                                target.appendChild(warningContainer);
                            }
                            target.appendChild(errorElem);
                        });
                        if (!hasErrors && geoJSONWarningsContainer.style.display === "none") {
                            geoJSONWarningsContainer.style.display = "block";
                        }
                        if (hasErrors && geoJSONErrorsContainer.style.display === "none") {
                            geoJSONErrorsContainer.style.display = "block";
                        }
                    }
                    else {
                        addError(_this.translations.UnknownConversionError);
                    }
                }
                finally {
                    if (displayFormat && format) {
                        formatContainer.style.display = "block";
                    }
                    else {
                        formatContainer.style.display = "none";
                    }
                    if (crs && _this.translations[crs]) {
                        crsContainer.style.display = "block";
                    }
                    else {
                        crsContainer.style.display = "none";
                    }
                    formatValue.innerHTML = format;
                    if (!hasErrors && hasWarnings) {
                        valid = utils_1.convertAnyToWGS84GeoJSON(fixedGeoJSON);
                    }
                    if (_this.translations[crs]) {
                        crsValue.innerHTML = _this.translations[crs];
                    }
                }
                return { valid: !!(format && crs && allowGrid || valid), geoJSON: valid };
            };
            updateInfo();
            this.addTranslationHook(function () { return updateInfo(storedValue); });
            var unmount = function () {
                _this.removeTranslationHook(updateInfo);
            };
            return { elem: _container, validate: updateInfo, unmount: unmount };
        };
        LajiMapWithControls.prototype.openDrawUploadDialog = function () {
            var _this = this;
            var container = document.createElement("form");
            container.className = "laji-map-coordinate-upload";
            var textarea = utils_1.createTextArea(10, 50);
            textarea.className += " form-group";
            var button = document.createElement("button");
            button.setAttribute("type", "submit");
            button.className = "btn btn-block btn-primary";
            var translationsHooks = [];
            translationsHooks.push(this.addTranslationHook(button, "UploadDrawnFeatures"));
            button.setAttribute("disabled", "disabled");
            var _a = this.createFormatDetectorElem(), formatDetectorElem = _a.elem, validate = _a.validate, unmountFormatDetector = _a.unmount;
            var fixedGeoJSON = undefined;
            textarea.oninput = function (e) {
                var value = e.target.value;
                var _a = validate(value), valid = _a.valid, geoJSON = _a.geoJSON;
                fixedGeoJSON = geoJSON;
                if (valid) {
                    button.removeAttribute("disabled");
                    if (alert) {
                        container.removeChild(alert);
                        alert = undefined;
                    }
                }
                else {
                    button.setAttribute("disabled", "disabled");
                }
                if (container.className.indexOf(" has-error") !== -1) {
                    container.className = container.className.replace(" has-error", "");
                }
            };
            var alert = undefined;
            var alertTranslationHook = undefined;
            var updateAlert = function (error) {
                if (alert)
                    container.removeChild(alert);
                alert = document.createElement("div");
                alert.className = "alert alert-danger";
                if (alertTranslationHook)
                    _this.removeTranslationHook(alertTranslationHook);
                alertTranslationHook = _this.addTranslationHook(alert, function () { return utils_1.stringifyLajiMapError(error, _this.translations); });
                container.appendChild(alert);
            };
            var convertText = function (e) {
                e.preventDefault();
                try {
                    var prevFeatureCollection = {
                        type: "FeatureCollection",
                        features: _this.cloneFeatures(_this.getDraw().featureCollection.features)
                    };
                    var events_1 = [{
                            type: "delete",
                            idxs: Object.keys(_this.idxsToIds[_this.drawIdx]).map(function (idx) { return parseInt(idx); }),
                            features: _this.cloneFeatures(_this.getDraw().featureCollection.features)
                        }];
                    _this.updateDrawData(__assign(__assign({}, _this.getDraw()), { featureCollection: undefined, geoData: fixedGeoJSON || textarea.value }));
                    _this.getDraw().featureCollection.features.forEach(function (feature) {
                        events_1.push({ type: "create", feature: feature });
                    });
                    _this._triggerEvent(events_1, _this.getDraw().onChange);
                    _this._updateDrawUndoStack(events_1, prevFeatureCollection);
                    _this._closeDialog(e);
                }
                catch (e) {
                    if (e.stringify)
                        updateAlert(e);
                    throw e;
                }
                var bounds = _this.getDraw().group.getBounds();
                if (Object.keys(bounds).length)
                    _this.map.fitBounds(bounds);
            };
            button.addEventListener("click", convertText);
            container.appendChild(textarea);
            container.appendChild(formatDetectorElem);
            container.appendChild(button);
            this._showDialog(container, function () {
                translationsHooks.forEach(function (hook) { return _this.removeTranslationHook(hook); });
                if (alertTranslationHook)
                    _this.removeTranslationHook(alertTranslationHook);
                unmountFormatDetector();
            });
            textarea.focus();
            textarea.select();
        };
        LajiMapWithControls.prototype._joinTranslations = function () {
            var words = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                words[_i] = arguments[_i];
            }
            var translations = this.translations;
            return words.map(function (word) { return translations[word]; }).join(" ");
        };
        LajiMapWithControls.prototype._updateContextMenu = function () {
            var _this = this;
            if (!dependency_utils_1.depsProvided(this, "_updateContextMenu", arguments))
                return;
            var join = function () {
                var params = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    params[_i] = arguments[_i];
                }
                return _this._joinTranslations.apply(_this, params);
            };
            this.map.contextmenu.removeAllItems();
            this._contextMenuItems = {};
            var groupAdded = false;
            this.getFeatureTypes().forEach(function (featureType) {
                var text = join("Draw", featureType);
                if (_this.getDraw() && _this.drawIsEditable() && _this.getDraw()[featureType] !== false && _this.controlSettings.draw[featureType] !== false) {
                    _this._contextMenuItems["draw." + featureType] = _this.map.contextmenu.addItem({
                        text: text,
                        iconCls: "context-menu-draw context-menu-draw-" + featureType,
                        callback: function () { return _this.triggerDrawing(featureType); }
                    });
                    groupAdded = true;
                }
            });
            var addControlGroup = function (groupName, controlGroup) {
                if (controlGroup.contextMenu === false)
                    return;
                if (groupAdded && controlGroup.some(function (control) { return _this._controlIsAllowed(getSubControlName(groupName, control.name)); })) {
                    _this.map.contextmenu.addItem("-");
                }
                groupAdded = false;
                controlGroup.forEach(function (control) {
                    var controlName = getSubControlName(groupName, control.name);
                    if ("text" in control && _this._controlIsAllowed(controlName)) {
                        _this._contextMenuItems[controlName] = _this.map.contextmenu.addItem(__assign(__assign({}, control), { callback: function () {
                                return _this.container.querySelector(".button-" + controlName.replace(".", "_")).click();
                            } }));
                        groupAdded = true;
                    }
                });
            };
            var itemsWithContextMenu = this.controlItems.filter(function (item) { return item.contextMenu !== false; });
            itemsWithContextMenu.forEach(function (control) { return addControlGroup(control.controls
                ? control.name
                : undefined, control.controls
                ? control.controls
                : [control]); });
            dependency_utils_1.provide(this, "contextMenu");
        };
        LajiMapWithControls.prototype.getGoogleGeocodingControl = function () {
            var control = new leaflet_geosearch_1.GeoSearchControl({
                provider: this.provider,
                showmarker: false,
                autoClose: true,
                searchLabel: this.translations.GeocodingSearchLabel + "... (" + this.translations.Google + ")",
                notFoundMessage: this.translations.GeocodingSearchFail
            });
            var onAdd = control.__proto__.onAdd;
            control.__proto__.onAdd = function (map) {
                var container = onAdd.call(this, map);
                L.DomEvent.disableClickPropagation(container);
                var resetButton = control.elements.resetButton;
                resetButton.parentElement.removeChild(resetButton);
                control.searchElement.elements.input.addEventListener("blur", function () {
                    setTimeout(function () { return control.closeResults(); }, 300);
                });
                return container;
            };
            return control;
        };
        LajiMapWithControls.prototype.setFullscreenOn = function () {
            _super.prototype.setFullscreenOn.call(this);
            this._updateFullscreenControl();
        };
        LajiMapWithControls.prototype.setFullscreenOff = function () {
            _super.prototype.setFullscreenOff.call(this);
            this._updateFullscreenControl();
        };
        LajiMapWithControls.prototype._updateFullscreenControl = function () {
            var _a;
            var button = this._controlButtons.fullscreen;
            if (!button)
                return;
            var icon = button.children[0];
            var _replace = ["full", "small"];
            var replace = this._fullscreen
                ? _replace
                : _replace.reverse();
            var title = this._fullscreen
                ? "MapExitFullscreen"
                : "MapFullscreen";
            icon.className = (_a = icon.className).replace.apply(_a, replace);
            button.title = this.translations[title];
        };
        LajiMapWithControls.prototype.triggerDrawing = function (featureType) {
            try {
                this.drawControl._toolbars.draw._modes[featureType.toLowerCase()].handler.enable();
                this.addDrawAbortListeners();
            }
            catch (e) {
                _super.prototype.triggerDrawing.call(this, featureType);
            }
        };
        LajiMapWithControls.prototype.shouldNotPreventScrolling = function () {
            return _super.prototype.shouldNotPreventScrolling.call(this) || !!this.activeControl;
        };
        __decorate([
            dependency_utils_1.dependsOn("map")
        ], LajiMapWithControls.prototype, "setLang", null);
        __decorate([
            dependency_utils_1.reflect(),
            dependency_utils_1.dependsOn("controls")
        ], LajiMapWithControls.prototype, "_updateUserLocate", null);
        __decorate([
            dependency_utils_1.reflect(),
            dependency_utils_1.dependsOn("map", "translations", "controlSettings")
        ], LajiMapWithControls.prototype, "_updateMapControls", null);
        __decorate([
            dependency_utils_1.reflect(),
            dependency_utils_1.dependsOn("draw")
        ], LajiMapWithControls.prototype, "_updateDrawControls", null);
        __decorate([
            dependency_utils_1.reflect(),
            dependency_utils_1.dependsOn("customControls")
        ], LajiMapWithControls.prototype, "_updateCustomControls", null);
        __decorate([
            dependency_utils_1.reflect(),
            dependency_utils_1.dependsOn("lineTransect")
        ], LajiMapWithControls.prototype, "_updateLineTransectControls", null);
        __decorate([
            dependency_utils_1.dependsOn("controls", "contextMenu")
        ], LajiMapWithControls.prototype, "updateLTUndoButton", null);
        __decorate([
            dependency_utils_1.dependsOn("controls", "contextMenu")
        ], LajiMapWithControls.prototype, "updateLTRedoButton", null);
        __decorate([
            dependency_utils_1.dependsOn("controls", "contextMenu")
        ], LajiMapWithControls.prototype, "updateDrawUndoButton", null);
        __decorate([
            dependency_utils_1.dependsOn("controls", "contextMenu")
        ], LajiMapWithControls.prototype, "updateDrawRedoButton", null);
        __decorate([
            dependency_utils_1.reflect(),
            dependency_utils_1.dependsOn("controls")
        ], LajiMapWithControls.prototype, "_updateContextMenu", null);
        return LajiMapWithControls;
    }(Base));
    return LajiMapWithControls;
} // tslint:disable-line
exports.default = LajiMapWithControls;
