import * as LM from "./map.defs";
import * as C from "./controls.defs";
import _LajiMap from "./map";
export declare const LajiMap: {
    new (...args: any[]): {
        controls: import("leaflet").Control[];
        _customControls: C.CustomControl[];
        layerControl: import("leaflet").Control.Layers;
        controlItems: C.ControlOptions[];
        _controlItemsByName: {
            [controlName: string]: C.ControlOptions;
        };
        activeControl: import("leaflet").Control;
        controlSettings: C.InternalControlsOptions;
        drawControl: import("leaflet").Control.Draw;
        _locateOn: boolean;
        _controlButtons: {
            [controlName: string]: HTMLElement;
        };
        _opacitySetBySlide: boolean;
        _slider: any;
        _contextMenuItems: {
            [buttonName: string]: HTMLElement;
        };
        _internalTileLayersUpdate: boolean;
        getOptionKeys(): any;
        _setLang(): void;
        setLang(lang: any): void;
        _initializeMapEvents(): void;
        _toggleLocate(): void;
        _setLocateOn(...params: any[]): void;
        _setLocateOff(): void;
        _onLocationFound(e: any): void;
        setTileLayers(options: any): void;
        _updateUserLocate(value: any): void;
        _updateMapControls(): void;
        _updateDrawControls(): void;
        updateDrawData(item: LM.DrawOptions): void;
        _updateCustomControls(): void;
        _updateLineTransectControls(): void;
        setControlsWarn(controlSettings: any): void;
        setControls(controlSettings: boolean | C.ControlsOptions): void;
        setCustomControls(controls?: C.CustomControl[]): void;
        _controlIsAllowed(name: any, custom?: boolean): any;
        _addControl(name: any, control: import("leaflet").Control): void;
        _createControlButton(that: any, container: any, fn: any, name?: any): HTMLElement;
        _createControlItem(that: any, container: any, glyphName: any, title: any, fn: any, name: any): HTMLElement;
        _getDrawControl(): import("leaflet").Control.Draw;
        _getCoordinatesControl(): import("leaflet").Control;
        _getLayerControl(): import("leaflet").Control;
        getZoomControl(): import("leaflet").Control.Zoom;
        setTileLayerOpacity(opacity: any, triggerEvent?: any): void;
        setLineTransectGeometry(feature: any, undo: any): void;
        resetDrawUndoStack(): void;
        _updateDrawUndoStack(events: LM.LajiMapCreateEvent | LM.LajiMapEditEvent | LM.LajiMapDeleteEvent | LM.LajiMapInsertEvent | LM.LajiMapActivateEvent | LM.LajiMapEvent[], prevFeatureCollection: any, prevActiveIdx?: any): void;
        drawUndo(): void;
        drawRedo(): void;
        _updateUndoButton(buttonName: any, history: any, historyPointer: any): void;
        _updateRedoButton(buttonName: any, history: any, historyPointer: any): void;
        updateLTUndoButton(): void;
        updateLTRedoButton(): void;
        updateDrawUndoButton(): void;
        updateDrawRedoButton(): void;
        openCoordinatesInputDialog(): void;
        openDrawCopyDialog(): void;
        createFormatDetectorElem(options?: {
            displayFormat?: boolean;
            displayErrors?: boolean;
            allowGrid?: boolean;
        }): {
            elem: HTMLElement;
            validate: (value?: string) => {
                valid: boolean;
                geoJSON: import("geojson").GeoJSON;
            };
            unmount: () => void;
        };
        openDrawUploadDialog(): void;
        _joinTranslations(...words: any[]): string;
        _updateContextMenu(): void;
        getGoogleGeocodingControl(): any;
        setFullscreenOn(): void;
        setFullscreenOff(): void;
        _updateFullscreenControl(): void;
        triggerDrawing(featureType: LM.DataItemType): void;
        shouldNotPreventScrolling(): boolean;
        googleApiKey: string;
        container: HTMLElement;
        mapElem: HTMLElement;
        blockerElem: HTMLElement;
        rootElem: HTMLElement;
        translations: any;
        data: LM.Data[];
        map: import("leaflet").Map;
        _onDrawReverse: (layer: LM.DataItemLayer) => void;
        _onDrawRemove: (layer: LM.DataItemLayer) => void;
        idxsToIds: {
            [dataIdx: number]: {
                [featureIdx: number]: number;
            };
        };
        idsToIdxs: {
            [dataIdx: number]: {
                [id: number]: number;
            };
        };
        idsToIdxTuples: {
            [id: number]: LM.IdxTuple;
        };
        editIdxTuple: LM.IdxTuple;
        drawing: boolean;
        _drawHistoryPointer: number;
        _drawHistory: LM.DrawHistoryEntry[];
        polyline: import("leaflet").Polyline<import("geojson").LineString | import("geojson").MultiLineString, any>;
        userLocation: {
            latlng: import("leaflet").LatLng;
            accuracy: number;
        };
        userLocationMarker: import("leaflet").CircleMarker<any>;
        userLocationRadiusMarker: import("leaflet").Circle<any>;
        userLocationLayer: import("leaflet").LayerGroup<any>;
        popup: any;
        featurePopupOffset: number;
        markerPopupOffset: number;
        lang: LM.Lang;
        tileLayerOpacity: number;
        onSetLangHooks: (() => void)[];
        options: LM.Options;
        _dialogRoot: HTMLElement;
        _openDialogs: any[];
        _closeDialog: (e?: Event) => void;
        draw: LM.Draw;
        drawIdx: number;
        _draftDrawLayer: LM.DataItemLayer;
        _idxsToHovered: {
            [dataIdx: number]: {
                [featureIdx: number]: boolean;
            };
        };
        _idxsToContextMenuOpen: {
            [dataIdx: number]: {
                [id: number]: boolean;
            };
        };
        locate: boolean | [(event: import("leaflet").LocationEvent) => void, (error: import("leaflet").ErrorEvent) => void];
        _located: boolean;
        popupOnHover: boolean;
        popupCounter: number;
        onPopupClose: () => void;
        _drawReverseLayers: import("leaflet").Polyline<import("geojson").LineString | import("geojson").MultiLineString, any>[];
        _drawRemoveLayers: LM.DataItemLayer[];
        _zoomToData: boolean | LM.LajiMapFitBoundsOptions;
        _disableDblClickZoom: boolean;
        dictionary: {
            [lang: string]: any;
        };
        _domCleaners: (() => void)[];
        _documentEvents: {
            [eventName: string]: EventListener;
        };
        zoom: number;
        center: import("leaflet").LatLngExpression;
        tileLayer: import("leaflet").TileLayer;
        overlaysByNames: {
            [name: string]: import("leaflet").TileLayer;
        };
        availableOverlaysByNames: {
            [name: string]: import("leaflet").TileLayer;
        };
        overlays: import("leaflet").TileLayer[];
        finnishTileLayers: {
            ykjGrid?: import("leaflet").TileLayer;
            ykjGridLabels?: import("leaflet").TileLayer;
            maastokartta?: import("leaflet").TileLayer;
            taustakartta?: import("leaflet").TileLayer;
            pohjakartta?: import("leaflet").TileLayer;
            ortokuva?: import("leaflet").TileLayer;
            laser?: import("leaflet").TileLayer;
        };
        worldTileLayers: {
            openStreetMap?: import("leaflet").TileLayer;
            googleSatellite?: import("leaflet").TileLayer;
        };
        tileLayers: {
            ykjGrid?: import("leaflet").TileLayer;
            ykjGridLabels?: import("leaflet").TileLayer;
            maastokartta?: import("leaflet").TileLayer;
            taustakartta?: import("leaflet").TileLayer;
            pohjakartta?: import("leaflet").TileLayer;
            ortokuva?: import("leaflet").TileLayer;
            laser?: import("leaflet").TileLayer;
            openStreetMap?: import("leaflet").TileLayer;
            googleSatellite?: import("leaflet").TileLayer;
            geobiologicalProvinces?: import("leaflet").TileLayer;
            geobiologicalProvinceBorders?: import("leaflet").TileLayer;
            municipalities?: import("leaflet").TileLayer;
            forestVegetationZones?: import("leaflet").TileLayer;
            mireVegetationZones?: import("leaflet").TileLayer;
            threatenedSpeciesEvaluationZones?: import("leaflet").TileLayer;
            biodiversityForestZones?: import("leaflet").TileLayer;
        };
        tileLayerName: LM.TileLayerName;
        _tileLayers: LM.InternalTileLayersOptions;
        availableTileLayers: {
            [name: string]: import("leaflet").TileLayer;
        };
        _listenedEvents: import("leaflet").LeafletEventHandlerFnMap;
        _keyListeners: {
            [eventName: string]: {
                [key: string]: ((e: Event) => boolean | void)[];
            };
        };
        _swapToWorldFlag: boolean;
        _mouseLatLng: import("leaflet").LatLng;
        _contextMenuLayer: import("leaflet").Layer;
        _preventScrollDomCleaner: () => void;
        _onDrawStopPreventScrolling: () => void;
        _onDrawStartPreventScrolling: () => void;
        _preventScroll: boolean;
        _scrollPreventElem: HTMLElement;
        _scrollPreventTextElemContainer: HTMLElement;
        _scrollPreventTextElem: HTMLElement;
        _scrollPreventScrollListeners: [string, EventListener][];
        _startPreventScrollingTimeout: () => void;
        _onControlClickPreventScrolling: () => boolean;
        _onMouseDownPreventScrolling: EventListener;
        _onTouchPreventScrolling: EventListener;
        _preventScrolling: () => void;
        _showPreventAnimationTimeout: any;
        _showPreventShowTimeout: any;
        _showPreventHideTimeout: any;
        _showingPreventScroll: boolean;
        _LTEditPointIdxTuple: LM.IdxTuple;
        _clickBeforeZoomAndPan: boolean;
        _origLatLngs: {
            [id: string]: import("leaflet").LatLng[];
        };
        _tooltip: import("leaflet").Draw.Tooltip;
        _tooltipTranslationHook: () => void;
        _onMouseMove: (e: any) => void;
        provider: any;
        leafletOptions: import("leaflet").MapOptions;
        _viewCriticalSection: number;
        _tileLayersSet: boolean;
        activeProjName: "finnish" | "world";
        _tileLayerOrder: string[];
        viewLocked: boolean;
        _locateParam: boolean | LM.UserLocationOptions;
        locateOptions: LM.UserLocationOptions;
        availableTileLayersWhitelist: LM.TileLayerName[];
        availableTileLayersBlacklist: LM.TileLayerName[];
        _initialized: boolean;
        mmlProj: import("leaflet").Proj.CRS;
        _trySwapToFinnishOnInitialization: boolean;
        _fullscreen: boolean;
        _fullscreenElem: HTMLElement;
        _beforeFullscreen: {
            rootElem: HTMLElement;
            bodyAsDialogRoot: boolean;
            clickBeforeZoomAndPan: boolean;
            bodyOverflowY: string;
        };
        setOptions(options?: LM.Options): void;
        setOption(option: "center" | "data" | "circle" | "marker" | "polygon" | "polyline" | "contextmenu" | "zoomToData" | "locate" | "rootElem" | "lang" | "draw" | "tileLayerName" | "tileLayers" | "availableTileLayerNamesBlacklist" | "availableTileLayerNamesWhitelist" | "overlayNames" | "availableOverlayNameBlacklist" | "availableOverlayNameWhitelist" | "tileLayerOpacity" | "zoom" | "onPopupClose" | "markerPopupOffset" | "featurePopupOffset" | "popupOnHover" | "on" | "rectangle" | "bodyAsDialogRoot" | "clickBeforeZoomAndPan" | "viewLocked" | "controls" | "preferCanvas" | "attributionControl" | "zoomControl" | "closePopupOnClick" | "zoomSnap" | "zoomDelta" | "trackResize" | "boxZoom" | "doubleClickZoom" | "dragging" | "crs" | "minZoom" | "maxZoom" | "layers" | "maxBounds" | "renderer" | "fadeAnimation" | "markerZoomAnimation" | "transform3DLimit" | "zoomAnimation" | "zoomAnimationThreshold" | "inertia" | "inertiaDeceleration" | "inertiaMaxSpeed" | "easeLinearity" | "worldCopyJump" | "maxBoundsViscosity" | "keyboard" | "keyboardPanDelta" | "scrollWheelZoom" | "wheelDebounceTime" | "wheelPxPerZoomLevel" | "tap" | "tapTolerance" | "touchZoom" | "bounceAtZoomLimits" | "drawControl" | "smoothWheelZoom" | "smoothSensitivity" | "contextmenuInheritItems" | "contextmenuItems" | "contextmenuWidth", value: any): void;
        getOption(option: "center" | "data" | "circle" | "marker" | "polygon" | "polyline" | "contextmenu" | "zoomToData" | "locate" | "rootElem" | "lang" | "draw" | "tileLayerName" | "tileLayers" | "availableTileLayerNamesBlacklist" | "availableTileLayerNamesWhitelist" | "overlayNames" | "availableOverlayNameBlacklist" | "availableOverlayNameWhitelist" | "tileLayerOpacity" | "zoom" | "onPopupClose" | "markerPopupOffset" | "featurePopupOffset" | "popupOnHover" | "on" | "rectangle" | "bodyAsDialogRoot" | "clickBeforeZoomAndPan" | "viewLocked" | "controls" | "preferCanvas" | "attributionControl" | "zoomControl" | "closePopupOnClick" | "zoomSnap" | "zoomDelta" | "trackResize" | "boxZoom" | "doubleClickZoom" | "dragging" | "crs" | "minZoom" | "maxZoom" | "layers" | "maxBounds" | "renderer" | "fadeAnimation" | "markerZoomAnimation" | "transform3DLimit" | "zoomAnimation" | "zoomAnimationThreshold" | "inertia" | "inertiaDeceleration" | "inertiaMaxSpeed" | "easeLinearity" | "worldCopyJump" | "maxBoundsViscosity" | "keyboard" | "keyboardPanDelta" | "scrollWheelZoom" | "wheelDebounceTime" | "wheelPxPerZoomLevel" | "tap" | "tapTolerance" | "touchZoom" | "bounceAtZoomLimits" | "drawControl" | "smoothWheelZoom" | "smoothSensitivity" | "contextmenuInheritItems" | "contextmenuItems" | "contextmenuWidth"): any;
        getOptions(): LM.Options;
        setRootElem(rootElem: HTMLElement): void;
        setBodyAsDialogRoot(value?: boolean): void;
        setClickBeforeZoomAndPan(value?: boolean): void;
        getMMLProj(): import("leaflet").CRS;
        _initializeMap(): void;
        _initializeView(): void;
        _isOutsideFinland(latLng: import("leaflet").LatLngExpression): boolean;
        _swapToWorldOutsideFinland(latLng: import("leaflet").LatLngExpression): void;
        keyHandlerForType(type: string, e: any): boolean;
        _addDocumentEventListener(type: string, fn: EventListener): void;
        _addKeyListener(key: string, fn: (e?: Event) => boolean | void, type?: string): void;
        _removeKeyListener(key: string, fn: (e?: Event) => boolean | void, type?: string): void;
        _triggerKeyEvent(key: string, e: Event, type: string): boolean;
        setEventListeners(eventListeners: import("leaflet").LeafletEventHandlerFnMap): void;
        _getDefaultCRSLayers(): import("leaflet").TileLayer[];
        _getMMLCRSLayers(): import("leaflet").TileLayer[];
        setTileLayerByName(name: LM.TileLayerName): void;
        _getListForAvailableTileLayer(names: LM.TileLayerName[], condition: any, _tileLayers?: {
            [name: string]: import("leaflet").TileLayer;
        }): {};
        setAvailableTileLayers(names: LM.TileLayerName[], condition: boolean, _tileLayers?: {
            [name: string]: import("leaflet").TileLayer;
        }): void;
        getDefaultTileLayerBlacklist(): LM.TileLayerName[];
        getDefaultTileLayerWhitelist(): LM.TileLayerName[];
        setAvailableTileLayerBlacklist(names: LM.TileLayerName[]): void;
        setAvailableTileLayerWhitelist(names: LM.TileLayerName[]): void;
        getAvailableOverlaysByNames(): {
            [name: string]: import("leaflet").TileLayer[];
        };
        getAvailableWorldTileLayers(): {
            [name: string]: import("leaflet").TileLayer[];
        };
        getAvailableFinnishTileLayers(): {
            [name: string]: import("leaflet").TileLayer[];
        };
        getAvailableLayersFor(_layers: any, availables: any): {
            [name: string]: import("leaflet").TileLayer[];
        };
        setTileLayer(layer: import("leaflet").TileLayer): void;
        getActiveLayers(options: LM.InternalTileLayersOptions): {
            ykjGrid?: LM.TileLayerOptions;
            ykjGridLabels?: LM.TileLayerOptions;
            maastokartta?: LM.TileLayerOptions;
            taustakartta?: LM.TileLayerOptions;
            pohjakartta?: LM.TileLayerOptions;
            ortokuva?: LM.TileLayerOptions;
            laser?: LM.TileLayerOptions;
            openStreetMap?: LM.TileLayerOptions;
            googleSatellite?: LM.TileLayerOptions;
            geobiologicalProvinces?: LM.TileLayerOptions;
            geobiologicalProvinceBorders?: LM.TileLayerOptions;
            municipalities?: LM.TileLayerOptions;
            forestVegetationZones?: LM.TileLayerOptions;
            mireVegetationZones?: LM.TileLayerOptions;
            threatenedSpeciesEvaluationZones?: LM.TileLayerOptions;
            biodiversityForestZones?: LM.TileLayerOptions;
        };
        _getInternalTileLayerOptions(options: LM.TileLayersOptions): LM.InternalTileLayersOptions;
        getTileLayers(): LM.TileLayersOptions;
        setOverlays(overlays?: import("leaflet").TileLayer[]): void;
        _setOverlaysByName(overlayNames: LM.OverlayName[]): void;
        getOverlaysByName(): LM.OverlayName[];
        setOverlaysByName(overlayNames?: LM.OverlayName[]): void;
        setAvailableOverlaysBlacklist(overlayNames: LM.OverlayName[]): void;
        setAvailableOverlaysWhitelist(overlayNames: LM.OverlayName[]): void;
        setAvailableOverlays(overlayNames: LM.OverlayName[], condition: any): void;
        getNormalizedZoom(zoom?: number, tileLayer?: import("leaflet").TileLayer): number;
        getDenormalizedZoom(zoom?: number, tileLayer?: import("leaflet").TileLayer): number;
        initZoom(zoom: any): void;
        setNormalizedZoom(zoom: any, options?: {
            animate: boolean;
        }): void;
        setCenter(center: import("leaflet").LatLngExpression): void;
        destroy(): void;
        cleanDOM(): void;
        _addDomCleaner(fn: () => void): void;
        _removeDomCleaner(fn: () => void): void;
        _constructDictionary(): void;
        formatFeatureOut(feature: import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>, layer?: LM.DataItemLayer): import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>;
        formatFeatureIn(feature: import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>, idx: number): import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>;
        cloneFeatures(features: import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>[]): import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>[];
        initializeDataItem(options: LM.DataOptions, dataIdx?: number): void;
        _getAllData(): {
            group: import("leaflet").FeatureGroup<any>;
        }[];
        zoomToData(options?: boolean | LM.ZoomToDataOptions): void;
        getBoundsForZoomToDataOptions(options?: boolean | LM.ZoomToDataOptions): import("leaflet").LatLngBounds;
        getBoundsForDraw(): import("leaflet").LatLngBounds;
        getBoundsForIdxs(...idxs: any[]): import("leaflet").LatLngBounds;
        getBoundsForData(datas?: {
            group: import("leaflet").FeatureGroup<any>;
        }[]): import("leaflet").LatLngBounds;
        getBoundsForLayers(layers: import("leaflet").Layer[]): import("leaflet").LatLngBounds;
        _mapLayersToBoundableLayers(layers: import("leaflet").Layer[]): import("leaflet").Layer[];
        _initializeLayer(layer: LM.DataItemLayer, idxTuple: LM.IdxTuple): void;
        fitBounds(_bounds: import("leaflet").LatLngBoundsExpression, options?: LM.LajiMapFitBoundsOptions): void;
        setData(data: LM.Data | LM.Data[]): void;
        getData: () => LM.Data[];
        addData(items: LM.DataOptions[]): void;
        updateData(dataIdx: any, item: LM.DataOptions): void;
        removeData(dataIdx: number): void;
        getDrawOptions(options: boolean | LM.DrawOptions): LM.DrawOptions;
        setDraw(options: LM.DrawOptions): void;
        getDraw(): LM.Draw;
        drawIsAllowed(): boolean;
        drawIsEditable(): boolean;
        wrapGeoJSONCoordinate([lng, lat]: import("geojson").Position): import("geojson").Position;
        _setOnChangeForItem(item: any, format?: LM.OnChangeCoordinateSystem, crs?: string): void;
        clearItemData(item: LM.Data, commit?: boolean): void;
        clearDrawData(): void;
        _startDrawRemove(): void;
        _stopDrawRemove(): boolean;
        _finishDrawRemove(): void;
        _cancelDrawRemove(): boolean;
        _onDrawReverseHandler({ layer }: import("leaflet").GeoJSONEvent): void;
        _startDrawReverse(): void;
        _stopDrawReverse(): void;
        _finishDrawReverse(): void;
        _cancelDrawReverse(): void;
        _createIcon(options?: import("leaflet").PathOptions): import("leaflet").Icon<import("leaflet").IconOptions>;
        _getClusterIcon(data: LM.Data): (cluster: import("leaflet").MarkerCluster) => import("leaflet").DivIcon;
        setActive(layer: LM.DataItemLayer): void;
        _resetIds(dataIdx: number): void;
        _setIdForLayer(layer: LM.DataItemLayer, idxTuple: LM.IdxTuple): void;
        recluster(): void;
        _reclusterDrawData(): void;
        _reclusterData(): void;
        getClusterOptionsFor(item: LM.Data): {
            showCoverageOnHover?: boolean;
            zoomToBoundsOnClick?: boolean;
            spiderfyOnMaxZoom?: boolean;
            removeOutsideVisibleBounds?: boolean;
            animate?: boolean;
            animateAddingMarkers?: boolean;
            disableClusteringAtZoom?: number;
            maxClusterRadius?: number | ((zoom: number) => number);
            polygonOptions?: import("leaflet").PolylineOptions;
            singleMarkerMode?: boolean;
            spiderLegPolylineOptions?: import("leaflet").PolylineOptions;
            spiderfyDistanceMultiplier?: number;
            iconCreateFunction: ((cluster: import("leaflet").MarkerCluster) => import("leaflet").Icon<import("leaflet").IconOptions> | import("leaflet").DivIcon) | ((cluster: import("leaflet").MarkerCluster) => import("leaflet").DivIcon);
            chunkedLoading?: boolean;
            chunkDelay?: number;
            pane?: string;
            attribution?: string;
        };
        _reclusterDataItem(item: LM.Data): void;
        reorderData(): void;
        redrawDrawData(): void;
        redrawDataItem(idx: number): void;
        redrawData(): void;
        redraw(): void;
        _initializePopup(layer: LM.DataItemLayer): void;
        _initializeTooltip(layer: LM.DataItemLayer): void;
        _updateContextMenuForLayer(layer: LM.DataItemLayer): void;
        setLocate(locate?: boolean | LM.UserLocationOptions): void;
        createUserLocationLayer(latlng: import("leaflet").LatLng, accuracy: number): {
            layerGroup: import("leaflet").LayerGroup<any>;
            markerLayer: import("leaflet").CircleMarker<any>;
            radiusLayer: import("leaflet").Circle<any>;
        };
        _onLocationNotFound(e: import("leaflet").ErrorEvent): void;
        getDrawLayerByIdx(idx: number): LM.DataItemLayer;
        _getLayerByIdxTuple: (idxTuple: LM.IdxTuple) => LM.DataItemLayer;
        getLayerByIdxTuple(idxTuple: LM.IdxTuple): LM.DataItemLayer;
        _getLayerById(id: number): LM.DataItemLayer;
        _getIdxTupleByLayer(layer: any): LM.IdxTuple;
        _getDrawLayerById(id: any): LM.DataItemLayer;
        _triggerEvent(e: any, handler: any): void;
        _decoratePolyline(layer: import("leaflet").Polyline<import("geojson").LineString | import("geojson").MultiLineString, any>): void;
        _reversePolyline(layer: any): void;
        _getStartCircleStyle(lineLayer: any): import("leaflet").PathOptions;
        _onAdd(dataIdx: number, layer: LM.DataItemLayer, coordinateVerbatim?: string): void;
        _onEdit(dataIdx: any, data: any): void;
        _onDelete(dataIdx: any, deleteIds: any): void;
        _removeLayerFromItem(item: LM.Data, layer: LM.DataItemLayer): void;
        _onActiveChange(idxTuple: LM.IdxTuple): void;
        focusToLayerByIdxs(idxTuple: LM.IdxTuple): void;
        focusToDrawLayer(idx: number): void;
        _setEditable(layer: LM.DataItemLayer): void;
        _clearEditable(): void;
        _commitEdit(): void;
        _interceptClick(): boolean;
        setLayerStyle(layer: import("leaflet").FeatureGroup<any> | import("leaflet").Polygon<any> | import("leaflet").Polyline<import("geojson").LineString | import("geojson").MultiLineString, any> | import("leaflet").Marker<any> | import("leaflet").Circle<any>, style: import("leaflet").PathOptions): void;
        _featureToLayer(getFeatureStyle: (options: LM.GetFeatureStyleOptions) => import("leaflet").PathOptions, dataIdx?: number): (feature: any) => any;
        _getDefaultDrawDraftStyle(): import("leaflet").PathOptions;
        _fillStyleWithGlobals<T extends import("leaflet").PathOptions>(idxTuple: LM.IdxTuple): T;
        _getStyleForType(idx: number | LM.IdxTuple, overrideStyles?: import("leaflet").PathOptions): import("leaflet").PathOptions;
        _getStyleForLayer(layer: LM.DataItemLayer, overrideStyles?: any): import("leaflet").PathOptions;
        updateLayerStyle(layer: LM.DataItemLayer): void;
        _getDefaultDrawStyle(): import("leaflet").PathOptions;
        _getDefaultDrawClusterStyle(): import("leaflet").PathOptions;
        _getDefaultDataStyle(item: LM.Data): () => import("leaflet").PathOptions;
        _getDefaultDataClusterStyle: (item: any) => () => {
            color: string;
            opacity: number;
        };
        _getDefaultDraftStyle(dataIdx: number): import("leaflet").PathOptions;
        _updateDataLayerGroupStyle(idx: number): void;
        addTranslationHook(elemOrFn: HTMLElement | (() => void), translationKey?: string | (() => string), attr?: string): () => void;
        removeTranslationHook(hook: () => void): void;
        _getDrawOptionsForType<T_1 extends import("leaflet").PathOptions>(featureType: LM.DataItemType): T_1;
        abortDrawing(e?: Event): void;
        addDrawAbortListeners(): void;
        addFeatureToDraw(feature: import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>): void;
        addFeatureToData(feature: import("geojson").Feature<import("geojson").Geometry, {
            [name: string]: any;
        }>, dataIdx: number): void;
        getFeatureTypes(): LM.DataItemType[];
        _showError(e: Error): void;
        showClosableElement(elem: HTMLElement, onClose: (e: Event) => void, blocker?: boolean, getContainer?: () => HTMLElement): void;
        _createTooltip(translationKey: string, error?: boolean): import("leaflet").Draw.Tooltip;
        _disposeTooltip(): void;
        _showDialog(container: HTMLElement, onClose?: (e: Event) => void): void;
        setGoogleApiKey(googleApiKey: string): void;
        setGeocodingProvider(): void;
        geocode(query: string, additional?: any, zoom?: number): void;
        setViewLocked(value: any): void;
        toggleFullscreen(): void;
    };
} & typeof _LajiMap;
export default LajiMap;
export * from "./defs";
