"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextmenuItem = exports.isPolyline = void 0;
var L = require("leaflet");
require("leaflet-draw");
require("proj4leaflet");
require("Leaflet.vector-markers");
require("leaflet.markercluster");
require("./lib/Leaflet.rrose/leaflet.rrose-src");
require("leaflet.smoothwheelzoom");
require("leaflet-contextmenu");
require("leaflet-textpath");
require("leaflet-measure-path");
var leaflet_geosearch_1 = require("leaflet-geosearch");
var utils_1 = require("./utils");
var dependency_utils_1 = require("./dependency-utils");
var globals_1 = require("./globals");
var map_defs_1 = require("./map.defs");
var translations_1 = require("./translations");
function capitalizeFirstLetter(s) {
    return s.charAt(0).toUpperCase() + s.slice(1);
}
function isPolyline(layer) {
    return layer instanceof L.Polyline && ["Rectangle", "Polygon"].every(function (type) { return !(layer instanceof L[type]); });
}
exports.isPolyline = isPolyline;
var DEFAULT_LAYER_NAME = map_defs_1.TileLayerName.taustakartta;
// Override the tooltip to turn when it overflows.
var tooltipOrigPrototype = L.Draw.Tooltip.prototype;
L.Draw.Tooltip = L.Draw.Tooltip.extend({
    updatePosition: function (latlng) {
        tooltipOrigPrototype.updatePosition.call(this, latlng);
        var _a = this._container.getBoundingClientRect(), width = _a.width, x = _a.x;
        var _b = this._map._container.getBoundingClientRect(), mapWidth = _b.width, mapX = _b.x;
        if (width + x > mapWidth + mapX) {
            var _d = this._map.latLngToLayerPoint(latlng), _x = _d.x, _y = _d.y;
            L.DomUtil.setPosition(this._container, new L.Point(_x - width - 30, _y));
            if (this._container.className.indexOf(" reversed") === -1) {
                this._container.className += " reversed";
            }
        }
        else if (this._container.className.indexOf(" reversed") !== -1) {
            this._container.className = this._container.className.replace(" reversed", "");
        }
        return this;
    }
});
var _initIcon = L.Marker.prototype._initIcon;
L.Marker.include({
    _initIcon: function () {
        _initIcon.call(this);
        if (this._initStyle) {
            this._setIconStyle(this._initStyle);
        }
    },
    setStyle: function (style) {
        // Ran into a bug? See known issues section of README.
        if (this._icon) {
            this._setIconStyle(style);
        }
        else {
            this._initStyle = style;
        }
    },
    _setIconStyle: function (style) {
        if (this._icon) {
            this._icon.firstChild.firstChild.style.fill = style.color;
            this._icon.firstChild.firstChild.style.opacity = style.opacity || 2;
        }
    }
});
var ContextmenuItem = /** @class */ (function () {
    function ContextmenuItem() {
    }
    return ContextmenuItem;
}());
exports.ContextmenuItem = ContextmenuItem;
var LajiMap = /** @class */ (function () {
    function LajiMap(props) {
        var _this = this;
        this.onSetLangHooks = [];
        this._openDialogs = [];
        this._keyListeners = {};
        this._viewCriticalSection = 0;
        this._tileLayerOrder = [
            "pohjakartta",
            "taustakartta",
            "maastokartta",
            "laser",
            "ortokuva",
            "ykjGrid",
            "ykjGridLabels",
            "openStreetMap",
            "googleSatellite",
            "geobiologicalProvinces",
            "geobiologicalProvinceBorders",
            "municipalities",
            "forestVegetationZones",
            "mireVegetationZones",
            "threatenedSpeciesEvaluationZones",
            "biodiversityForestZones",
        ];
        this._initialized = false;
        this._trySwapToFinnishOnInitialization = true;
        this._fullscreen = false;
        this.getData = function () {
            var data = __spreadArrays(_this.data);
            delete data[_this.drawIdx];
            return data;
        };
        this._getLayerByIdxTuple = this.getLayerByIdxTuple;
        this._getDefaultDataClusterStyle = function (item) { return function () {
            var color = item.editable ? globals_1.EDITABLE_DATA_LAYER_COLOR : globals_1.DATA_LAYER_COLOR;
            if (item.getFeatureStyle) {
                var style = item.getFeatureStyle();
                if (style.color)
                    color = style.color;
            }
            return { color: color, opacity: 1 };
        }; };
        this._constructDictionary();
        var options = {
            tileLayerName: DEFAULT_LAYER_NAME,
            lang: map_defs_1.Lang.en,
            data: [],
            locate: false,
            center: [65, 26],
            zoom: 2,
            zoomToData: false,
            popupOnHover: false,
            draw: false,
            bodyAsDialogRoot: true,
            clickBeforeZoomAndPan: false,
            viewLocked: false,
            availableTileLayerNamesBlacklist: [map_defs_1.TileLayerName.pohjakartta]
        };
        this.options = __assign(__assign({}, options), props);
        this.leafletOptions = {};
        this.setOptions(this.options);
        this._initializeMap();
        this._initializeView();
        this.setGeocodingProvider();
        this._stopDrawRemove = this._stopDrawRemove.bind(this);
        this._stopDrawReverse = this._stopDrawReverse.bind(this);
        this._onDrawReverseHandler = this._onDrawReverseHandler.bind(this);
        this.abortDrawing = this.abortDrawing.bind(this);
        this.setFullscreenOff = this.setFullscreenOff.bind(this);
        this._initialized = true;
    }
    LajiMap.prototype.getOptionKeys = function () {
        var _this = this;
        return {
            rootElem: "setRootElem",
            lang: "setLang",
            data: ["setData", function () { return _this.getData(); }],
            draw: ["setDraw", function () { return _this.getDraw(); }],
            tileLayerName: "setTileLayerByName",
            availableTileLayerNamesBlacklist: "setAvailableTileLayerBlacklist",
            availableTileLayerNamesWhitelist: "setAvailableTileLayerWhitelist",
            overlayNames: ["_setOverlaysByName", function () { return _this.getOverlaysByName(); }],
            availableOverlayNameBlacklist: "setAvailableOverlaysBlacklist",
            availableOverlayNameWhitelist: "setAvailableOverlaysWhitelist",
            tileLayerOpacity: "setTileLayerOpacity",
            tileLayers: ["setTileLayers", function () { return _this.getTileLayers(); }],
            center: ["setCenter", function () { return _this.map.getCenter(); }],
            zoom: ["initZoom", function () { return _this.getNormalizedZoom(); }],
            zoomToData: ["zoomToData", "_zoomToData"],
            locate: ["setLocate", "locate"],
            onPopupClose: true,
            markerPopupOffset: true,
            featurePopupOffset: true,
            popupOnHover: true,
            on: ["setEventListeners", "_listenedEvent"],
            polyline: true,
            polygon: true,
            rectangle: true,
            circle: true,
            marker: true,
            bodyAsDialogRoot: ["setBodyAsDialogRoot", function () { return _this._dialogRoot === document.body; }],
            clickBeforeZoomAndPan: ["setClickBeforeZoomAndPan", "_clickBeforeZoomAndPan"],
            googleApiKey: "setGoogleApiKey",
            viewLocked: "setViewLocked"
        };
    };
    LajiMap.prototype.setOptions = function (options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        Object.keys(options).forEach(function (option) {
            _this.setOption(option, options[option]);
        });
    };
    LajiMap.prototype.setOption = function (option, value) {
        var optionKeys = this.getOptionKeys();
        if (!optionKeys.hasOwnProperty(option)) {
            if (!this._initialized) {
                this.leafletOptions[option] = value;
            }
            else {
                console.warn("setting leaflet options works only during initialization. '" + option + "' isn't a LajiMap option.");
            }
            return;
        }
        var optionKey = Array.isArray(optionKeys[option]) ? optionKeys[option][0] : optionKeys[option];
        if (optionKey === true) {
            this[option] = value;
        }
        else {
            this[optionKey](value);
        }
    };
    LajiMap.prototype.getOption = function (option) {
        var optionKeys = this.getOptionKeys();
        if (Array.isArray(optionKeys[option])) {
            var getter = optionKeys[option][1];
            return typeof getter === "function" ? getter() : this[getter];
        }
        else if (option in this) {
            return this[option];
        }
    };
    LajiMap.prototype.getOptions = function () {
        var _this = this;
        var optionKeys = this.getOptionKeys();
        return Object.keys(optionKeys).reduce(function (options, key) {
            options[key] = _this.getOption(key);
            return options;
        }, {});
    };
    LajiMap.prototype.setRootElem = function (rootElem) {
        var oldContainer = this.container;
        var children = (oldContainer || {}).children;
        this.mapElem = this.mapElem || document.createElement("div");
        this.blockerElem = this.blockerElem || document.createElement("div");
        if (this.map && this.map.getContainer() && !this.map.getContainer().contains(document.activeElement)) {
            this.map.fire("blur");
        }
        this.container = document.createElement("div");
        this.container.className = "laji-map";
        this.blockerElem.className = "laji-map-blocker";
        if (children) {
            for (var _i = 0, _a = Array.from(children); _i < _a.length; _i++) {
                var child = _a[_i];
                this.container.appendChild(child);
            }
        }
        else {
            this.container.appendChild(this.mapElem);
        }
        var shouldSetZoomAndPan = this._clickBeforeZoomAndPan;
        shouldSetZoomAndPan && this.setClickBeforeZoomAndPan(false);
        this.rootElem = rootElem;
        this.rootElem.appendChild(this.container);
        if (oldContainer && oldContainer !== this.container) {
            oldContainer.parentElement.removeChild(oldContainer);
        }
        shouldSetZoomAndPan && this.setClickBeforeZoomAndPan(true);
        this._dialogRoot && this.setBodyAsDialogRoot(this._dialogRoot === document.body);
        this.map && this.map.invalidateSize();
        dependency_utils_1.provide(this, "rootElem");
    };
    LajiMap.prototype.setBodyAsDialogRoot = function (value) {
        var _this = this;
        var _a;
        if (value === void 0) { value = true; }
        if (!dependency_utils_1.depsProvided(this, "setBodyAsDialogRoot", arguments))
            return;
        var prevBodyRoot = this._dialogRoot;
        if (value) {
            this._dialogRoot = document.body;
        }
        else {
            this._dialogRoot = this.container;
        }
        if (prevBodyRoot) {
            if (this.blockerElem.parentNode === prevBodyRoot)
                prevBodyRoot.removeChild(this.blockerElem);
            if (this.blockerElem.className.indexOf("fixed") !== -1) {
                this.blockerElem.className = this.blockerElem.className.replace(" fixed", "");
            }
            (_a = this._openDialogs) === null || _a === void 0 ? void 0 : _a.forEach(function (elem) {
                _this._dialogRoot.appendChild(elem);
            });
        }
        this._dialogRoot.appendChild(this.blockerElem);
        if (value)
            this.blockerElem.className = this.blockerElem.className + " fixed";
    };
    LajiMap.prototype.shouldNotPreventScrolling = function () {
        return !!(this.drawing || this._LTEditPointIdxTuple);
    };
    LajiMap.prototype.setClickBeforeZoomAndPan = function (value) {
        var _this = this;
        if (value === void 0) { value = true; }
        if (!dependency_utils_1.depsProvided(this, "setClickBeforeZoomAndPan", arguments))
            return;
        if (this.viewLocked && value) {
            return;
        }
        var valueWas = this._clickBeforeZoomAndPan;
        this._clickBeforeZoomAndPan = value;
        var isOutsideLajiMap = function (elem) {
            return document.body.contains(elem)
                && !_this.container.contains(elem)
                && elem !== _this.blockerElem
                && (!_this._openDialogs.length || _this._openDialogs.every(function (dialog) { return !dialog.contains(elem); }));
        };
        var translationHook = undefined;
        this._scrollPreventElem = this._scrollPreventElem || document.createElement("div");
        this._scrollPreventTextElemContainer = this._scrollPreventTextElemContainer || document.createElement("div");
        this._scrollPreventTextElem = this._scrollPreventTextElem || document.createElement("span");
        this._scrollPreventTextElemContainer.appendChild(this._scrollPreventTextElem);
        this._scrollPreventElem.className = "laji-map-scroll-prevent left";
        this._scrollPreventTextElemContainer.className = "laji-map-scroll-prevent text-container left";
        translationHook = this.addTranslationHook(this._scrollPreventTextElem, "ClickBeforeZoom");
        this._showingPreventScroll = false;
        if (!this._preventScrolling) {
            this._preventScrolling = function () {
                if (_this.shouldNotPreventScrolling())
                    return;
                _this.map.smoothWheelZoom.disable();
                _this.map.dragging.disable();
                _this._preventScroll = true;
            };
        }
        if (!this._startPreventScrollingTimeout) {
            this._startPreventScrollingTimeout = function () {
                clearTimeout(_this._showPreventShowTimeout);
                _this._showPreventShowTimeout = setTimeout(function () {
                    _this._preventScrolling();
                }, 10000);
            };
        }
        var showPreventElem = function () {
            var showingAlready = _this._showingPreventScroll;
            _this._showingPreventScroll = true;
            if (!showingAlready) {
                [].forEach.call(document.querySelectorAll(".laji-map-scroll-prevent"), function (elem) { return elem.className = elem.className.replace("left", "enter"); });
                setTimeout(function () {
                    [].forEach.call(document.querySelectorAll(".laji-map-scroll-prevent"), function (elem) { return elem.className = elem.className.replace(" enter", ""); });
                });
            }
            clearTimeout(_this._showPreventHideTimeout);
            clearTimeout(_this._showPreventShowTimeout);
            clearTimeout(_this._showPreventAnimationTimeout);
            _this._showPreventHideTimeout = setTimeout(function () {
                if (!document.body.contains(_this._scrollPreventElem))
                    return;
                hidePreventElem();
            }, 2000);
            [].forEach.call(document.querySelectorAll(".laji-map-scroll-prevent"), function (elem) { return elem.style.display = "block"; });
        };
        var hidePreventElem = function () {
            if (!_this._showingPreventScroll)
                return;
            clearTimeout(_this._showPreventHideTimeout);
            clearTimeout(_this._showPreventShowTimeout);
            clearTimeout(_this._showPreventAnimationTimeout);
            [].forEach.call(document.querySelectorAll(".laji-map-scroll-prevent"), function (elem) { return elem.className = elem.className + " leaving"; });
            _this._showPreventAnimationTimeout = setTimeout(function () {
                _this._showingPreventScroll = false;
                [].forEach.call(document.querySelectorAll(".laji-map-scroll-prevent"), function (elem) { return elem.className = elem.className.replace("leaving", "left"); });
                _this._startPreventScrollingTimeout();
            }, 200); // Should match transition time in css
        };
        var _onTouchOrMouseEventAgnostic = function (isOutside) {
            _this._startPreventScrollingTimeout();
            if (!_this._preventScroll && isOutside) {
                _this._preventScrolling();
            }
            else if (_this._preventScroll && !isOutside && !_this.viewLocked) {
                _this.map.smoothWheelZoom.enable();
                _this.map.dragging.enable();
                hidePreventElem();
                _this._preventScroll = false;
                return true;
            }
        };
        var onTouchOrMouse = function (touch) { return function (e) {
            if (touch)
                e.stopPropagation();
            var enabled = _onTouchOrMouseEventAgnostic(isOutsideLajiMap(e.target));
            if (enabled && !touch) {
                _this.map.dragging._draggable._onDown(e);
            }
        }; };
        if (!this._onTouchPreventScrolling) {
            this._onTouchPreventScrolling = onTouchOrMouse(!!"touch");
            this._onMouseDownPreventScrolling = onTouchOrMouse(!"mouse");
            this._onControlClickPreventScrolling = function () { return _onTouchOrMouseEventAgnostic(false); };
            this._onDrawStartPreventScrolling = function () { return !_this.viewLocked && _this.map.dragging.disable(); };
            this._onDrawStopPreventScrolling = function () { return !_this.viewLocked && _this.map.dragging.enable(); };
        }
        if (this._preventScrollDomCleaner) {
            this._removeDomCleaner(this._preventScrollDomCleaner);
        }
        this._preventScrollDomCleaner = function () {
            if (_this._preventScrollDomCleaner) {
                _this._removeDomCleaner(_this._preventScrollDomCleaner);
            }
            _this._preventScrollDomCleaner = undefined;
            clearTimeout(_this._showPreventHideTimeout);
            clearTimeout(_this._showPreventShowTimeout);
            clearTimeout(_this._showPreventAnimationTimeout);
            document.removeEventListener("touch", _this._onTouchPreventScrolling);
            document.removeEventListener("mousedown", _this._onMouseDownPreventScrolling);
            _this.map.removeEventListener("zoomstart", _this._startPreventScrollingTimeout);
            _this.map.removeEventListener("controlClick", _this._onControlClickPreventScrolling);
            _this.map.removeEventListener("draw:drawstart", _this._onDrawStartPreventScrolling);
            _this.map.removeEventListener("draw:drawstop", _this._onDrawStopPreventScrolling);
            var scrollPreventElemParent = _this._scrollPreventElem.parentNode;
            if (scrollPreventElemParent)
                scrollPreventElemParent.removeChild(_this._scrollPreventElem);
            _this._scrollPreventElem = undefined;
            var scrollPreventTextElemContainerParent = _this._scrollPreventTextElemContainer.parentNode;
            if (scrollPreventTextElemContainerParent) {
                scrollPreventTextElemContainerParent.removeChild(_this._scrollPreventTextElemContainer);
            }
            _this._scrollPreventTextElemContainer = undefined;
            (_this._scrollPreventScrollListeners || []).forEach(function (_a) {
                var name = _a[0], fn = _a[1];
                return window.removeEventListener(name, fn);
            });
            _this._scrollPreventScrollListeners = undefined;
            !_this.viewLocked && _this.map.smoothWheelZoom.enable();
            !_this.viewLocked && _this.map.dragging.enable();
        };
        if (value && !valueWas) {
            this._preventScrolling();
            document.addEventListener("touch", this._onTouchPreventScrolling);
            document.addEventListener("mousedown", this._onMouseDownPreventScrolling);
            this.map.addEventListener("controlClick", this._onControlClickPreventScrolling);
            this._scrollPreventScrollListeners = [];
            "wheel touchstart".split(" ").forEach(function (eventName) {
                var eventListener = function (e) {
                    var coordinatesSource = eventName === "touchstart" ? e.touches[0] : e;
                    var pointedElem = document.elementFromPoint(coordinatesSource.clientX, coordinatesSource.clientY);
                    var isOutside = isOutsideLajiMap(pointedElem);
                    if (_this._preventScroll && !isOutside) {
                        _this.removeTranslationHook(translationHook);
                        translationHook = _this.addTranslationHook(_this._scrollPreventTextElem, "ClickBefore" + (eventName === "wheel" ? "Zoom" : "Pan"));
                        showPreventElem();
                    }
                    else {
                        _this._startPreventScrollingTimeout();
                    }
                };
                window.addEventListener(eventName, eventListener);
                _this._scrollPreventScrollListeners.push([eventName, eventListener]);
                _this.map.addEventListener("zoomstart", _this._startPreventScrollingTimeout);
            });
            this.container.appendChild(this._scrollPreventElem);
            this.container.appendChild(this._scrollPreventTextElemContainer);
            this.map.addEventListener("draw:drawstart", this._onDrawStartPreventScrolling);
            this.map.addEventListener("draw:drawstop", this._onDrawStopPreventScrolling);
            this._addDomCleaner(this._preventScrollDomCleaner);
        }
        else if (!value && valueWas) {
            if (this._preventScrollDomCleaner)
                this._preventScrollDomCleaner();
        }
    };
    LajiMap.prototype.getMMLProj = function () {
        return this.mmlProj;
    };
    LajiMap.prototype._initializeMap = function () {
        var _this = this;
        try {
            if (!dependency_utils_1.depsProvided(this, "_initializeMap", arguments))
                return;
            L.Icon.Default.imagePath = "https://cdnjs.cloudflare.com/ajax/libs/leaflet/0.7.7/images/";
            this.map = L.map(this.mapElem, __assign({ contextmenu: true, contextmenuItems: [], zoomControl: false, attributionControl: false, doubleClickZoom: false, zoomSnap: 0, maxZoom: 19, zoom: this.zoom, center: this.center, scrollWheelZoom: false, smoothWheelZoom: true, smoothSensitivity: 3 }, this.leafletOptions));
            this.mmlProj = new L.Proj.CRS("EPSG:3067", globals_1.EPSG3067String, {
                origin: [-548576, 8388608],
                bounds: L.bounds([-548576, 8388608], [1548576, 6291456]),
                resolutions: [
                    8192, 4096, 2048, 1024, 512, 256,
                    128, 64, 32, 16, 8, 4, 2, 1, 0.5,
                    0.25, 0.125, 0.0625, 0.03125, 0.015625
                ],
            });
            // Scale controller won't work without this hack.
            // Fixes also circle projection.
            this.mmlProj.distance = L.CRS.Earth.distance;
            this.mmlProj.R = 6378137;
            this.finnishTileLayers = {};
            var getAttribution = function (link, text) { return "<a href=\"" + link + "\" target=\"_blank\" rel=\"noopener noreferrer\">&copy; " + text + "</a>"; };
            var mmlAttribution_1 = getAttribution("https://www.maanmittauslaitos.fi/avoindata_lisenssi_versio1_20120501", "Maanmittauslaitos");
            var sykeAttribution = getAttribution("https://www.syke.fi/fi-FI/Avoin_tieto/Kayttolupa_ja_vastuut", "SYKE");
            var getMMLLayer = function (name, options) {
                if (options === void 0) { options = { format: "png" }; }
                return L.tileLayer("https://proxy.laji.fi/mml_wmts/maasto/wmts/1.0.0/" + name + "/default/ETRS-TM35FIN/{z}/{y}/{x}." + options.format, __assign(__assign({}, options), { style: "default", minZoom: 0, maxZoom: 15, version: "1.0.0", format: "image/" + options.format, transparent: false, attribution: mmlAttribution_1 }));
            };
            this.finnishTileLayers = __assign(__assign({}, this.finnishTileLayers), { pohjakartta: L.tileLayer.wms("https://avaa.tdata.fi/geoserver/osm_finland/gwc/service/wms?", {
                    layers: "osm_finland:Sea",
                    maxZoom: 14,
                    format: "image/png",
                    transparent: false,
                    version: "1.1.0",
                    attribution: mmlAttribution_1
                }), taustakartta: getMMLLayer("taustakartta"), maastokartta: getMMLLayer("maastokartta"), ortokuva: getMMLLayer("ortokuva", { format: "jpg", maxZoom: 14 }), laser: L.tileLayer("https://wmts.mapant.fi/wmts.php?z={z}&x={x}&y={y}", {
                    maxZoom: 19,
                    minZoom: 0,
                    tileSize: 256,
                    attribution: mmlAttribution_1 + ", " + getAttribution("https://www.mapant.fi", "Mapant")
                }), ykjGrid: L.tileLayer.wms("https://maps.luomus.fi/geoserver/atlas/wms", {
                    maxZoom: 15,
                    layers: "atlas:YKJ_ETRS_LINE100,atlas:YKJ_ETRS_LINE1000,atlas:YKJ_ETRS_LINE10000,atlas:YKJ_ETRS_LINE100000",
                    format: "image/png",
                    transparent: true,
                    version: "1.1.0",
                }), ykjGridLabels: L.tileLayer.wms("https://maps.luomus.fi/geoserver/atlas/wms", {
                    maxZoom: 15,
                    layers: "atlas:YKJ_ETRS_LABEL1000,atlas:YKJ_ETRS_LABEL10000,atlas:YKJ_ETRS_LABEL100000",
                    format: "image/png",
                    transparent: true,
                    version: "1.1.0",
                }) });
            this.worldTileLayers = {
                openStreetMap: L.tileLayer("https://proxy.laji.fi/osm/{z}/{x}/{y}.png", {
                    attribution: getAttribution("https://osm.org/copyright", "OpenStreetMap contributors")
                }),
                googleSatellite: L.tileLayer("https://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}", {
                    subdomains: ["mt0", "mt1", "mt2", "mt3"],
                    attribution: getAttribution("https://developers.google.com/maps/terms", "Google")
                })
            };
            this.tileLayers = __assign(__assign({}, this.finnishTileLayers), this.worldTileLayers);
            this.availableTileLayers = this.tileLayers;
            this.overlaysByNames = {
                geobiologicalProvinces: L.tileLayer.wms("https://maps.luomus.fi/geoserver/ows", {
                    maxZoom: 15,
                    layers: "INSPIRE:fi_fmnh_br_extended",
                    format: "image/png",
                    transparent: true,
                    version: "1.3.0",
                    defaultOpacity: 0.5
                }),
                geobiologicalProvinceBorders: L.tileLayer.wms("https://maps.luomus.fi/geoserver/INSPIRE/wms", {
                    maxZoom: 15,
                    layers: "INSPIRE:fi_fmnh_br",
                    styles: "harmaaviiva",
                    format: "image/png",
                    transparent: true,
                    version: "1.1.0",
                }),
                municipalities: L.tileLayer.wms("https://geo.stat.fi/geoserver/tilastointialueet/wms", {
                    layers: "kunta1000k_2018",
                    transparent: true,
                    format: "image/png",
                    attribution: getAttribution("https://www.stat.fi/org/lainsaadanto/copyright.html", "Tilastokeskus")
                }),
                forestVegetationZones: L.tileLayer.wms("https://paikkatieto.ymparisto.fi/arcgis/services/INSPIRE/SYKE_EliomaantieteellisetAlueet/MapServer/WmsServer", {
                    maxZoom: 15,
                    layers: "br.Metsakasvillisuusvyohykkeet",
                    format: "image/png",
                    transparent: true,
                    version: "1.3.0",
                    defaultOpacity: 0.5,
                    attribution: sykeAttribution
                }),
                mireVegetationZones: L.tileLayer.wms("https://paikkatieto.ymparisto.fi/arcgis/services/INSPIRE/SYKE_EliomaantieteellisetAlueet/MapServer/WmsServer", {
                    maxZoom: 15,
                    layers: "br.Suokasvillisuusvyohykkeet",
                    format: "image/png",
                    transparent: true,
                    version: "1.3.0",
                    defaultOpacity: 0.5,
                    attribution: sykeAttribution
                }),
                threatenedSpeciesEvaluationZones: L.tileLayer.wms("https://maps.luomus.fi/geoserver/Vyohykejaot/wms", {
                    maxZoom: 15,
                    layers: "Vyohykejaot:Metsakasvillisuusvyohykkeet_Uhanalaisarviointi",
                    format: "image/png",
                    transparent: true,
                    version: "1.1.0",
                    attribution: sykeAttribution
                }),
                biodiversityForestZones: L.tileLayer.wms("https://paikkatieto.ymparisto.fi/arcgis/services/SYKE/SYKE_MonimuotoisuudelleTarkeatMetsaalueetZonation/MapServer/WmsServer", {
                    maxZoom: 15,
                    layers: "8",
                    defaultOpacity: 0.5,
                    attribution: sykeAttribution
                })
            };
            var combined_1 = __assign(__assign({}, this.tileLayers), this.overlaysByNames);
            Object.keys(combined_1).forEach(function (name) {
                combined_1[name].setZIndex(_this._tileLayerOrder.indexOf(name));
            });
            this.availableOverlaysByNames = this.overlaysByNames;
            if (this.locateOptions && this.locateOptions.on) {
                this._setLocateOn();
            }
            this._initializeMapEvents();
            this.idxsToIds = [];
            this.idsToIdxs = [];
            this.idsToIdxTuples = {};
            this._idxsToHovered = {};
            this._idxsToContextMenuOpen = {};
            dependency_utils_1.provide(this, "map");
        }
        catch (e) {
            if (e._lajiMapError) {
                this._showError(e);
            }
            else {
                throw e;
            }
        }
    };
    LajiMap.prototype._initializeView = function () {
        var _a, _b;
        if (!dependency_utils_1.depsProvided(this, "_initializeView", arguments))
            return;
        this._viewCriticalSection++;
        var tileLayerOptions;
        if (this.options.tileLayers) {
            tileLayerOptions = this.options.tileLayers;
        }
        else if (this.options.tileLayerName) {
            tileLayerOptions = { layers: (_a = {}, _a[this.options.tileLayerName] = true, _a) };
        }
        else {
            tileLayerOptions = { layers: (_b = {}, _b[DEFAULT_LAYER_NAME] = true, _b) };
        }
        tileLayerOptions = this._getInternalTileLayerOptions(tileLayerOptions);
        var center, bounds;
        if (this.options.zoomToData) {
            bounds = this.getBoundsForZoomToDataOptions(this.options.zoomToData);
            if (bounds.isValid()) {
                center = bounds.getCenter();
            }
            else {
                bounds = undefined;
            }
        }
        if (!center) {
            center = this.options.center;
        }
        if (tileLayerOptions.active === "finnish" && this._isOutsideFinland(center)) {
            tileLayerOptions.active = "world";
        }
        this._trySwapToFinnishOnInitialization = this._isOutsideFinland(center);
        this.setTileLayers(tileLayerOptions);
        if (bounds) {
            this.zoomToData(this.options.zoomToData);
        }
        else {
            this.map.setView(this.center, this.getDenormalizedZoom(this.zoom), { animate: false });
        }
        dependency_utils_1.provide(this, "view");
        this.reorderData();
        this._viewCriticalSection--;
    };
    LajiMap.prototype._isOutsideFinland = function (latLng) {
        return !L.latLngBounds(globals_1.FINLAND_BOUNDS).contains(latLng);
    };
    LajiMap.prototype._swapToWorldOutsideFinland = function (latLng) {
        var _this = this;
        if (!dependency_utils_1.depsProvided(this, "_swapToWorldOutsideFinland", arguments))
            return;
        if (Object.keys(this.worldTileLayers).some(function (name) { return !!_this.availableTileLayers[name]; })
            && this._isOutsideFinland(latLng)) {
            this._swapToWorldFlag = true;
            var options = void 0;
            var someWorldMapVisible = Object.keys(this.worldTileLayers).some(function (name) {
                return !!_this._tileLayers.layers[name].visible;
            });
            if (someWorldMapVisible) {
                options = __assign(__assign({}, this._tileLayers), { active: "world" });
            }
            else {
                options = __assign(__assign({}, this._tileLayers), { layers: __assign(__assign({}, this._tileLayers.layers), { openStreetMap: true }), active: "world" });
            }
            this.setTileLayers(options);
        }
    };
    LajiMap.prototype._initializeMapEvents = function () {
        var _this = this;
        if (!dependency_utils_1.depsProvided(this, "_initializeMapEvents", arguments))
            return;
        this.map.addEventListener({
            // We have to handle dblclick zoom manually, since the default event can't be cancelled.
            "dblclick": function (e) {
                setTimeout(function () {
                    if (_this._disableDblClickZoom)
                        return;
                    var oldZoom = _this.map.getZoom();
                    var delta = _this.map.options.zoomDelta;
                    var zoom = e.originalEvent.shiftKey ? oldZoom - delta : oldZoom + delta;
                    _this.map.setZoomAround(e.containerPoint, zoom);
                });
            },
            "click": function () { return _this._interceptClick(); },
            "mousemove": function (_a) {
                var latlng = _a.latlng;
                _this._mouseLatLng = latlng;
            },
            "draw:created": function (_a) {
                var layer = _a.layer;
                return _this._onAdd(_this.drawIdx, layer);
            },
            "draw:drawstart": function () {
                _this.drawing = true;
                _this.map.fire("controlClick", { name: "draw" });
            },
            "draw:drawstop": function () { _this.drawing = false; },
            "draw:drawvertex": function (e) {
                var layers = e.layers.getLayers();
                var keys = Object.keys(layers);
                var latlng = layers[keys[keys.length - 1]].getLatLng();
                var _a = _this.map.latLngToContainerPoint(latlng), x = _a.x, y = _a.y;
                var _b = _this.rootElem.getBoundingClientRect(), width = _b.width, height = _b.height;
                var treshold = Math.min(width, height) / 4;
                if ([y, y - height, x, x - width].some(function (dist) { return Math.abs(dist) < treshold; })) {
                    _this.map.panTo(latlng);
                }
            },
            "locationfound": function (e) { return _this._onLocationFound(e); },
            "locationerror": function (e) { return _this._onLocationNotFound(e); },
            "contextmenu.show": function (e) {
                if (e.relatedTarget) {
                    _this._contextMenuLayer = e.relatedTarget;
                    var tuple = _this._getIdxTupleByLayer(_this._contextMenuLayer);
                    if (tuple) {
                        var dataIdx = tuple[0], featureIdx = tuple[1];
                        if (_this.data[dataIdx] && _this.data[dataIdx].editable) {
                            _this._idxsToContextMenuOpen[dataIdx][featureIdx] = true;
                            _this.updateLayerStyle(e.relatedTarget);
                        }
                    }
                }
                _this._interceptClick();
            },
            "contextmenu.hide": function () {
                var contextMenuLayer = _this._contextMenuLayer;
                _this._contextMenuLayer = undefined;
                if (!contextMenuLayer)
                    return;
                var tuple = _this._getIdxTupleByLayer(contextMenuLayer);
                if (tuple) {
                    var dataIdx = tuple[0], featureIdx = tuple[1];
                    if (_this.data[dataIdx] && _this.data[dataIdx].editable) {
                        _this._idxsToContextMenuOpen[dataIdx][featureIdx] = false;
                        _this.updateLayerStyle(contextMenuLayer);
                    }
                }
                _this.map.fire("mousemove", { latlng: _this._mouseLatLng });
            },
            "moveend": function () {
                if (_this._viewCriticalSection) {
                    return;
                }
                if (_this._swapToWorldFlag) {
                    _this._swapToWorldFlag = false;
                    return;
                }
                _this._swapToWorldOutsideFinland(_this.map.getCenter());
            }
        });
        this._addDocumentEventListener("click", function (e) {
            if (e.target !== _this.rootElem && !_this.rootElem.contains(e.target)) {
                _this._interceptClick();
            }
        });
        this._addDocumentEventListener("keydown", function (e) { return _this.keyHandlerForType("keydown", e); });
        this._addDocumentEventListener("keyup", function (e) { return _this.keyHandlerForType("keyup", e); });
    };
    LajiMap.prototype.keyHandlerForType = function (type, e) {
        e = e || window.event;
        var key = "key" in e ? e.key : e.keyCode;
        var isEscape = ["Escape", "Esc", 27].includes(key);
        if (isEscape) {
            key = globals_1.ESC;
        }
        if (this._triggerKeyEvent(key.toLowerCase(), e, type)) {
            e.preventDefault();
            e.stopPropagation();
            e.stopImmediatePropagation();
            return true;
        }
    };
    LajiMap.prototype._addDocumentEventListener = function (type, fn) {
        if (!this._documentEvents)
            this._documentEvents = {};
        this._documentEvents[type] = fn;
        document.addEventListener(type, fn);
    };
    LajiMap.prototype._addKeyListener = function (key, fn, type) {
        if (type === void 0) { type = "keydown"; }
        if (!this._keyListeners[type])
            this._keyListeners[type] = {};
        if (!this._keyListeners[type][key])
            this._keyListeners[type][key] = [];
        this._keyListeners[type][key] = __spreadArrays([fn], this._keyListeners[type][key]);
    };
    LajiMap.prototype._removeKeyListener = function (key, fn, type) {
        var _a, _b;
        if (type === void 0) { type = "keydown"; }
        var index = (_b = (_a = this._keyListeners[type]) === null || _a === void 0 ? void 0 : _a[key]) === null || _b === void 0 ? void 0 : _b.indexOf(fn);
        if (index >= 0) {
            this._keyListeners[type][key].splice(index, 1);
        }
    };
    LajiMap.prototype._triggerKeyEvent = function (key, e, type) {
        var _a;
        for (var _i = 0, _b = ((_a = this._keyListeners[type]) === null || _a === void 0 ? void 0 : _a[key]) || []; _i < _b.length; _i++) {
            var fn = _b[_i];
            var result = fn(e);
            if (result !== false) {
                return true;
            }
        }
    };
    LajiMap.prototype.setEventListeners = function (eventListeners) {
        var _this = this;
        if (!dependency_utils_1.depsProvided(this, "setEventListeners", arguments))
            return;
        if (!eventListeners)
            return;
        Object.keys(this._listenedEvents || {}).forEach(function (name) {
            _this.map.removeEventListener(name, _this._listenedEvents[name]);
        });
        this._listenedEvents = eventListeners;
        this.map.addEventListener(eventListeners);
    };
    LajiMap.prototype._getDefaultCRSLayers = function () {
        return [
            this.tileLayers.openStreetMap,
            this.tileLayers.googleSatellite,
        ];
    };
    LajiMap.prototype._getMMLCRSLayers = function () {
        return [
            this.tileLayers.maastokartta,
            this.tileLayers.taustakartta,
            this.tileLayers.pohjakartta,
            this.tileLayers.ortokuva,
            this.tileLayers.laser
        ];
    };
    LajiMap.prototype.setTileLayerByName = function (name) {
        if (!dependency_utils_1.depsProvided(this, "setTileLayerByName", arguments))
            return;
        if (!this._initialized && this._tileLayersSet) {
            return;
        }
        this.setTileLayer(this.tileLayers[name]);
    };
    LajiMap.prototype._getListForAvailableTileLayer = function (names, condition, _tileLayers) {
        var _this = this;
        var list = names.reduce(function (_list, name) {
            _list[name] = true;
            return _list;
        }, {});
        return Object.keys(_tileLayers || this.tileLayers).reduce(function (tileLayers, name) {
            if (name in list === condition)
                tileLayers[name] = _this.tileLayers[name];
            return tileLayers;
        }, {});
    };
    LajiMap.prototype.setAvailableTileLayers = function (names, condition, _tileLayers) {
        if (!dependency_utils_1.depsProvided(this, "setAvailableTileLayers", arguments))
            return;
        this.availableTileLayers = this._getListForAvailableTileLayer(names, condition, _tileLayers);
        !dependency_utils_1.isProvided(this, "availableTileLayers") && dependency_utils_1.provide(this, "availableTileLayers");
        dependency_utils_1.isProvided(this, "tileLayer") && this.setTileLayers(this._tileLayers);
    };
    LajiMap.prototype.getDefaultTileLayerBlacklist = function () { return []; };
    LajiMap.prototype.getDefaultTileLayerWhitelist = function () { return Object.keys(this.tileLayers); };
    LajiMap.prototype.setAvailableTileLayerBlacklist = function (names) {
        if (!dependency_utils_1.depsProvided(this, "setAvailableTileLayerBlacklist", arguments))
            return;
        if (!names) {
            names = this.getDefaultTileLayerBlacklist();
        }
        this.availableTileLayersBlacklist = names;
        var layers = this._getListForAvailableTileLayer(this.availableTileLayersWhitelist || this.getDefaultTileLayerWhitelist(), true);
        this.setAvailableTileLayers(names, false, layers);
    };
    LajiMap.prototype.setAvailableTileLayerWhitelist = function (names) {
        if (!dependency_utils_1.depsProvided(this, "setAvailableTileLayerWhitelist", arguments))
            return;
        if (!names) {
            names = this.getDefaultTileLayerWhitelist();
        }
        this.availableTileLayersWhitelist = names;
        var layers = this._getListForAvailableTileLayer(this.availableTileLayersBlacklist || this.getDefaultTileLayerBlacklist(), false);
        this.setAvailableTileLayers(names, true, layers);
    };
    LajiMap.prototype.getAvailableOverlaysByNames = function () {
        return this.getAvailableLayersFor(this.overlaysByNames, this.availableOverlaysByNames);
    };
    LajiMap.prototype.getAvailableWorldTileLayers = function () {
        return this.getAvailableLayersFor(this.worldTileLayers, this.availableTileLayers);
    };
    LajiMap.prototype.getAvailableFinnishTileLayers = function () {
        return this.getAvailableLayersFor(this.finnishTileLayers, this.availableTileLayers);
    };
    LajiMap.prototype.getAvailableLayersFor = function (_layers, availables) {
        return Object.keys(_layers).reduce(function (layers, name) {
            if (availables[name]) {
                layers[name] = _layers[name];
            }
            return layers;
        }, {});
    };
    LajiMap.prototype.setTileLayer = function (layer) {
        var _a;
        var _this = this;
        var name = Object.keys(this.tileLayers).find(function (_name) {
            if (_this.tileLayers[_name] === layer) {
                return !!_name;
            }
        });
        var overlays = this.getOverlaysByName().reduce(function (_overlays, _name) {
            _overlays[_name] = _this._tileLayers.layers[_name];
            return _overlays;
        }, {});
        this.setTileLayers({ layers: __assign((_a = {}, _a[name] = { opacity: 1, visible: true }, _a), overlays) });
    };
    LajiMap.prototype.getActiveLayers = function (options) {
        var _this = this;
        var layers = options.layers, active = options.active;
        if (!active) {
            var useFinnishProj_1;
            var foundMultiple_1 = false;
            Object.keys(layers).some(function (name) {
                if (foundMultiple_1) {
                    return true;
                }
                var layerOptions = layers[name];
                var isWorldMapLayer = layerOptions.visible && _this.worldTileLayers[name];
                if (!layerOptions.visible) {
                    return;
                }
                if (useFinnishProj_1 === undefined) {
                    useFinnishProj_1 = _this.finnishTileLayers[name];
                }
                else if (useFinnishProj_1 && _this.worldTileLayers[name] || !useFinnishProj_1 && !_this.finnishTileLayers[name]) {
                    useFinnishProj_1 = true;
                    foundMultiple_1 = true;
                }
            });
            active = useFinnishProj_1 ? "finnish" : "world";
        }
        return Object.keys(layers).reduce(function (_layers, name) {
            if (layers[name].visible
                && (_this.overlaysByNames[name]
                    || active === "finnish" && _this.finnishTileLayers[name]
                    || active === "world" && _this.worldTileLayers[name])) {
                _layers[name] = layers[name];
            }
            return _layers;
        }, {});
    };
    LajiMap.prototype._getInternalTileLayerOptions = function (options) {
        var layers = options.layers, active = options.active;
        var defaultCRSLayers = this._getDefaultCRSLayers();
        var mmlCRSLayers = this._getMMLCRSLayers();
        var combinedLayers = __assign(__assign({}, this.availableTileLayers), this.availableOverlaysByNames);
        var newOptions = __assign(__assign({}, options), { layers: Object.keys(combinedLayers).reduce(function (_layers, name) {
                var layerOptions = options.layers[name];
                _layers[name] = typeof layerOptions === "boolean" || layerOptions === undefined
                    ? { opacity: layerOptions ? (combinedLayers[name].options.defaultOpacity || 1) : 0, visible: !!layerOptions }
                    : {
                        opacity: layerOptions.opacity,
                        visible: layerOptions.hasOwnProperty("visible") ? layerOptions.visible : !!layerOptions.opacity
                    };
                return _layers;
            }, {}) });
        var activeLayers = this.getActiveLayers(newOptions);
        newOptions.active = options.active
            || (Object.keys(activeLayers).length === 0 || this.finnishTileLayers[Object.keys(activeLayers)[0]]
                ? "finnish"
                : "world");
        return newOptions;
    };
    LajiMap.prototype.setTileLayers = function (options) {
        var _this = this;
        this._tileLayersSet = true;
        if (!dependency_utils_1.depsProvided(this, "setTileLayers", arguments))
            return;
        var newOptions = this._getInternalTileLayerOptions(options);
        var defaultCRSLayers = this._getDefaultCRSLayers();
        var mmlCRSLayers = this._getMMLCRSLayers();
        var combinedLayers = __assign(__assign({}, this.availableTileLayers), this.availableOverlaysByNames);
        var prevActiveLayers = this._tileLayers && this.getActiveLayers(this._tileLayers);
        var activeLayers = this.getActiveLayers(newOptions);
        var oldActive = this.activeProjName;
        newOptions.active = options.active
            || (Object.keys(activeLayers).length === 0 || this.finnishTileLayers[Object.keys(activeLayers)[0]]
                ? "finnish"
                : "world");
        var findNonOverlay = function (name) { return !!_this.finnishTileLayers[name] || !!_this.worldTileLayers[name]; };
        var layer = this.tileLayers[Object.keys(activeLayers).find(findNonOverlay)];
        // For BW compatibility.
        this.tileLayer = layer;
        var existingLayer = this._tileLayers && this.tileLayers[Object.keys(this.getActiveLayers(this._tileLayers)).find(findNonOverlay)];
        var center = this.map.getCenter();
        this.map.options.crs = defaultCRSLayers.indexOf(layer) !== -1 ? L.CRS.EPSG3857 : this.mmlProj;
        var zoom = this.map.getZoom();
        if (this.activeProjName && newOptions.active !== this.activeProjName
            && this.activeProjName !== "finnish"
            && (!layer
                || (mmlCRSLayers.indexOf(layer) !== -1 && mmlCRSLayers.indexOf(existingLayer) === -1))) {
            if (dependency_utils_1.isProvided(this, "tileLayer")) {
                zoom = zoom - 3;
            }
        }
        else if (newOptions.active !== this.activeProjName
            && this.activeProjName !== "world"
            && (!layer
                || (defaultCRSLayers.indexOf(layer) !== -1 && defaultCRSLayers.indexOf(existingLayer) === -1))) {
            zoom = zoom + 3;
        }
        this.activeProjName = newOptions.active;
        var prevOptions = this._tileLayers;
        this._tileLayers = newOptions;
        var changedLayers = Object.keys(this._tileLayers.layers).reduce(function (changed, name) {
            var activeLayer = activeLayers[name] || { visible: false, opacity: 0 };
            var prevActiveLayer = (prevActiveLayers || {})[name] || { visible: false, opacity: 0 };
            if (!prevActiveLayers
                || activeLayer.visible !== prevActiveLayer.visible
                || activeLayer.opacity !== prevActiveLayer.opacity
                || (oldActive && oldActive !== newOptions.active && _this.overlaysByNames[name])) {
                changed[name] = true;
            }
            return changed;
        }, {});
        Object.keys(changedLayers).forEach(function (name) {
            var _layer = combinedLayers[name];
            var _a = _this._tileLayers.layers[name], opacity = _a.opacity, visible = _a.visible;
            prevOptions && (!visible || !activeLayers[name]) && _this.map.hasLayer(_layer) && _layer.setOpacity(0);
            // Overlays must be reapplied if projection changed.
            oldActive && oldActive !== newOptions.active && _this.overlaysByNames[name] && _this.map.removeLayer(_layer);
            visible && activeLayers[name] && !_this.map.hasLayer(_layer) && _this.map.addLayer(_layer);
            visible && activeLayers[name] && _layer.setOpacity(opacity);
        });
        // Zoom levels behave differently on different projections.
        // We bypass the default max zoom behaviour and handle it manually
        // below.
        var maxZoom = Object.keys(activeLayers).reduce(function (_maxZoom, name) {
            if (!activeLayers[name]) {
                return;
            }
            var _layer = _this.tileLayers[name];
            return _layer && _layer.options.maxZoom < _maxZoom
                ? _layer.options.maxZoom
                : _maxZoom;
        }, 19);
        this.map.setMaxZoom(19);
        if (this.activeProjName !== oldActive) {
            // Prevent moveend event triggering layer swap, since view reset below must be ran sequentially.
            this._viewCriticalSection++;
            // Redraw all layers according to new projection.
            this.map._resetView(this.map.getCenter(), this.map.getZoom(), true);
            this.map.setView(center, zoom, { animate: false });
            this.recluster();
            this._viewCriticalSection--;
            this.map.fire("projectionChange", newOptions.active);
        }
        this.map.setMaxZoom(maxZoom);
        var currentLayerName = undefined;
        for (var tileLayerName in this.tileLayers) {
            if (this.tileLayer === this.tileLayers[tileLayerName]) {
                currentLayerName = tileLayerName;
                this.tileLayerName = currentLayerName;
            }
        }
        if (dependency_utils_1.isProvided(this, "tileLayer")) {
            this.map.fire("tileLayerChange", { tileLayerName: currentLayerName });
            this.map.fire("tileLayersChange", { tileLayers: this._tileLayers });
            this.map.fire("overlaysChange", { overlayNames: this.getOverlaysByName() });
        }
        // We need to provide before swapping, or else swapping causes callback loop since it might call this function.
        var _isProvided = dependency_utils_1.isProvided(this, "tileLayer");
        if (!_isProvided) {
            dependency_utils_1.provide(this, "tileLayer");
            this._trySwapToFinnishOnInitialization && this._swapToWorldOutsideFinland(this.map.getCenter());
        }
    };
    LajiMap.prototype.getTileLayers = function () {
        return this._tileLayers;
    };
    LajiMap.prototype.setTileLayerOpacity = function (val, triggerEvent) {
        var _a;
        if (triggerEvent === void 0) { triggerEvent = true; }
        if (!dependency_utils_1.depsProvided(this, "setTileLayerOpacity", arguments))
            return;
        if (val === undefined)
            return;
        if (!this._initialized && this.options.tileLayers) {
            return;
        }
        var initialCall = this.tileLayerOpacity === undefined;
        this.tileLayerOpacity = val;
        if (this.tileLayerName) {
            this.setTileLayers(__assign(__assign({}, this._tileLayers), { layers: __assign(__assign({}, this._tileLayers.layers), (_a = {}, _a[this.tileLayerName] = __assign(__assign({}, this._tileLayers.layers[this.tileLayerName]), { opacity: val }), _a)) }));
        }
        if (!initialCall && triggerEvent)
            this.map.fire("tileLayerOpacityChange", { tileLayerOpacity: val });
    };
    LajiMap.prototype.setOverlays = function (overlays) {
        if (overlays === void 0) { overlays = []; }
        if (!this._initialized && this.options.tileLayers) {
            return;
        }
        var bwCompatibleOverlays = __assign(__assign({}, this.overlaysByNames), { ykjGrid: this.tileLayers.ykjGrid, ykjGridLabels: this.tileLayers.ykjGridLabels });
        var uniq = function (layer) { return layer._url + JSON.stringify(layer.options) + JSON.stringify(layer.wmsParams); };
        var urlsToNames = Object.keys(bwCompatibleOverlays).reduce(function (_map, name) {
            _map[uniq(bwCompatibleOverlays[name])] = name;
            return _map;
        }, {});
        var names = overlays.reduce(function (_names, layer) {
            _names[urlsToNames[uniq(layer)]] = true;
            return _names;
        }, {});
        var changes = Object.keys(bwCompatibleOverlays).reduce(function (_names, name) {
            _names[name] = { visible: !!names[name], opacity: names[name] ? bwCompatibleOverlays[name].defaultOpacity || 1 : 0 };
            return _names;
        }, {});
        this.setTileLayers(__assign(__assign({}, this._tileLayers), { layers: __assign(__assign({}, this._tileLayers.layers), changes) }));
        dependency_utils_1.provide(this, "overlays");
    };
    // Wrapper that prevents overlay event triggering on initial call.
    LajiMap.prototype._setOverlaysByName = function (overlayNames) {
        this.setOverlaysByName(overlayNames);
    };
    LajiMap.prototype.getOverlaysByName = function () {
        var _this = this;
        return this._tileLayers ? Object.keys(this._tileLayers.layers).reduce(function (names, name) {
            if (!_this.overlaysByNames[name]) {
                return names;
            }
            var _a = _this._tileLayers.layers[name], visible = _a.visible, opacity = _a.opacity;
            if (visible && opacity) {
                names.push(name);
            }
            return names;
        }, []) : [];
    };
    LajiMap.prototype.setOverlaysByName = function (overlayNames) {
        var _this = this;
        if (overlayNames === void 0) { overlayNames = []; }
        if (!dependency_utils_1.depsProvided(this, "setOverlaysByName", arguments))
            return;
        this.setOverlays(overlayNames.map(function (name) { return _this.overlaysByNames[name] || _this.tileLayers[name]; }));
    };
    LajiMap.prototype.setAvailableOverlaysBlacklist = function (overlayNames) {
        if (!overlayNames) {
            overlayNames = [];
        }
        this.setAvailableOverlays(overlayNames, false);
    };
    LajiMap.prototype.setAvailableOverlaysWhitelist = function (overlayNames) {
        if (!dependency_utils_1.depsProvided(this, "setAvailableOverlaysWhitelist", arguments))
            return;
        if (!overlayNames) {
            overlayNames = Object.keys(this.overlaysByNames);
        }
        this.setAvailableOverlays(overlayNames, true);
    };
    LajiMap.prototype.setAvailableOverlays = function (overlayNames, condition) {
        var _this = this;
        if (overlayNames === void 0) { overlayNames = []; }
        if (!dependency_utils_1.depsProvided(this, "setAvailableOverlays", arguments))
            return;
        var list = overlayNames.reduce(function (_list, name) {
            _list[name] = true;
            return _list;
        }, {});
        this.availableOverlaysByNames = Object.keys(this.overlaysByNames).reduce(function (overlaysByNames, name) {
            if (name in list === condition)
                overlaysByNames[name] = _this.overlaysByNames[name];
            return overlaysByNames;
        }, {});
        !dependency_utils_1.isProvided(this, "availableOverlays") && dependency_utils_1.provide(this, "availableOverlays");
        dependency_utils_1.isProvided(this, "tileLayer") && this.setTileLayers(this._tileLayers);
    };
    LajiMap.prototype.getNormalizedZoom = function (zoom, tileLayer) {
        if (!zoom) {
            zoom = this.map.getZoom();
        }
        return (this._getMMLCRSLayers().indexOf(tileLayer || this.tileLayer) !== -1) ? zoom : zoom - 3;
    };
    LajiMap.prototype.getDenormalizedZoom = function (zoom, tileLayer) {
        if (typeof zoom !== "number" || isNaN(zoom)) {
            zoom = this.map.getZoom();
        }
        return this._getDefaultCRSLayers().indexOf(tileLayer || this.tileLayer) !== -1 ? zoom + 3 : zoom;
    };
    LajiMap.prototype.initZoom = function (zoom) {
        this.setNormalizedZoom(zoom);
    };
    LajiMap.prototype.setNormalizedZoom = function (zoom, options) {
        if (options === void 0) { options = { animate: false }; }
        this.zoom = zoom;
        if (!dependency_utils_1.depsProvided(this, "setNormalizedZoom", arguments)) {
            dependency_utils_1.provide(this, "zoom");
            return;
        }
        if (this.map) {
            this.map.setZoom(this.getDenormalizedZoom(this.zoom), options);
        }
        if (!dependency_utils_1.isProvided(this, "zoom"))
            dependency_utils_1.provide(this, "zoom");
    };
    LajiMap.prototype.setCenter = function (center) {
        this.center = center;
        if (!dependency_utils_1.depsProvided(this, "setCenter", arguments)) {
            dependency_utils_1.provide(this, "center");
            return;
        }
        if (this.map) {
            this.map.setView(center, this.getDenormalizedZoom(this.zoom), { animate: false });
        }
        if (!dependency_utils_1.isProvided(this, "center"))
            dependency_utils_1.provide(this, "center");
    };
    LajiMap.prototype.destroy = function () {
        var _this = this;
        this.cleanDOM();
        this.map && this.map.remove();
        this.map = null;
        if (this._documentEvents)
            Object.keys(this._documentEvents).forEach(function (type) {
                document.removeEventListener(type, _this._documentEvents[type]);
            });
    };
    LajiMap.prototype.cleanDOM = function () {
        var safeRemove = function (from, elem) { return from && elem && from.contains(elem) && from.removeChild(elem); };
        safeRemove(this.rootElem, this.container);
        safeRemove(this._dialogRoot, this.blockerElem);
        if (this._closeDialog)
            this._closeDialog();
        if (this._domCleaners) {
            this._domCleaners.forEach(function (cleaner) { return cleaner(); });
            this._domCleaners = [];
        }
    };
    LajiMap.prototype._addDomCleaner = function (fn) {
        if (!this._domCleaners)
            this._domCleaners = [];
        this._domCleaners.push(fn);
    };
    LajiMap.prototype._removeDomCleaner = function (fn) {
        if (!this._domCleaners)
            return;
        this._domCleaners = this._domCleaners.filter(function (_fn) { return _fn !== fn; });
    };
    LajiMap.prototype._constructDictionary = function () {
        function decapitalizeFirstLetter(s) {
            return s.charAt(0).toLowerCase() + s.slice(1);
        }
        var dictionaries = {};
        for (var word in translations_1.default) {
            for (var lang in translations_1.default[word]) {
                var translation = translations_1.default[word][lang];
                if (!dictionaries.hasOwnProperty(lang))
                    dictionaries[lang] = {};
                dictionaries[lang][decapitalizeFirstLetter(word)] = decapitalizeFirstLetter(translation);
                dictionaries[lang][capitalizeFirstLetter(word)] = capitalizeFirstLetter(translation);
            }
        }
        for (var lang in dictionaries) {
            var dictionary = dictionaries[lang];
            for (var key in dictionary) {
                while (dictionary[key].indexOf("$") !== -1) {
                    var keyToReplace = dictionary[key].match(/\$\w+/)[0];
                    var replaceKey = keyToReplace.substring(1);
                    dictionary[key] = dictionary[key].replace(keyToReplace, dictionary[replaceKey]);
                }
            }
        }
        this.dictionary = dictionaries;
    };
    LajiMap.prototype.setLang = function (lang, shouldProvide) {
        if (shouldProvide === void 0) { shouldProvide = true; }
        if (!dependency_utils_1.depsProvided(this, "setLang", arguments))
            return;
        if (!this.translations || this.lang !== lang) {
            this.lang = lang;
            this.translations = this.dictionary[this.lang];
            this.onSetLangHooks.forEach(function (hook) { return hook(); });
            shouldProvide && dependency_utils_1.provide(this, "translations");
        }
    };
    LajiMap.prototype.formatFeatureOut = function (feature, layer) {
        var _this = this;
        if (layer && layer instanceof L.Circle) {
            // GeoJSON circles doesn't have radius, so we extend GeoJSON.
            feature.geometry.radius = layer.getRadius();
        }
        else if (feature.geometry.type === "Polygon") {
            // If the coordinates are ordered counterclockwise, reverse them.
            var coordinates = feature.geometry.coordinates[0].slice(0);
            var isClockwise = !utils_1.coordinatesAreClockWise(coordinates);
            if (!isClockwise) {
                feature = __assign(__assign({}, feature), { geometry: __assign(__assign({}, feature.geometry), { coordinates: [coordinates.reverse()] }) });
            }
        }
        var normalizeCoordinates = function (c) {
            if (typeof c[0] === "number") {
                return _this.wrapGeoJSONCoordinate(c).map(function (_c) { return +_c.toFixed(6); });
            }
            else {
                return c.map(normalizeCoordinates);
            }
        };
        feature = utils_1.updateImmutablyRecursivelyWith(feature, function (key, value) {
            if (key === "coordinates") {
                value = normalizeCoordinates(value);
            }
            return value;
        });
        var _a = feature.properties, lajiMapIdx = _a.lajiMapIdx, properties = __rest(_a, ["lajiMapIdx"]); // eslint-disable-line
        return __assign(__assign({}, feature), { properties: properties });
    };
    LajiMap.prototype.formatFeatureIn = function (feature, idx) {
        return __assign(__assign({}, feature), { properties: __assign(__assign({}, feature.properties), { lajiMapIdx: idx }) });
    };
    LajiMap.prototype.cloneFeatures = function (features) {
        var featuresClone = [];
        for (var i = 0; i < features.length; i++) {
            var feature = features[i];
            featuresClone[i] = this.formatFeatureIn(feature, i);
        }
        return featuresClone;
    };
    LajiMap.prototype.initializeDataItem = function (options, dataIdx) {
        var _this = this;
        dataIdx = dataIdx === undefined ? this.data.length : dataIdx;
        var item = (options || {});
        var geoData = item.geoData, _item = __rest(item, ["geoData"]);
        var format = item.format || geoData ? utils_1.detectFormat(geoData) : undefined;
        var crs = item.crs || (geoData || item.featureCollection) ? utils_1.detectCRS(geoData || item.featureCollection) : "WGS84";
        if ("geoData" in item) {
            var detectedFormat = utils_1.detectFormat(geoData);
            format = detectedFormat;
            if (detectedFormat === "GeoJSON") {
                var type = geoData.type;
                if (type === "FeatureCollection" || type === "Feature") {
                    format = "GeoJSONFeatureCollection";
                }
                else {
                    format = "GeoJSONGeometryCollection";
                }
            }
            var geoJSON = utils_1.convertAnyToWGS84GeoJSON(geoData);
            try {
                item = __assign(__assign({}, _item), { featureCollection: {
                        type: "FeatureCollection",
                        features: this.cloneFeatures(utils_1.flattenMultiLineStringsAndMultiPolygons(utils_1.anyToFeatureCollection(geoJSON).features))
                    }, format: format, crs: crs });
            }
            catch (e) {
                throw new Error("Invalid geoJSON type in data[" + dataIdx + "]");
            }
            this.initializeDataItem(item, dataIdx);
            return;
            // Flatten features which have a geometry collection a geometry to features of the featureCollection
        }
        else if (item.featureCollection && item.featureCollection.features.some(function (feature) {
            return feature.geometry && feature.geometry.type === "GeometryCollection";
        })) {
            var _a = item.featureCollection, geometry = _a.geometry, _featureCollection = __rest(_a, ["geometry"]); // eslint-disable-line no-unused-vars
            item = __assign(__assign({}, item), { featureCollection: __assign(__assign({}, _featureCollection), { features: _featureCollection.features.reduce(function (features, f) {
                        if (f.geometry.type === "GeometryCollection") {
                            f.geometry.geometries.forEach(function (g) {
                                features.push({ type: "Feature", geometry: g, properties: f.properties });
                            });
                        }
                        else {
                            features.push(f);
                        }
                        return features;
                    }, []) }) });
            this.initializeDataItem(item, dataIdx);
            return;
        }
        var features = item.featureCollection && item.featureCollection.features ?
            item.featureCollection.features :
            [];
        item = __assign(__assign({ getFeatureStyle: function () { return _this._getDefaultDataStyle(item)(); }, getClusterStyle: function () { return _this._getDefaultDataClusterStyle(item)(); }, getDraftStyle: function (_dataIdx) { return _this._getDefaultDraftStyle(_dataIdx); } }, item), { featureCollection: {
                type: "FeatureCollection",
                features: this.cloneFeatures(features)
            }, hasCustomGetFeatureStyle: item.hasOwnProperty("hasCustomGetFeatureStyle")
                ? item.hasCustomGetFeatureStyle
                : !!item.getFeatureStyle, idx: dataIdx });
        item.hasActive = ("activeIdx" in item);
        this.idxsToIds[dataIdx] = {};
        this.idsToIdxs[dataIdx] = {};
        this._idxsToHovered[dataIdx] = [];
        this._idxsToContextMenuOpen[dataIdx] = [];
        if (this.data[dataIdx] && this.data[dataIdx].groupContainer) {
            this.data[dataIdx].groupContainer.clearLayers();
        }
        this._setOnChangeForItem(item, item.format, item.crs);
        this.data[dataIdx] = item;
        var layer = L.geoJSON(utils_1.convertAnyToWGS84GeoJSON(item.featureCollection), {
            pointToLayer: this._featureToLayer(item.getFeatureStyle, dataIdx),
            style: function (feature) {
                return _this._getStyleForType([dataIdx, feature.properties.lajiMapIdx]);
            },
            onEachFeature: function (feature, _layer) {
                _this._initializeLayer(_layer, [dataIdx, feature.properties.lajiMapIdx]);
            }
        });
        item.group = layer;
        item.groupContainer = layer;
        if (item.cluster) {
            item.groupContainer = L.markerClusterGroup(this.getClusterOptionsFor(item));
            item.group.addTo(item.groupContainer);
        }
        item.groupContainer.addTo(this.map);
        if (item.on)
            Object.keys(item.on).forEach(function (eventName) {
                item.group.on(eventName, function (e) {
                    var _layer = e.layer;
                    var feature = _layer.feature;
                    var idx = feature.properties.lajiMapIdx;
                    if (eventName === "click" && _this._interceptClick())
                        return;
                    item.on[eventName](e, {
                        idx: idx,
                        featureIdx: idx,
                        dataIdx: dataIdx,
                        layer: _layer,
                        feature: feature && _layer
                            ? _this.formatFeatureOut(feature, _layer)
                            : undefined
                    });
                });
            });
        item.group.on("click", function (e) {
            var lajiMapIdx = e.layer.feature.properties.lajiMapIdx;
            if (!_this._interceptClick())
                _this._onActiveChange([item.idx, lajiMapIdx]);
        });
        item.group.on("dblclick", function (e) {
            _this._disableDblClickZoom = true;
            var _layer = e.layer;
            _this._setEditable(_layer);
            setTimeout(function () {
                _this._disableDblClickZoom = false;
            }, 10);
        });
        item.group.on("mouseover", function (e) {
            var _a, _b;
            var _layer = e.layer;
            if (item.editable || item.hasActive || item.highlightOnHover) {
                var _d = _this._getIdxTupleByLayer(_layer), _dataIdx = _d[0], _featureIdx = _d[1];
                _this._idxsToHovered[_dataIdx][_featureIdx] = true;
                _this.updateLayerStyle(_layer);
            }
            if (utils_1.isObject(item.showMeasurements) && item.showMeasurements.showOnHover) {
                (_b = (_a = _layer).showMeasurements) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
        });
        item.group.on("mouseout", function (e) {
            var _a, _b;
            var _layer = e.layer;
            if (item.editable || item.hasActive || item.highlightOnHover) {
                var _d = _this._getIdxTupleByLayer(_layer), _dataIdx = _d[0], _featureIdx = _d[1];
                _this._idxsToHovered[_dataIdx][_featureIdx] = false;
                _this.updateLayerStyle(_layer);
            }
            if (utils_1.isObject(item.showMeasurements) && item.showMeasurements.showOnHover) {
                (_b = (_a = _layer).hideMeasurements) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
        });
        item.group.on("layeradd", function (e) {
            var _layer = e.layer;
            var _features = item.featureCollection.features;
            var featureIdx = _features.length - 1;
            var feature = _this.formatFeatureOut(_layer.toGeoJSON(), _layer);
            feature.properties.lajiMapIdx = featureIdx;
            _layer.feature = feature;
            if (item.cluster) {
                item.groupContainer.addLayer(_layer);
            }
            _this._initializeLayer(_layer, [dataIdx, featureIdx]);
            _this.updateLayerStyle(_layer);
        });
        item.group.on("layerremove", function (e) {
            var _layer = e.layer;
            var _a = _this._getIdxTupleByLayer(_layer), _dataIdx = _a[0], _featureIdx = _a[1];
            _this._idxsToContextMenuOpen[_dataIdx][_featureIdx] = false;
            _this._idxsToHovered[_dataIdx][_featureIdx] = false;
        });
    };
    LajiMap.prototype._getAllData = function () {
        var data = __spreadArrays(this.data);
        var draw = this.getDraw();
        if (draw) {
            data.push(draw);
        }
        return data;
    };
    LajiMap.prototype.zoomToData = function (options) {
        if (options === void 0) { options = {}; }
        if (!dependency_utils_1.depsProvided(this, "zoomToData", arguments))
            return;
        if (!options)
            return;
        if (options && !utils_1.isObject(options)) {
            options = {};
        }
        var bounds = this.getBoundsForZoomToDataOptions(options);
        if (!bounds.isValid())
            return;
        this.fitBounds(bounds, options);
    };
    LajiMap.prototype.getBoundsForZoomToDataOptions = function (options) {
        if (options === void 0) { options = {}; }
        if (options && !utils_1.isObject(options)) {
            options = {};
        }
        var _a = options, dataIdxs = _a.dataIdxs, draw = _a.draw;
        var datasToZoom = dataIdxs || draw
            ? __spreadArrays((dataIdxs || []), (draw ? [this.drawIdx] : [])) : undefined;
        return datasToZoom
            ? this.getBoundsForIdxs(datasToZoom)
            : this.getBoundsForData();
    };
    LajiMap.prototype.getBoundsForDraw = function () {
        return this.getBoundsForIdxs(this.drawIdx);
    };
    LajiMap.prototype.getBoundsForIdxs = function () {
        var _this = this;
        var idxs = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            idxs[_i] = arguments[_i];
        }
        return this.getBoundsForData(idxs.map(function (i) { return _this.data[i]; }));
    };
    LajiMap.prototype.getBoundsForData = function (datas) {
        var _this = this;
        if (!datas) {
            datas = this._getAllData();
        }
        var featureGroup = L.featureGroup(datas.filter(function (item) { return item; }).reduce(function (layers, item) {
            var newLayers = _this._mapLayersToBoundableLayers(item.group.getLayers());
            layers = __spreadArrays(layers, newLayers);
            return layers;
        }, []));
        return featureGroup.getBounds();
    };
    LajiMap.prototype.getBoundsForLayers = function (layers) {
        return L.featureGroup(this._mapLayersToBoundableLayers(layers)).getBounds();
    };
    LajiMap.prototype._mapLayersToBoundableLayers = function (layers) {
        return layers.map(function (layer) {
            if (layer instanceof L.Circle) { // getBounds fails for circles
                var _a = layer.getLatLng(), lat = _a.lat, lng = _a.lng;
                var polygonGeoJSON = utils_1.circleToPolygon([lng, lat], layer.getRadius(), 4);
                return L.polygon(polygonGeoJSON.coordinates[0].map(function (c) { return c.slice(0).reverse(); }));
            }
            return layer;
        });
    };
    LajiMap.prototype._initializeLayer = function (layer, idxTuple) {
        this._setIdForLayer(layer, idxTuple);
        this._initializePopup(layer);
        this._initializeTooltip(layer);
        this._updateContextMenuForLayer(layer);
        if (isPolyline(layer))
            this._decoratePolyline(layer);
        var item = this.data[idxTuple[0]];
        if (item.showMeasurements
            && !(utils_1.isObject(item.showMeasurements) && item.showMeasurements.showOnHover)) {
            layer.options.showMeasurements = true;
        }
    };
    LajiMap.prototype.fitBounds = function (_bounds, options) {
        if (options === void 0) { options = {}; }
        var bounds = L.latLngBounds(_bounds);
        if (!bounds.isValid())
            return;
        var paddingInMeters = options.paddingInMeters;
        if (paddingInMeters) {
            bounds = L.latLngBounds(bounds.getSouthWest().toBounds(paddingInMeters).getSouthWest(), bounds.getNorthEast().toBounds(paddingInMeters).getNorthEast());
        }
        var minZoom = options.minZoom, maxZoom = options.maxZoom, _options = __rest(options, ["minZoom", "maxZoom"]);
        this._swapToWorldOutsideFinland(bounds.getCenter());
        this.map.fitBounds(bounds, _options);
        if (options.hasOwnProperty("maxZoom")) {
            if (this.getNormalizedZoom() > maxZoom)
                this.setNormalizedZoom(maxZoom);
        }
        if (options.hasOwnProperty("minZoom")) {
            if (this.getNormalizedZoom() < minZoom)
                this.setNormalizedZoom(minZoom);
        }
    };
    LajiMap.prototype.setData = function (data) {
        var _this = this;
        if (!dependency_utils_1.depsProvided(this, "setData", arguments))
            return;
        if (!this.data) {
            this.data = [];
        }
        else {
            this.data.forEach(function (item, idx) {
                (idx !== _this.drawIdx && item) && item.groupContainer.clearLayers();
            });
            var draw = this.getDraw();
            this.data = [];
            if (draw) {
                this.data[this.drawIdx] = draw;
            }
        }
        if (!Array.isArray(data))
            data = [data];
        data.forEach(function (item, idx) { return (idx !== _this.drawIdx) && _this.updateData(idx, item); });
        this.reorderData();
        dependency_utils_1.provide(this, "data");
    };
    LajiMap.prototype.addData = function (items) {
        var _this = this;
        if (!items)
            return;
        if (!Array.isArray(items))
            items = [items];
        items.forEach(function (item) { return _this.initializeDataItem(item); });
    };
    LajiMap.prototype.updateData = function (dataIdx, item) {
        this.initializeDataItem(item, dataIdx);
    };
    LajiMap.prototype.updateDrawData = function (item) {
        this.updateData(this.drawIdx, this.getDrawOptions(item));
    };
    LajiMap.prototype.removeData = function (dataIdx) {
        if (this.data[dataIdx]) {
            this.data[dataIdx].groupContainer.clearLayers();
            delete this.data[dataIdx];
        }
    };
    LajiMap.prototype.getDrawOptions = function (options) {
        var _this = this;
        var drawAllowed = options !== false;
        var draw = __assign({}, this.getFeatureTypes().reduce(function (_options, key) {
            var optionValue = {};
            if (options === false || utils_1.isObject(options) && options[key] === false)
                optionValue = false;
            else if (utils_1.isObject(options) && utils_1.isObject(options[key]))
                optionValue = options[key];
            _options[key] = optionValue;
            return _options;
        }, {}));
        draw = __assign(__assign({}, draw), __assign({}, (drawAllowed ? (utils_1.isObject(options) ? options : {}) : {})));
        if (options.data) {
            console.warn("laji-map warning: draw.data is deprecated and HAS BEEN REMOVED! Please move it's content to draw");
        }
        draw = __assign({ getFeatureStyle: function () { return _this._getDefaultDrawStyle(); }, getClusterStyle: function () { return _this._getDefaultDrawClusterStyle(); }, getDraftStyle: function () { return _this._getDefaultDrawDraftStyle(); }, hasCustomGetFeatureStyle: !!draw.getFeatureStyle, editable: true }, draw);
        return draw;
    };
    LajiMap.prototype.setDraw = function (options) {
        if (!dependency_utils_1.depsProvided(this, "setDraw", arguments))
            return;
        // Using a negative idx lets us keep the original data indices.
        if (this.drawIdx === undefined)
            this.drawIdx = -1;
        this.updateDrawData(options);
        this.resetDrawUndoStack();
        this.reorderData();
        dependency_utils_1.provide(this, "draw");
    };
    LajiMap.prototype.getDraw = function () {
        return this.data[this.drawIdx];
    };
    LajiMap.prototype.drawIsAllowed = function () {
        var draw = this.getDraw();
        return this.getFeatureTypes().some(function (type) { return draw[type]; });
    };
    LajiMap.prototype.drawIsEditable = function () {
        var draw = this.getDraw();
        return this.drawIsAllowed && draw.editable;
    };
    LajiMap.prototype.resetDrawUndoStack = function () {
        this._drawHistory = [{ featureCollection: {
                    type: "FeatureCollection",
                    features: this.cloneFeatures(this.getDraw().featureCollection.features)
                } }];
        this._drawHistoryPointer = 0;
    };
    LajiMap.prototype.drawUndo = function () {
        var _this = this;
        if (this._drawHistoryPointer <= 0)
            return;
        var events = this._drawHistory[this._drawHistoryPointer].undoEvents;
        this._drawHistoryPointer--;
        var featureCollection = this._drawHistory[this._drawHistoryPointer].featureCollection;
        this.updateData(this.drawIdx, __assign(__assign({}, this.getDraw()), { featureCollection: featureCollection }));
        if (events) {
            events.some(function (e) {
                if (e.type === "active") {
                    _this.setActive(_this._getLayerByIdxTuple([_this.drawIdx, e.idx]));
                    return true;
                }
            });
            this._triggerEvent(events, this.getDraw().onChange);
        }
    };
    LajiMap.prototype.drawRedo = function () {
        var _this = this;
        if (this._drawHistoryPointer >= this._drawHistory.length - 1)
            return;
        this._drawHistoryPointer++;
        var _a = this._drawHistory[this._drawHistoryPointer], featureCollection = _a.featureCollection, events = _a.redoEvents;
        this.updateData(this.drawIdx, __assign(__assign({}, this.getDraw()), { featureCollection: featureCollection }));
        if (events) {
            events.some(function (e) {
                if (e.type === "active") {
                    _this.setActive(_this._getLayerByIdxTuple([_this.drawIdx, e.idx]));
                    return true;
                }
            });
            this._triggerEvent(events, this.getDraw().onChange);
        }
    };
    LajiMap.prototype.wrapGeoJSONCoordinate = function (_a) {
        var lng = _a[0], lat = _a[1];
        var wrapped = this.map.wrapLatLng([lat, lng]);
        return [wrapped.lng, wrapped.lat];
    };
    LajiMap.prototype._setOnChangeForItem = function (item, format, crs) {
        if (format === void 0) { format = "GeoJSON"; }
        if (crs === void 0) { crs = "WGS84"; }
        if (!dependency_utils_1.depsProvided(this, "_setOnChangeForItem", arguments))
            return;
        var convertCoordinateSystem = format === "GeoJSONFeatureCollection" || format === "GeoJSONGeometryCollection"
            ? "GeoJSON"
            : format;
        var onChange = item.onChange;
        item.onChange = function (events) {
            var _events = events.map(function (e) {
                switch (e.type) {
                    case "create":
                    case "insert":
                        var converted = utils_1.convert(e.feature, convertCoordinateSystem, crs);
                        if (converted.type === "FeatureCollection" && format === "GeoJSONGeometryCollection") {
                            converted = {
                                type: "GeometryCollection",
                                geometries: converted.features.map(function (f) { return f.geometry; })
                            };
                        }
                        e.geoData = converted;
                        break;
                    case "edit":
                        e.geoData = Object.keys(e.features).reduce(function (converted, idx) {
                            converted[idx] = utils_1.convert(e.features[idx], convertCoordinateSystem, crs);
                            if (converted[idx].type === "FeatureCollection" && format === "GeoJSONGeometryCollection") {
                                converted[idx] = converted[idx].geometry;
                            }
                            return converted;
                        }, {});
                        break;
                }
                return e;
            });
            onChange && onChange(_events);
        };
    };
    LajiMap.prototype.clearItemData = function (item, commit) {
        if (commit === void 0) { commit = true; }
        var prevFeatureCollection = {
            type: "FeatureCollection",
            features: this.cloneFeatures(this.data[item.idx].featureCollection.features)
        };
        var event = {
            type: "delete",
            idxs: Object.keys(this.idxsToIds[item.idx]).map(function (idx) { return parseInt(idx); }),
            features: this.cloneFeatures(this.data[item.idx].featureCollection.features)
        };
        commit && this._triggerEvent(event, item.onChange);
        this.updateData(item.idx, __assign(__assign({}, item), { geoData: undefined, featureCollection: { type: "FeatureCollection", features: [] } }));
        this._resetIds(item.idx);
        if (commit && item.idx === this.drawIdx)
            this._updateDrawUndoStack(event, prevFeatureCollection);
    };
    LajiMap.prototype.clearDrawData = function () {
        this.clearItemData(this.getDraw());
    };
    LajiMap.prototype._startDrawRemove = function () {
        var _this = this;
        if (this._onDrawRemove)
            return;
        this._createTooltip("RemoveFeatureOnClick");
        this._drawRemoveLayers = [];
        this._onDrawRemove = function (layer) {
            _this._drawRemoveLayers.push(layer);
            _this._removeLayerFromItem(_this.getDraw(), layer);
        };
        this.getDraw().group.on("click", function (_a) {
            var layer = _a.layer;
            return _this._onDrawRemove(layer);
        });
        this._addKeyListener(globals_1.ESC, this._stopDrawRemove);
    };
    LajiMap.prototype._stopDrawRemove = function () {
        var _this = this;
        this.getDraw().group.removeEventListener("click", function (_a) {
            var layer = _a.layer;
            return _this._onDrawRemove(layer);
        });
        this._onDrawRemove = undefined;
        this._disposeTooltip();
        this._drawRemoveLayers = undefined;
        this._removeKeyListener(globals_1.ESC, this._stopDrawRemove);
        return true;
    };
    LajiMap.prototype._finishDrawRemove = function () {
        var layers = this._drawRemoveLayers;
        this._stopDrawRemove();
        if (layers && layers.length)
            this._onDelete(this.drawIdx, layers.map(function (layer) { return L.Util.stamp(layer); }));
    };
    LajiMap.prototype._cancelDrawRemove = function () {
        var _this = this;
        var layers = this._drawRemoveLayers;
        this._stopDrawRemove();
        if (layers) {
            layers.forEach(function (layer) {
                _this.getDraw().group.addLayer(layer);
                _this.updateLayerStyle(layer);
            });
            return true;
        }
        return false;
    };
    LajiMap.prototype._onDrawReverseHandler = function (_a) {
        var layer = _a.layer;
        this._onDrawReverse(layer);
    };
    LajiMap.prototype._startDrawReverse = function () {
        var _this = this;
        if (this._onDrawReverse)
            return;
        this._createTooltip("ReverseLineOnClick");
        this._drawReverseLayers = [];
        this._onDrawReverse = function (layer) {
            if (!isPolyline(layer))
                return;
            _this._drawReverseLayers.push(layer);
            _this._reversePolyline(layer);
        };
        this.getDraw().group.on("click", this._onDrawReverseHandler);
        this._addKeyListener(globals_1.ESC, this._stopDrawReverse);
    };
    LajiMap.prototype._stopDrawReverse = function () {
        if (!this._onDrawReverse)
            return;
        this.getDraw().group.removeEventListener("click", this._onDrawReverseHandler);
        this._onDrawReverse = undefined;
        this._drawReverseLayers = undefined;
        this._disposeTooltip();
        this._removeKeyListener(globals_1.ESC, this._stopDrawReverse);
    };
    LajiMap.prototype._finishDrawReverse = function () {
        var layers = this._drawReverseLayers;
        this._stopDrawReverse();
        if (!layers || !layers.length)
            return;
        var editData = layers.reduce(function (idToLayer, layer) {
            idToLayer[L.Util.stamp(layer)] = { layer: layer };
            return idToLayer;
        }, {});
        this._onEdit(this.drawIdx, editData);
    };
    LajiMap.prototype._cancelDrawReverse = function () {
        var _this = this;
        var layers = this._drawReverseLayers;
        this._stopDrawReverse();
        if (!layers)
            return;
        layers.forEach(function (layer) {
            layer.setLatLngs(_this._origLatLngs[L.Util.stamp(layer)]);
            _this._decoratePolyline(layer);
        }, {});
        this._origLatLngs = undefined;
    };
    LajiMap.prototype._createIcon = function (options) {
        if (options === void 0) { options = {}; }
        var markerColor = options.color || globals_1.NORMAL_COLOR;
        var opacity = options.opacity || 1;
        return new L.VectorMarkers.Icon({
            prefix: "glyphicon",
            icon: "record",
            markerColor: markerColor,
            opacity: opacity
        });
    };
    LajiMap.prototype._getClusterIcon = function (data) {
        return function (cluster) {
            var childCount = cluster.getChildCount();
            var className = " marker-cluster-";
            if (childCount < 10) {
                className += "small";
            }
            else if (childCount < 100) {
                className += "medium";
            }
            else {
                className += "large";
            }
            var color = globals_1.NORMAL_COLOR;
            var opacity = 0.5;
            if (data.getClusterStyle) {
                var featureStyle = data.getClusterStyle(childCount);
                if (featureStyle.color)
                    color = featureStyle.color;
                if (featureStyle.opacity)
                    opacity = featureStyle.opacity;
            }
            var styleObject = {
                "background-color": color,
                opacity: opacity
            };
            var styleString = Object.keys(styleObject)
                .reduce(function (style, key) {
                style += key + ":" + styleObject[key] + ";";
                return style;
            }, "");
            return L.divIcon({
                html: "<div style=\"" + styleString + "\"><span>" + childCount + "</span></div>",
                className: "marker-cluster" + className,
                iconSize: new L.Point(40, 40)
            });
        };
    };
    LajiMap.prototype.setActive = function (layer) {
        var _a = this._getIdxTupleByLayer(layer), dataIdx = _a[0], featureIdx = _a[1];
        var item = this.data[dataIdx];
        if (!item.hasActive)
            return;
        var prevActiveIdx = item.activeIdx;
        item.activeIdx = featureIdx;
        var prevActiveLayer = this._getLayerByIdxTuple([dataIdx, prevActiveIdx]);
        prevActiveLayer && this.updateLayerStyle(prevActiveLayer);
        this.updateLayerStyle(layer);
    };
    LajiMap.prototype._resetIds = function (dataIdx) {
        var _this = this;
        // Maps item indices to internal ids and the other way around.
        // We use leaflet ids as internal ids.
        this.idxsToIds[dataIdx] = {};
        this.idsToIdxs[dataIdx] = {};
        var counter = 0;
        if (this.data[dataIdx].group)
            this.data[dataIdx].group.eachLayer(function (layer) {
                _this._setIdForLayer(layer, [dataIdx, counter]);
                counter++;
            });
    };
    LajiMap.prototype._setIdForLayer = function (layer, idxTuple) {
        var dataIdx = idxTuple[0], featureIdx = idxTuple[1];
        if (!this.idxsToIds[dataIdx]) {
            this.idxsToIds[dataIdx] = {};
            this.idsToIdxs[dataIdx] = {};
        }
        var id = L.Util.stamp(layer);
        this.idxsToIds[dataIdx][featureIdx] = id;
        this.idsToIdxs[dataIdx][id] = featureIdx;
        this.idsToIdxTuples[id] = [dataIdx, featureIdx];
    };
    LajiMap.prototype.recluster = function () {
        this._reclusterData();
        this._reclusterDrawData();
    };
    LajiMap.prototype._reclusterDrawData = function () {
        this._reclusterDataItem(this.getDraw());
    };
    LajiMap.prototype._reclusterData = function () {
        var _this = this;
        if (this.data)
            this.data.forEach(function (item) { return _this._reclusterDataItem(item); });
    };
    LajiMap.prototype.getClusterOptionsFor = function (item) {
        return __assign({ iconCreateFunction: this._getClusterIcon(item) }, (utils_1.isObject(item.cluster) ? item.cluster : {}));
    };
    LajiMap.prototype._reclusterDataItem = function (item) {
        if (item.cluster) {
            this.map.removeLayer(item.groupContainer);
            item.groupContainer = L.markerClusterGroup(this.getClusterOptionsFor(item)).addTo(this.map);
            item.groupContainer.addLayer(item.group);
        }
    };
    LajiMap.prototype.reorderData = function () {
        this._getAllData().forEach(function (i) { return i && i.group.bringToFront(); });
    };
    LajiMap.prototype.redrawDrawData = function () {
        this.redrawDataItem(this.drawIdx);
    };
    LajiMap.prototype.redrawDataItem = function (idx) {
        var _this = this;
        var dataItem = this.data[idx];
        if (!dataItem || !dataItem.group)
            return;
        this._updateDataLayerGroupStyle(idx);
        dataItem.group.eachLayer(function (layer) {
            _this._initializePopup(layer);
            _this._initializeTooltip(layer);
        });
    };
    LajiMap.prototype.redrawData = function () {
        var _this = this;
        this.data.forEach(function (dataItem, idx) {
            _this.redrawDataItem(idx);
        });
    };
    LajiMap.prototype.redraw = function () {
        this.redrawData();
        this.redrawDrawData();
    };
    LajiMap.prototype._initializePopup = function (layer) {
        var dataIdx = this._getIdxTupleByLayer(layer)[0];
        var item = this.data[dataIdx];
        if (!item.getPopup)
            return;
        var that = this;
        var latlng = undefined;
        function openPopup(content) {
            var _a = that._getIdxTupleByLayer(layer), _ = _a[0], featureIdx = _a[1];
            if (!latlng)
                return;
            if (that.editIdxTuple && that.editIdxTuple[0] === dataIdx && that.editIdxTuple[1] === featureIdx)
                return;
            var _b = that.markerPopupOffset, markerPopupOffset = _b === void 0 ? 40 : _b, _d = that.featurePopupOffset, featurePopupOffset = _d === void 0 ? 5 : _d;
            var offset = (layer instanceof L.Marker) ? (-markerPopupOffset || 0) : (-featurePopupOffset || 0);
            that.popup = new L.Rrose({ offset: new L.Point(0, offset), closeButton: !that.popupOnHover, autoPan: false })
                .setContent(content)
                .setLatLng(latlng)
                .openOn(that.map);
        }
        function closePopup() {
            if (latlng)
                that.map.closePopup();
            if (that.onPopupClose)
                that.onPopupClose();
            latlng = undefined;
        }
        function getContentAndOpenPopup(_latlng) {
            var _a = that._getIdxTupleByLayer(layer), _ = _a[0], featureIdx = _a[1];
            if (!that.popupCounter)
                that.popupCounter = 0;
            that.popupCounter++;
            latlng = _latlng;
            var popupCounter = that.popupCounter;
            // Allow either returning content or firing a callback with content.
            var content = item.getPopup({ dataIdx: dataIdx, featureIdx: featureIdx, feature: that.formatFeatureOut(layer.toGeoJSON(), layer), item: item }, function (callbackContent) { return that.popupCounter === popupCounter && openPopup(callbackContent); });
            content !== undefined && typeof content !== "function" && openPopup(content);
        }
        if (this.popupOnHover) {
            layer.on("mousemove", function (e) {
                latlng = e.latlng;
                if (that.popup)
                    that.popup.setLatLng(latlng);
            });
            layer.on("mouseover", function (e) {
                getContentAndOpenPopup(e.latlng);
            });
            layer.on("mouseout", function () {
                closePopup();
            });
            layer.on("remove", function () {
                closePopup();
            });
        }
        else {
            layer.on("click", function (e) {
                if (item.getPopup) {
                    closePopup();
                    getContentAndOpenPopup(e.latlng);
                }
            });
        }
    };
    LajiMap.prototype._initializeTooltip = function (layer) {
        var _this = this;
        var openTooltip = function () {
            var _a = _this._getIdxTupleByLayer(layer), dataIdx = _a[0], featureIdx = _a[1];
            var item = _this.data[dataIdx];
            if (!item.getTooltip)
                return;
            function _openTooltip(content) {
                layer.bindTooltip(content, item.tooltipOptions).openTooltip();
            }
            // Allow either returning content or firing a callback with content.
            var content = item.getTooltip({ dataIdx: dataIdx, featureIdx: featureIdx, feature: _this.formatFeatureOut(layer.toGeoJSON(), layer), item: item }, function (callbackContent) { return _openTooltip(callbackContent); });
            if (content !== undefined && typeof content !== "function")
                _openTooltip(content);
        };
        var closeTooltip = function () {
            layer.unbindTooltip();
        };
        layer.on("mouseover", function () {
            openTooltip();
        });
        layer.on("mouseout", function () {
            closeTooltip();
        });
    };
    LajiMap.prototype._updateContextMenuForLayer = function (layer) {
        var _this = this;
        if (!dependency_utils_1.depsProvided(this, "_updateContextMenuForLayer", arguments))
            return;
        var _a = this._getIdxTupleByLayer(layer), dataIdx = _a[0], featureIdx = _a[1];
        var translations = this.translations;
        layer.unbindContextMenu();
        var contextmenuItems = [];
        if (this.data[dataIdx] && this.data[dataIdx].editable) {
            contextmenuItems = [
                {
                    text: translations.EditFeature,
                    callback: function () { return _this._setEditable(layer); },
                    iconCls: "glyphicon glyphicon-pencil"
                },
                {
                    text: translations.DeleteFeature,
                    callback: function () { return _this._onDelete(dataIdx, _this.idxsToIds[dataIdx][featureIdx]); },
                    iconCls: "glyphicon glyphicon-trash"
                },
            ];
            if (isPolyline(layer)) {
                contextmenuItems.push({
                    text: translations.ReverseFeature,
                    callback: function () {
                        var _a;
                        _this._reversePolyline(layer);
                        var id = _this.idxsToIds[dataIdx][featureIdx];
                        _this._onEdit(dataIdx, (_a = {}, _a[id] = { layer: layer }, _a));
                    },
                    iconCls: "glyphicon glyphicon-sort"
                });
            }
        }
        layer.bindContextMenu({
            contextmenuInheritItems: false,
            contextmenuItems: contextmenuItems
        });
    };
    LajiMap.prototype.setLocate = function (locate) {
        if (locate === void 0) { locate = false; }
        var defaultOptions = {
            on: true,
            onLocationFound: undefined,
            onLocationError: undefined,
            userLocation: undefined,
            panOnFound: true
        };
        var options = defaultOptions;
        if (utils_1.isObject(locate)) {
            options = __assign(__assign({}, defaultOptions), locate);
        }
        else if (typeof locate === "boolean") {
            options = __assign(__assign({}, defaultOptions), { on: !!locate });
        }
        else if (Array.isArray(locate)) {
            console.warn("laji-map warning: locate signature has changed, read the README. Options in array format will be removed in the future!");
            options = __assign(__assign({}, defaultOptions), { onLocationFound: locate[0], onLocationError: locate[1], userLocation: locate[2] });
        }
        var locateOn = locate
            ? options.on
            : !!locate;
        this.locateOptions = options;
        this._locateParam = locate;
        locateOn
            ? this._setLocateOn()
            : this.userLocationMarker
                ? this.userLocationMarker.remove() && this.userLocationRadiusMarker.remove()
                : undefined;
    };
    LajiMap.prototype._setLocateOn = function (triggerEvent) {
        if (triggerEvent === void 0) { triggerEvent = false; }
        if (!dependency_utils_1.depsProvided(this, "_setLocateOn", arguments))
            return;
        var _a = this.locateOptions, on = _a.on, userLocation = _a.userLocation;
        if (on && this._located === undefined && userLocation) {
            this._onLocationFound(userLocation);
        }
        this.map.locate({ watch: true, enableHighAccuracy: true });
        triggerEvent && this.map.fire("locateToggle", { locate: typeof this._locateParam === "boolean"
                ? true
                : __assign(__assign({}, this.locateOptions), { on: true })
        });
    };
    LajiMap.prototype._setLocateOff = function () {
        if (!dependency_utils_1.depsProvided(this, "_setLocateOff", arguments))
            return;
        this.map.stopLocate();
        if (this.userLocationLayer) {
            this.userLocationLayer.remove();
            this.userLocationLayer = undefined;
            this.userLocationMarker = undefined;
            this.userLocationRadiusMarker = undefined;
        }
        var _a = this.locateOptions, on = _a.on, onLocationFound = _a.onLocationFound;
        if (on && onLocationFound)
            onLocationFound(undefined);
        this._located = false;
        this.map.fire("locateToggle", { locate: typeof this._locateParam === "boolean"
                ? false
                : __assign(__assign({}, this.locateOptions), { on: false })
        });
    };
    LajiMap.prototype._onLocationFound = function (_a) {
        var latlng = _a.latlng, accuracy = _a.accuracy, bounds = _a.bounds;
        if (!dependency_utils_1.depsProvided(this, "_onLocationFound", arguments))
            return;
        if (!this._located && bounds && this.locateOptions.panOnFound)
            this.map.fitBounds(bounds);
        this._located = true;
        if (this.userLocationLayer) {
            this.userLocationRadiusMarker.setLatLng(latlng).setRadius(accuracy);
            this.userLocationMarker.setLatLng(latlng);
        }
        else {
            var _b = this.createUserLocationLayer(latlng, accuracy), layerGroup = _b.layerGroup, markerLayer = _b.markerLayer, radiusLayer = _b.radiusLayer;
            this.userLocationLayer = layerGroup;
            this.userLocationRadiusMarker = radiusLayer;
            this.userLocationMarker = markerLayer;
            layerGroup.addTo(this.map);
        }
        this.userLocation = { latlng: latlng, accuracy: accuracy };
        if (this.locateOptions.onLocationFound)
            this.locateOptions.onLocationFound(latlng, accuracy);
    };
    LajiMap.prototype.createUserLocationLayer = function (latlng, accuracy) {
        var _this = this;
        var layerGroup = L.layerGroup();
        var radiusLayer = L.circle(latlng, {
            radius: accuracy,
            color: globals_1.USER_LOCATION_COLOR,
            fillColor: globals_1.USER_LOCATION_COLOR,
            opacity: 0
        }).addTo(layerGroup);
        var markerLayer = L.circleMarker(latlng, {
            color: globals_1.USER_LOCATION_COLOR,
            fillColor: globals_1.USER_LOCATION_COLOR,
            fillOpacity: 0.7
        }).addTo(layerGroup);
        markerLayer.on("click", function () {
            !_this._interceptClick() && _this.map.fitBounds(radiusLayer.getBounds());
        });
        return { layerGroup: layerGroup, markerLayer: markerLayer, radiusLayer: radiusLayer };
    };
    LajiMap.prototype._onLocationNotFound = function (e) {
        var onLocationError = this.locateOptions.onLocationError;
        if (onLocationError)
            onLocationError(e);
    };
    LajiMap.prototype.getDrawLayerByIdx = function (idx) {
        return this._getLayerByIdxTuple([this.drawIdx, idx]);
    };
    LajiMap.prototype.getLayerByIdxTuple = function (idxTuple) {
        var dataIdx = idxTuple[0], featureIdx = idxTuple[1];
        var item = this.data[dataIdx];
        var id = this.idxsToIds[dataIdx][featureIdx];
        return item.group ? item.group.getLayer(id) : undefined;
    };
    LajiMap.prototype._getLayerById = function (id) {
        var dataIdx = this.idsToIdxTuples[id][0];
        return this.data[dataIdx].group.getLayer(id);
    };
    LajiMap.prototype._getIdxTupleByLayer = function (layer) {
        return this.idsToIdxTuples[layer._leaflet_id];
    };
    LajiMap.prototype._getDrawLayerById = function (id) {
        return this._getLayerById(id);
    };
    LajiMap.prototype._triggerEvent = function (e, handler) {
        if (!Array.isArray(e))
            e = [e];
        if (handler)
            handler(e);
    };
    LajiMap.prototype._decoratePolyline = function (layer) {
        var _this = this;
        if (!isPolyline(layer))
            return;
        var idxTuple = this._getIdxTupleByLayer(layer);
        var dataIdx = idxTuple[0], featureIdx = idxTuple[1];
        var _a = this._fillStyleWithGlobals(idxTuple), showStart = _a.showStart, _b = _a.showDirection, showDirection = _b === void 0 ? true : _b;
        function warn() {
            console.warn("Failed to add a starting point to line");
        }
        var typelessLayer = layer;
        if (showDirection !== false) {
            var clickable = typelessLayer.clickable;
            typelessLayer.options.clickable = false;
            try {
                layer.setText(null).setText("→", { repeat: true, attributes: { "dy": 5, "font-size": 18 } });
            }
            catch (e) {
                console.warn("laji-map polyline text decorating failed");
            }
            typelessLayer.options.clickable = clickable;
        }
        if (!showStart)
            return;
        var firstPoint = undefined;
        if (!layer.feature.geometry.type) {
            warn();
            return;
        }
        switch (layer.feature.geometry.type) {
            case "MultiLineString":
                firstPoint = layer.getLatLngs()[0][0];
                break;
            case "LineString":
                firstPoint = layer.getLatLngs()[0];
                break;
            default:
                throw new Error("Tried to decorate a line layer but wasn't a line");
        }
        if (!firstPoint) {
            warn();
            return;
        }
        if (typelessLayer._startCircle) {
            typelessLayer._startCircle.remove();
        }
        typelessLayer._startCircle = L.circleMarker(firstPoint, this._getStartCircleStyle(layer)).addTo(this.map);
        layer.on("editdrag", function () {
            typelessLayer._startCircle.setLatLng(layer.getLatLngs()[0]);
        });
        layer.on("remove", function () {
            typelessLayer._startCircle.remove();
        });
        layer.on("add", function () {
            typelessLayer._startCircle.addTo(_this.map);
        });
        var bringToFront = typelessLayer.__proto__.bringToFront;
        typelessLayer.__proto__.bringToFront = function () {
            bringToFront.call(typelessLayer);
            typelessLayer._startCircle.bringToFront();
        };
    };
    LajiMap.prototype._reversePolyline = function (layer) {
        var type = layer.feature.geometry.type;
        if (type === "LineString") {
            if (!this._origLatLngs) {
                this._origLatLngs = {};
            }
            var id = L.Util.stamp(layer);
            if (!this._origLatLngs[id])
                this._origLatLngs[id] = layer.getLatLngs();
            layer.setLatLngs(layer.getLatLngs().slice(0).reverse());
            this._decoratePolyline(layer);
        }
    };
    LajiMap.prototype._getStartCircleStyle = function (lineLayer) {
        var options = __assign(__assign({}, (this.polyline || {})), lineLayer.options);
        return __assign(__assign({}, options), { weight: 0, radius: options.weight + 1, fill: true, fillOpacity: 1 });
    };
    LajiMap.prototype._updateDrawUndoStack = function (events, prevFeatureCollection, prevActiveIdx) {
        if (this._drawHistoryPointer < this._drawHistory.length - 1) {
            this._drawHistory = this._drawHistory.splice(0).splice(0, this._drawHistoryPointer + 1);
        }
        var featureCollection = {
            type: "FeatureCollection",
            features: this.cloneFeatures(this.getDraw().featureCollection.features)
        };
        var reverseEvents = [];
        (Array.isArray(events) ? events : [events]).forEach(function (e) {
            switch (e.type) {
                case "create":
                    reverseEvents.push({
                        type: "delete",
                        idxs: [featureCollection.features.length - 1]
                    });
                    break;
                case "edit":
                    reverseEvents.push({
                        type: "edit",
                        features: Object.keys(e.features).reduce(function (features, idx) {
                            features[idx] = prevFeatureCollection.features[idx];
                            return features;
                        }, {}),
                        idxs: [featureCollection.features.length - 1]
                    });
                    break;
                case "delete":
                    e.idxs.sort().reverse().forEach(function (idx) { return reverseEvents.push({
                        type: "insert",
                        idx: idx,
                        feature: prevFeatureCollection.features[idx]
                    }); });
                    break;
                case "active":
                    reverseEvents.push({
                        type: "active",
                        idx: prevActiveIdx
                    });
                    break;
            }
        });
        this._drawHistory.push({
            featureCollection: featureCollection,
            undoEvents: reverseEvents,
            redoEvents: Array.isArray(events) ? events : [events]
        });
        this._drawHistoryPointer++;
    };
    LajiMap.prototype._onAdd = function (dataIdx, layer, coordinateVerbatim) {
        var _a;
        var _b;
        if (isPolyline(layer) && layer.getLatLngs().length < 2)
            return;
        var prevActiveIdx = this.data[dataIdx].activeIdx;
        var prevFeatureCollection = {
            type: "FeatureCollection",
            features: this.cloneFeatures(this.data[dataIdx].featureCollection.features)
        };
        var item = this.data[dataIdx];
        var single = item.single, features = item.featureCollection.features;
        var feature = this.formatFeatureOut(layer.toGeoJSON(), layer);
        if (coordinateVerbatim && feature.geometry) {
            feature.geometry.coordinateVerbatim = coordinateVerbatim;
        }
        if (single && features.length > 0) {
            this.clearItemData(item, !"commit");
            item = this.data[dataIdx];
            item.featureCollection.features = [features[features.length - 1]];
            item.group.addLayer(layer);
            this._onEdit(dataIdx, (_a = {}, _a[L.Util.stamp(layer)] = { layer: layer, coordinateVerbatim: coordinateVerbatim }, _a));
            return;
        }
        features.push(feature);
        item.group.addLayer(layer);
        if (item.showMeasurements
            && !(utils_1.isObject(item.showMeasurements) && item.showMeasurements.showOnHover)) {
            (_b = layer.showMeasurements) === null || _b === void 0 ? void 0 : _b.call(layer);
        }
        var events = [
            {
                type: "create",
                feature: feature
            },
        ];
        if (item.hasActive) {
            events.push({ type: "active", idx: features.length - 1 });
        }
        this._triggerEvent(events, item.onChange);
        if (dataIdx === this.drawIdx) {
            this._updateDrawUndoStack(events, undefined, prevActiveIdx);
        }
        if (item.hasActive) {
            this.setActive(this._getLayerByIdxTuple([dataIdx, features.length - 1]));
        }
    };
    LajiMap.prototype._onEdit = function (dataIdx, data) {
        // Fix bug:
        // 1. Circle in edit mode
        // 2. Move the circle
        // 3. Open context menu for it
        // 4. Click outside circle to stop editing
        // 5. If draw onChange resets draw data, contextmenu crashes
        if (this._contextMenuLayer) {
            this.map.contextmenu.hide();
        }
        var eventData = {};
        var prevFeatureCollection = {
            type: "FeatureCollection",
            features: this.cloneFeatures(this.data[dataIdx].featureCollection.features)
        };
        for (var id in data) {
            var _a = data[id], layer = _a.layer, coordinateVerbatim = _a.coordinateVerbatim;
            var feature = this.formatFeatureOut(layer.toGeoJSON(), layer);
            if (coordinateVerbatim && feature.geometry) {
                feature.geometry.coordinateVerbatim = coordinateVerbatim;
            }
            var idx = this.idsToIdxs[dataIdx][id];
            eventData[idx] = feature;
            this.data[dataIdx].featureCollection.features[idx] = this.formatFeatureIn(feature, idx);
        }
        for (var id in data) {
            var layer = this._getLayerById(+id);
            if (layer) {
                layer.closePopup().closeTooltip();
            }
        }
        var item = this.data[dataIdx];
        var event = {
            type: "edit",
            features: eventData
        };
        this._triggerEvent(event, item.onChange);
        if (dataIdx === this.drawIdx) {
            this._updateDrawUndoStack(event, prevFeatureCollection);
        }
    };
    LajiMap.prototype._onDelete = function (dataIdx, deleteIds) {
        var _this = this;
        this._clearEditable();
        var prevFeatureCollection = {
            type: "FeatureCollection",
            features: this.cloneFeatures(this.data[dataIdx].featureCollection.features)
        };
        if (!Array.isArray(deleteIds))
            deleteIds = [deleteIds];
        var deleteIdxs = deleteIds.map(function (id) { return _this.idsToIdxs[dataIdx][id]; });
        var item = this.data[dataIdx];
        var activeIdx = item.activeIdx;
        var features = item.featureCollection.features;
        var survivingIds = Object.keys(this.idsToIdxs[dataIdx])
            .map(function (id) { return parseInt(id); }).filter(function (id) { return deleteIds.indexOf(id) === -1; });
        var changeActive = false;
        var newActiveId = undefined;
        var activeId = this.idxsToIds[dataIdx][activeIdx];
        if (item.hasActive) {
            if (features && survivingIds.length === 0) {
                changeActive = true;
            }
            else if (activeIdx !== undefined && deleteIds.indexOf(activeId) !== -1) {
                changeActive = true;
                var closestSmallerId_1 = undefined;
                var closestGreaterId_1 = undefined;
                var closestDistance_1 = undefined;
                var closestNegDistance_1 = undefined;
                survivingIds.forEach(function (id) {
                    var dist = activeIdx - _this.idsToIdxs[dataIdx][id];
                    if (dist > 0 && (closestDistance_1 === undefined || dist < closestDistance_1)) {
                        closestDistance_1 = dist;
                        closestSmallerId_1 = id;
                    }
                    else if (dist < 0 && (closestNegDistance_1 === undefined || dist > closestNegDistance_1)) {
                        closestNegDistance_1 = dist;
                        closestGreaterId_1 = id;
                    }
                });
                if (closestGreaterId_1 !== undefined)
                    newActiveId = closestGreaterId_1;
                else if (closestSmallerId_1 !== undefined)
                    newActiveId = closestSmallerId_1;
            }
            else {
                newActiveId = activeId;
                changeActive = true;
            }
        }
        var deletedFeatures = [];
        item.featureCollection.features = features.filter(function (feature, i) {
            var filter = deleteIdxs.indexOf(i) === -1;
            if (!filter) {
                deletedFeatures.push(feature);
            }
            return filter;
        });
        deleteIds.forEach(function (id) {
            _this._removeLayerFromItem(item, _this._getLayerById(id));
        });
        this._resetIds(dataIdx);
        item.group.eachLayer(function (layer) {
            _this._updateContextMenuForLayer(layer);
        });
        this._reclusterDataItem(dataIdx);
        var events = [{
                type: "delete",
                idxs: deleteIdxs,
                features: deletedFeatures
            }];
        if (changeActive) {
            events.push({ type: "active", idx: this.idsToIdxs[dataIdx][newActiveId] });
        }
        this._triggerEvent(events, item.onChange);
        if (dataIdx === this.drawIdx) {
            this._updateDrawUndoStack(events, prevFeatureCollection, newActiveId ? activeIdx : undefined);
        }
        if (changeActive) {
            this.setActive(this._getLayerByIdxTuple([dataIdx, this.idsToIdxs[dataIdx][newActiveId]]));
        }
    };
    LajiMap.prototype._removeLayerFromItem = function (item, layer) {
        if (item.group !== item.groupContainer && item.groupContainer.hasLayer(layer)) {
            item.groupContainer.removeLayer(layer);
        }
        if (item.group.hasLayer(layer)) {
            item.group.removeLayer(layer);
        }
    };
    LajiMap.prototype._onActiveChange = function (idxTuple) {
        var dataIdx = idxTuple[0], featureIdx = idxTuple[1];
        var item = this.data[dataIdx];
        if (item.hasActive) {
            this._triggerEvent({ type: "active", idx: featureIdx }, item.onChange);
            this.setActive(this._getLayerByIdxTuple(idxTuple));
        }
    };
    LajiMap.prototype.focusToLayerByIdxs = function (idxTuple) {
        var dataIdx = idxTuple[0], featureIdx = idxTuple[1];
        var id = this.idxsToIds[dataIdx][featureIdx];
        if (featureIdx === undefined) {
            return;
        }
        var layer = this._getDrawLayerById(id);
        if (!layer)
            return;
        if (layer instanceof L.Marker) {
            this.map.panTo(layer.getLatLng(), { animate: false });
        }
        else {
            this.map.fitBounds(layer.getBounds());
        }
        this._onActiveChange(idxTuple);
    };
    LajiMap.prototype.focusToDrawLayer = function (idx) {
        this.focusToLayerByIdxs([this.drawIdx, idx]);
    };
    LajiMap.prototype._setEditable = function (layer) {
        var _a = this._getIdxTupleByLayer(layer), dataIdx = _a[0], featureIdx = _a[1];
        var item = this.data[dataIdx];
        if (!item.editable || this._onDrawRemove || this._onDrawReverse)
            return;
        this._clearEditable();
        this.editIdxTuple = [dataIdx, featureIdx];
        var editLayer = this._getLayerByIdxTuple(this.editIdxTuple);
        if (item.cluster) {
            item.groupContainer.removeLayer(editLayer);
            this.map.addLayer(editLayer);
        }
        var layerOptions = editLayer.options;
        layerOptions.editing || (layerOptions.editing = {}); // See https://github.com/Leaflet/Leaflet.draw/issues/804
        layer.editing.enable();
        if (!this.map._editTooltip) {
            // For some reason editing circle radius fails without this
            this.map._editTooltip = { updateContent: function () { ; } };
        }
        editLayer.closePopup();
        this.updateLayerStyle(editLayer);
    };
    LajiMap.prototype._clearEditable = function () {
        if (this.editIdxTuple === undefined)
            return;
        var editLayer = this._getLayerByIdxTuple(this.editIdxTuple);
        editLayer.editing.disable();
        var item = this.data[this.editIdxTuple[0]];
        if (item.cluster) {
            this.map.removeLayer(editLayer);
            item.groupContainer.addLayer(editLayer);
        }
        this._reclusterDataItem(item);
        this.editIdxTuple = undefined;
    };
    LajiMap.prototype._commitEdit = function () {
        var _a;
        var editIdxTuple = this.editIdxTuple;
        var dataIdx = editIdxTuple[0], featureIdx = editIdxTuple[1];
        var editId = this.idxsToIds[dataIdx][featureIdx];
        this._clearEditable();
        var editLayer = this._getLayerByIdxTuple(editIdxTuple);
        this.updateLayerStyle(editLayer);
        this._onEdit(dataIdx, (_a = {}, _a[editId] = { layer: editLayer }, _a));
    };
    // Returns true if click was intercepted
    LajiMap.prototype._interceptClick = function () {
        if (this._onDrawRemove || this._onDrawReverse || this.drawing)
            return true;
        if (this.editIdxTuple !== undefined) {
            this._commitEdit();
            return true;
        }
        return false;
    };
    LajiMap.prototype.setLayerStyle = function (layer, style) {
        if (!layer)
            return;
        layer.setStyle(style);
        if (layer._startCircle)
            layer._startCircle.setStyle(this._getStartCircleStyle(layer));
    };
    LajiMap.prototype._featureToLayer = function (getFeatureStyle, dataIdx) {
        var _this = this;
        function reversePointCoords(coords) {
            return [coords[1], coords[0]];
        }
        return function (feature) {
            var layer;
            if (feature.geometry.type === "Point") {
                var latLng = reversePointCoords(feature.geometry.coordinates);
                var params = { feature: feature, featureIdx: feature.properties.lajiMapIdx };
                if (dataIdx !== undefined)
                    params[dataIdx] = dataIdx;
                layer = (feature.geometry.radius)
                    ? new L.Circle(latLng, feature.geometry.radius)
                    : L.marker(latLng, {
                        icon: _this._createIcon(getFeatureStyle(params))
                    });
            }
            else {
                layer = L.GeoJSON.geometryToLayer(feature);
            }
            return layer;
        };
    };
    LajiMap.prototype._getDefaultDrawDraftStyle = function () {
        return this._getStyleForType([this.drawIdx, undefined], { color: globals_1.EDITABLE_DATA_LAYER_COLOR, fillColor: globals_1.EDITABLE_DATA_LAYER_COLOR, opacity: 0.8 });
    };
    LajiMap.prototype._fillStyleWithGlobals = function (idxTuple) {
        var _this = this;
        var dataIdx = idxTuple[0], featureIdx = idxTuple[1];
        var layer = this._getLayerByIdxTuple(idxTuple);
        var item = this.data[dataIdx];
        var feature = item.featureCollection.features[featureIdx];
        var dataStyles = item.getFeatureStyle({
            dataIdx: dataIdx,
            featureIdx: featureIdx,
            feature: feature,
            item: item
        });
        var mergeOptions = function (type) {
            return __assign(__assign({}, (_this[type] || {})), (item[type] || {}));
        };
        var featureTypeStyle = undefined;
        if (layer) {
            if (layer instanceof L.Marker) {
                featureTypeStyle = mergeOptions("marker");
            }
            else if (isPolyline(layer)) {
                featureTypeStyle = mergeOptions("polyline");
            }
            else if (layer instanceof L.Rectangle) {
                featureTypeStyle = mergeOptions("rectangle");
            }
            else if (layer instanceof L.Polygon) {
                featureTypeStyle = mergeOptions("polygon");
            }
            else if (layer instanceof L.Circle) {
                featureTypeStyle = mergeOptions("circle");
            }
        }
        else {
            switch (feature.geometry.type) {
                case "LineString":
                case "MultiLineString":
                    featureTypeStyle = mergeOptions("polyline");
                    break;
                case "Polygon":
                    featureTypeStyle = mergeOptions("polygon");
                    break;
                case "Point":
                    featureTypeStyle = (feature.geometry.radius) ? mergeOptions("circle") : mergeOptions("marker");
                    break;
            }
        }
        return __assign(__assign({}, (featureTypeStyle || {})), (dataStyles || {}));
    };
    LajiMap.prototype._getStyleForType = function (idx, overrideStyles) {
        var _this = this;
        if (overrideStyles === void 0) { overrideStyles = {}; }
        var dataIdx, featureIdx;
        if (typeof idx === "number") {
            dataIdx = idx;
        }
        else {
            dataIdx = idx[0], featureIdx = idx[1];
        }
        var item = this.data[dataIdx];
        var feature = item.featureCollection.features[featureIdx];
        var active = item.activeIdx === featureIdx;
        var editing = false;
        if (this.editIdxTuple) {
            var _a = this.editIdxTuple, _dataIdx = _a[0], _featureIdx = _a[1];
            if (_dataIdx === dataIdx && _featureIdx === featureIdx) {
                editing = true;
            }
        }
        var hovered = (dataIdx !== undefined &&
            featureIdx !== undefined &&
            this._idxsToHovered[dataIdx][featureIdx]);
        var dataStyles = undefined;
        if (item.getFeatureStyle) {
            dataStyles = item.getFeatureStyle({
                dataIdx: dataIdx,
                featureIdx: featureIdx,
                feature: feature,
                item: item,
                active: active,
                editing: editing,
                hovered: hovered
            });
            if (dataStyles.color && !dataStyles.fillColor) {
                dataStyles.fillColor = dataStyles.color;
            }
        }
        else {
            dataStyles = this._fillStyleWithGlobals([dataIdx, featureIdx]);
        }
        var layer = undefined;
        if (this.idxsToIds[dataIdx])
            layer = this._getLayerByIdxTuple([dataIdx, featureIdx]);
        var isLine = (layer && isPolyline(layer)
            ||
                feature && (feature.geometry.type === "LineString" || feature.geometry.type === "MultiLineString"));
        var style = {
            opacity: 1,
            fillOpacity: 0.4,
            color: globals_1.NORMAL_COLOR,
            fillColor: globals_1.NORMAL_COLOR,
        };
        if (isLine) {
            style.weight = 10;
        }
        style = __assign(__assign(__assign({}, style), dataStyles), overrideStyles);
        var colors = [];
        if (!item.hasCustomGetFeatureStyle && active) {
            colors.push(["#00ff00", 80]);
        }
        if (!item.hasCustomGetFeatureStyle && editing) {
            var r = active ? "--" : "00";
            var b = r;
            colors.push(["#" + r + "ff" + b, 30]);
        }
        if (!item.hasCustomGetFeatureStyle && hovered) {
            colors.push(["#ffffff", 30]);
        }
        if (colors.length || this._idxsToContextMenuOpen[dataIdx][featureIdx]) {
            style = __assign({}, style);
            ["color", "fillColor"].forEach(function (prop) {
                if (style[prop]) {
                    var finalColor = undefined;
                    if (_this._idxsToContextMenuOpen[dataIdx][featureIdx] || (hovered && (_this._onDrawRemove || (_this._onDrawReverse && isLine)))) {
                        finalColor = "#ff0000";
                    }
                    else {
                        finalColor = colors.reduce(function (combined, _a) {
                            var color = _a[0], amount = _a[1];
                            return utils_1.combineColors(combined, color, amount);
                        }, style[prop]);
                    }
                    style[prop] = finalColor;
                }
            });
        }
        return style;
    };
    LajiMap.prototype._getStyleForLayer = function (layer, overrideStyles) {
        var _a = this._getIdxTupleByLayer(layer), dataIdx = _a[0], featureIdx = _a[1];
        return this._getStyleForType([dataIdx, featureIdx], overrideStyles);
    };
    LajiMap.prototype.updateLayerStyle = function (layer) {
        if (!layer)
            return;
        this.setLayerStyle(layer, this._getStyleForLayer(layer));
    };
    LajiMap.prototype._getDefaultDrawStyle = function () {
        return { color: globals_1.NORMAL_COLOR, fillColor: globals_1.NORMAL_COLOR, opacity: 1, fillOpacity: 0.7 };
    };
    LajiMap.prototype._getDefaultDrawClusterStyle = function () {
        return { color: this.getDraw().getFeatureStyle({}).color, opacity: 1 };
    };
    LajiMap.prototype._getDefaultDataStyle = function (item) {
        return function () {
            var color = (item && item.editable) ?
                globals_1.EDITABLE_DATA_LAYER_COLOR :
                globals_1.DATA_LAYER_COLOR;
            return { color: color, fillColor: color, opacity: 1, fillOpacity: 0.7 };
        };
    };
    ;
    LajiMap.prototype._getDefaultDraftStyle = function (dataIdx) {
        return this._getStyleForType(dataIdx, { color: globals_1.EDITABLE_DATA_LAYER_COLOR, fillColor: globals_1.EDITABLE_DATA_LAYER_COLOR, opacity: 0.8 });
    };
    LajiMap.prototype._updateDataLayerGroupStyle = function (idx) {
        var _this = this;
        var item = this.data[idx];
        if (!item)
            return;
        item.group.eachLayer(function (layer) {
            _this.updateLayerStyle(layer);
        });
    };
    LajiMap.prototype.addTranslationHook = function (elemOrFn, translationKey, attr) {
        if (attr === void 0) { attr = "innerHTML"; }
        var that = this;
        function translate() {
            if (typeof elemOrFn === "function") {
                var fn = elemOrFn;
                fn();
            }
            else {
                var elem = elemOrFn;
                var translation = (typeof translationKey === "function") ? translationKey() : that.translations[translationKey];
                if (typeof elem[attr] === "function") {
                    elem[attr](translation);
                }
                else {
                    elem[attr] = translation;
                }
            }
        }
        translate();
        this.onSetLangHooks.push(translate);
        return translate;
    };
    LajiMap.prototype.removeTranslationHook = function (hook) {
        var index = this.onSetLangHooks.indexOf(hook);
        if (index >= 0) {
            this.onSetLangHooks.splice(index, 1);
        }
    };
    LajiMap.prototype._getDrawOptionsForType = function (featureType) {
        var baseStyle = this.getDraw().getDraftStyle();
        var additionalOptions = {};
        switch (featureType) {
            case "marker":
                additionalOptions = {
                    icon: this._createIcon(__assign({}, this.getDraw().getDraftStyle()))
                };
                break;
            case "polygon":
                additionalOptions = {
                    allowIntersection: false
                };
                break;
        }
        var _userDefined = this.getDraw()[featureType];
        var userDefined = utils_1.isObject(_userDefined) ? _userDefined : {};
        return __assign(__assign(__assign({ metric: true, showLength: true, showRadius: true }, additionalOptions), userDefined), { shapeOptions: __assign(__assign(__assign({ showArea: true, poly: {
                    allowIntersection: false
                } }, baseStyle), (additionalOptions.shapeOptions || {})), userDefined) });
    };
    LajiMap.prototype.abortDrawing = function (e) {
        if (e.preventDefault) {
            e.preventDefault();
            e.stopPropagation();
        }
        if (this._draftDrawLayer)
            this._draftDrawLayer.disable();
        this._draftDrawLayer = undefined;
        this._removeKeyListener(globals_1.ESC, this.abortDrawing);
        this.map.off("controlClick", this.abortDrawing);
        this.map.removeEventListener("draw:created", this.abortDrawing);
    };
    LajiMap.prototype.addDrawAbortListeners = function () {
        this.map.on("draw:created", this.abortDrawing);
        this.map.on("controlClick", this.abortDrawing);
        this._addKeyListener(globals_1.ESC, this.abortDrawing);
    };
    LajiMap.prototype.triggerDrawing = function (featureType) {
        this._draftDrawLayer = new L.Draw[capitalizeFirstLetter(featureType)](this.map, this._getDrawOptionsForType(featureType));
        this._draftDrawLayer.enable();
        this.addDrawAbortListeners();
    };
    LajiMap.prototype.addFeatureToDraw = function (feature) {
        this.addFeatureToData(feature, this.drawIdx);
    };
    LajiMap.prototype.addFeatureToData = function (feature, dataIdx) {
        var layer = this._featureToLayer(this.data[dataIdx].getFeatureStyle)(feature);
        this._onAdd(dataIdx, layer);
    };
    LajiMap.prototype.getFeatureTypes = function () {
        return ["rectangle", "polyline", "polygon", "circle", "marker"];
    };
    LajiMap.prototype._showError = function (e) {
        var _this = this;
        var alert = document.createElement("div");
        alert.style.display = "block";
        alert.className = "laji-map-popup alert alert-danger";
        var lajiMapError = (e._lajiMapError) ? e : undefined;
        var message = function () { return translations_1.default.errorHTML + " " + lajiMapError
            ? utils_1.stringifyLajiMapError(lajiMapError, _this.translations)
            : e.message; };
        var translationHook = this.addTranslationHook(alert, message);
        this.showClosableElement(alert, function () {
            _this.removeTranslationHook(translationHook);
        });
    };
    LajiMap.prototype.showClosableElement = function (elem, onClose, blocker, getContainer) {
        var _this = this;
        if (blocker === void 0) { blocker = false; }
        if (getContainer === void 0) { getContainer = function () { return _this.container; }; }
        var closeButton = document.createElement("button");
        closeButton.setAttribute("type", "button");
        closeButton.className = "close";
        closeButton.innerHTML = "✖";
        closeButton.addEventListener("click", close);
        elem.insertBefore(closeButton, elem.firstChild);
        var that = this;
        function close(e) {
            if (e)
                e.preventDefault();
            that._removeKeyListener(globals_1.ESC, close);
            getContainer().removeChild(elem);
            if (blocker) {
                that.blockerElem.style.display = "";
                that.blockerElem.removeEventListener("click", close);
            }
            if (onClose)
                onClose(e);
            that._closeDialog = undefined;
            that._openDialogs = that._openDialogs.filter(function (dialog) { return dialog !== elem; });
            return true;
        }
        this._addKeyListener(globals_1.ESC, close);
        getContainer().appendChild(elem);
        if (blocker) {
            this.blockerElem.addEventListener("click", close);
            this.blockerElem.style.display = "block";
        }
        this._closeDialog = close;
        if (getContainer() === this._dialogRoot) {
            this._openDialogs.push(elem);
        }
    };
    LajiMap.prototype._createTooltip = function (translationKey, error) {
        var _this = this;
        if (error === void 0) { error = false; }
        if (this._tooltip && this._tooltipTranslationHook) {
            this.removeTranslationHook(this._tooltipTranslationHook);
        }
        else {
            if (this._tooltip)
                this._disposeTooltip();
            this._tooltip = new L.Draw.Tooltip(this.map);
            this._onMouseMove = function (_a) {
                var latlng = _a.latlng;
                return _this._tooltip.updatePosition(latlng);
            };
            ["mousemove", "touchmove", "MSPointerMove"].forEach(function (eType) { return _this.map.on(eType, _this._onMouseMove); });
            if (this._mouseLatLng)
                this._onMouseMove({ latlng: this._mouseLatLng });
        }
        if (translationKey in this.translations) {
            this._tooltipTranslationHook = this.addTranslationHook(function () { return _this._tooltip.updateContent({ text: _this.translations[translationKey] }); });
        }
        else {
            this._tooltip.updateContent({ text: translationKey });
        }
        if (error)
            this._tooltip.showAsError();
        else
            this._tooltip.removeError();
        return this._tooltip;
    };
    LajiMap.prototype._disposeTooltip = function () {
        var _this = this;
        if (this._onMouseMove)
            ["mousemove", "touchmove", "MSPointerMove"].forEach(function (eType) { return _this.map.off(eType, _this._onMouseMove); });
        this._onMouseMove = undefined;
        if (this._tooltip)
            this._tooltip.dispose();
        this._tooltipTranslationHook && this.removeTranslationHook(this._tooltipTranslationHook);
        this._tooltip = undefined;
    };
    LajiMap.prototype._showDialog = function (container, onClose) {
        var _this = this;
        var _container = document.createElement("div");
        _container.className = "laji-map-dialog panel panel-default panel-body";
        if (this._dialogRoot === document.body) {
            _container.className += " fixed";
        }
        _container.appendChild(container);
        function close(e) {
            if (onClose)
                onClose(e);
        }
        this.showClosableElement(_container, close, !!"showBlocker", function () { return _this._dialogRoot; });
    };
    LajiMap.prototype.setLineTransectGeometry = function (geometry, events) {
        console.warn("line transect mixin not included!");
    };
    LajiMap.prototype.setGoogleApiKey = function (googleApiKey) {
        this.googleApiKey = googleApiKey;
        dependency_utils_1.provide(this, "googleApiKey");
    };
    LajiMap.prototype.setGeocodingProvider = function () {
        if (!dependency_utils_1.depsProvided(this, "setGeocodingProvider", arguments))
            return;
        this.provider = new leaflet_geosearch_1.GoogleProvider({ params: { key: this.googleApiKey, language: this.lang, region: "fi" } });
        dependency_utils_1.provide(this, "geocodingProvider");
    };
    LajiMap.prototype.geocode = function (query, additional, zoom) {
        var _this = this;
        if (!this.provider) {
            console.warn("googleApiKey not provided for geocode");
            return;
        }
        this.provider.search(__assign({ query: query }, (additional || {}))).then(function (results) {
            if (results === void 0) { results = []; }
            if (!_this.map || !results.length)
                return;
            var first = results[0];
            var x = first.x, y = first.y;
            _this.map.panTo([y, x], { animate: false });
            if (zoom) {
                _this.setNormalizedZoom(zoom);
            }
        });
    };
    LajiMap.prototype.setViewLocked = function (value) {
        if (!dependency_utils_1.depsProvided(this, "setViewLocked", arguments))
            return;
        var method = value ? "disable" : "enable";
        this.map.dragging[method]();
        this.map.touchZoom[method]();
        this.map.smoothWheelZoom[method]();
        this.map.boxZoom[method]();
        this.map.keyboard[method]();
        if (this.map.tap) {
            this.map.tap[method]();
        }
        this._disableDblClickZoom = value;
        this.viewLocked = value;
        if (dependency_utils_1.isProvided(this, "viewLocked")) {
            this.setClickBeforeZoomAndPan(this._clickBeforeZoomAndPan);
        }
        dependency_utils_1.provide(this, "viewLocked");
    };
    LajiMap.prototype.toggleFullscreen = function () {
        this._fullscreen ? this.setFullscreenOff() : this.setFullscreenOn();
    };
    LajiMap.prototype.setFullscreenOn = function () {
        this._fullscreen = true;
        this._fullscreenElem = document.createElement("div");
        this._fullscreenElem.className = "laji-map-fullscreen";
        document.body.appendChild(this._fullscreenElem);
        this._beforeFullscreen = {
            rootElem: this.rootElem,
            bodyAsDialogRoot: this._dialogRoot === document.body,
            clickBeforeZoomAndPan: this._clickBeforeZoomAndPan,
            bodyOverflowY: document.body.style.overflowY
        };
        this.setRootElem(this._fullscreenElem);
        this.map.getContainer().focus();
        this.setBodyAsDialogRoot(false);
        this.setClickBeforeZoomAndPan(false);
        document.body.style.overflowY = "hidden";
        this._addKeyListener(globals_1.ESC, this.setFullscreenOff);
    };
    LajiMap.prototype.setFullscreenOff = function () {
        this._fullscreen = false;
        var _a = this._beforeFullscreen, rootElem = _a.rootElem, bodyAsDialogRoot = _a.bodyAsDialogRoot, clickBeforeZoomAndPan = _a.clickBeforeZoomAndPan, bodyOverflowY = _a.bodyOverflowY;
        this.setRootElem(rootElem);
        this.setBodyAsDialogRoot(bodyAsDialogRoot);
        this.setClickBeforeZoomAndPan(clickBeforeZoomAndPan);
        document.body.style.overflowY = bodyOverflowY;
        document.body.removeChild(this._fullscreenElem);
        this._removeKeyListener(globals_1.ESC, this.setFullscreenOff);
    };
    __decorate([
        dependency_utils_1.dependsOn("rootElem")
    ], LajiMap.prototype, "setBodyAsDialogRoot", null);
    __decorate([
        dependency_utils_1.dependsOn("rootElem", "map", "translations", "viewLocked")
    ], LajiMap.prototype, "setClickBeforeZoomAndPan", null);
    __decorate([
        dependency_utils_1.dependsOn("rootElem", "center", "zoom")
    ], LajiMap.prototype, "_initializeMap", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "_initializeView", null);
    __decorate([
        dependency_utils_1.dependsOn("tileLayer")
    ], LajiMap.prototype, "_swapToWorldOutsideFinland", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "_initializeMapEvents", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setEventListeners", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setTileLayerByName", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setAvailableTileLayers", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setAvailableTileLayerBlacklist", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setAvailableTileLayerWhitelist", null);
    __decorate([
        dependency_utils_1.dependsOn("map", "view")
    ], LajiMap.prototype, "setTileLayers", null);
    __decorate([
        dependency_utils_1.dependsOn("tileLayer")
    ], LajiMap.prototype, "setTileLayerOpacity", null);
    __decorate([
        dependency_utils_1.dependsOn("tileLayer")
    ], LajiMap.prototype, "setOverlaysByName", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setAvailableOverlaysWhitelist", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setAvailableOverlays", null);
    __decorate([
        dependency_utils_1.dependsOn("map", "view")
    ], LajiMap.prototype, "setNormalizedZoom", null);
    __decorate([
        dependency_utils_1.dependsOn("zoom", "view")
    ], LajiMap.prototype, "setCenter", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setLang", null);
    __decorate([
        dependency_utils_1.dependsOn("data", "draw", "view")
    ], LajiMap.prototype, "zoomToData", null);
    __decorate([
        dependency_utils_1.dependsOn("map", "translations")
    ], LajiMap.prototype, "setData", null);
    __decorate([
        dependency_utils_1.dependsOn("map", "data")
    ], LajiMap.prototype, "setDraw", null);
    __decorate([
        dependency_utils_1.dependsOn("data")
    ], LajiMap.prototype, "_setOnChangeForItem", null);
    __decorate([
        dependency_utils_1.dependsOn("translations")
    ], LajiMap.prototype, "_updateContextMenuForLayer", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "_setLocateOn", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "_setLocateOff", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "_onLocationFound", null);
    __decorate([
        dependency_utils_1.reflect(),
        dependency_utils_1.dependsOn("translations", "googleApiKey")
    ], LajiMap.prototype, "setGeocodingProvider", null);
    __decorate([
        dependency_utils_1.dependsOn("map")
    ], LajiMap.prototype, "setViewLocked", null);
    return LajiMap;
}());
exports.default = LajiMap;
