"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.geoJSONAsFeatureCollection = exports.flattenMultiLineStringsAndMultiPolygons = exports.anyToFeatureCollection = exports.capitalizeFirstLetter = exports.getLineTransectStartEndDistancesForIdx = exports.combineColors = exports.isObject = exports.createTextArea = exports.createTextInput = exports.roundMeters = exports.validateLatLng = exports.etrsTm35FinGridStrictValidator = exports.etrsValidator = exports.etrsTm35FinValidator = exports.ykjGridStrictValidator = exports.ykjGridValidator = exports.ykjValidator = exports.wgs84Validator = exports.parseJSON = exports.renderLajiMapError = exports.stringifyLajiMapError = exports.CoordinateError = exports.LajiMapGeoJSONError = exports.LajiMapGeoJSONConversionError = exports.LajiMapError = exports.getCRSObjectForGeoJSON = exports.coordinatesAreClockWise = exports.validateGeoJSON = exports.convert = exports.convertAnyToWGS84GeoJSON = exports.detectCRS = exports.detectCRSFromLatLng = exports.detectFormat = exports.geoJSONLineToLatLngSegmentArrays = exports.latLngSegmentsToGeoJSONGeometry = exports.latLngTuplesDistance = exports.latLngTuplesEqual = exports.latLngOrTupleToTuple = exports.WKTToGeoJSON = exports.geoJSONToWKT = exports.ISO6709ToGeoJSON = exports.geoJSONToISO6709 = exports.geoJSONToTextualFormatWith = exports.standardizeGeoJSON = exports.circleToPolygon = exports.convertGeoJSON = exports.updateImmutablyRecursivelyWith = exports.convertLatLng = exports.reverseCoordinate = void 0;
var proj4 = require("proj4");
var globals_1 = require("./globals");
function reverseCoordinate(c) {
    return c.slice(0).reverse();
}
exports.reverseCoordinate = reverseCoordinate;
proj4.defs("EPSG:2393", globals_1.EPSG2393String);
proj4.defs("EPSG:3067", globals_1.EPSG3067String);
// There are two sets of ETRS-GKn. Read more: http://latuviitta.org/documents/ETRS-GKn_ja_EPSG-koodit.html
// Old ETRS-GKn
proj4.defs("EPSG:3126", "+proj=tmerc +lat_0=0 +lon_0=19 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3127", "+proj=tmerc +lat_0=0 +lon_0=20 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3128", "+proj=tmerc +lat_0=0 +lon_0=21 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3129", "+proj=tmerc +lat_0=0 +lon_0=22 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3130", "+proj=tmerc +lat_0=0 +lon_0=23 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3131", "+proj=tmerc +lat_0=0 +lon_0=24 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3132", "+proj=tmerc +lat_0=0 +lon_0=25 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3133", "+proj=tmerc +lat_0=0 +lon_0=26 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3134", "+proj=tmerc +lat_0=0 +lon_0=27 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3135", "+proj=tmerc +lat_0=0 +lon_0=28 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3136", "+proj=tmerc +lat_0=0 +lon_0=29 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3137", "+proj=tmerc +lat_0=0 +lon_0=30 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3138", "+proj=tmerc +lat_0=0 +lon_0=31 +k=1 +x_0=500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
// New ETRS-GKn
proj4.defs("EPSG:3873", "+proj=tmerc +lat_0=0 +lon_0=19 +k=1 +x_0=19500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3873", "+proj=tmerc +lat_0=0 +lon_0=19 +k=1 +x_0=19500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3874", "+proj=tmerc +lat_0=0 +lon_0=20 +k=1 +x_0=20500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3875", "+proj=tmerc +lat_0=0 +lon_0=21 +k=1 +x_0=21500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3876", "+proj=tmerc +lat_0=0 +lon_0=22 +k=1 +x_0=22500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3877", "+proj=tmerc +lat_0=0 +lon_0=23 +k=1 +x_0=23500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3878", "+proj=tmerc +lat_0=0 +lon_0=24 +k=1 +x_0=24500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3879", "+proj=tmerc +lat_0=0 +lon_0=25 +k=1 +x_0=25500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3880", "+proj=tmerc +lat_0=0 +lon_0=26 +k=1 +x_0=26500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3881", "+proj=tmerc +lat_0=0 +lon_0=27 +k=1 +x_0=27500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3882", "+proj=tmerc +lat_0=0 +lon_0=28 +k=1 +x_0=28500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3883", "+proj=tmerc +lat_0=0 +lon_0=29 +k=1 +x_0=29500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3884", "+proj=tmerc +lat_0=0 +lon_0=30 +k=1 +x_0=30500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
proj4.defs("EPSG:3885", "+proj=tmerc +lat_0=0 +lon_0=31 +k=1 +x_0=31500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs");
function convertLatLng(latlng, from, to) {
    function formatToProj4Format(format) {
        return proj4.defs(format) || format;
    }
    var _a = [from, to].map(function (crs) {
        if (crs === "EPSG:2393") {
            return ykjValidator;
        }
        else if (crs === "EPSG:3067") {
            return etrsTm35FinValidator;
        }
        else if (crs === "WGS84") {
            return wgs84Validator;
        }
    }), fromValidator = _a[0], toValidator = _a[1];
    var format = function (_latlng, validator) { return _latlng.map(function (c) { return "" + c; }).map(function (c, i) { return +validator[i].formatter(c); }); };
    if (fromValidator && fromValidator[0].formatter) {
        latlng = format(latlng, fromValidator);
    }
    if (fromValidator && (fromValidator[0].regexp || fromValidator[0].range)) {
        validateLatLng(latlng.map(function (c) { return "" + c; }), fromValidator, !!"throwMode");
    }
    var converted = reverseCoordinate(proj4(formatToProj4Format(from), formatToProj4Format(to), reverseCoordinate(latlng)));
    if (toValidator && toValidator[0].formatter) {
        return format(converted, toValidator);
    }
    return converted;
}
exports.convertLatLng = convertLatLng;
function updateImmutablyRecursivelyWith(obj, fn) {
    function _updater(_obj) {
        if (typeof _obj === "object" && _obj !== null) {
            Object.keys(_obj).forEach(function (key) {
                _obj[key] = fn(key, _obj[key]);
                _updater(_obj[key]);
            });
        }
        return _obj;
    }
    return _updater(parseJSON(JSON.stringify(obj)));
}
exports.updateImmutablyRecursivelyWith = updateImmutablyRecursivelyWith;
function convertGeoJSON(geoJSON, from, to) {
    var convertCoordinates = function (coords) {
        if (typeof coords[0] === "number") {
            var validator = undefined;
            switch (from) {
                case "EPSG:2393":
                    validator = ykjValidator;
                    break;
                case "EPSG:3067":
                    validator = etrsValidator;
                    break;
                case "WGS84":
                    validator = wgs84Validator;
                    break;
            }
            validator && validateLatLng(reverseCoordinate(coords).map(function (_c) { return "" + _c; }), validator, !!"throwMode");
            return reverseCoordinate(convertLatLng(reverseCoordinate(coords), from, to));
        }
        else {
            return coords.map(convertCoordinates);
        }
    };
    return updateImmutablyRecursivelyWith(geoJSON, function (key, obj) {
        if (key === "coordinates")
            obj = convertCoordinates(obj);
        return obj;
    });
}
exports.convertGeoJSON = convertGeoJSON;
/* Taken from https://github.com/arg20/circle-to-radius
 * (Copied here because the library didn't act nice with exporting)
 */
function circleToPolygon(center, radius, numberOfSegments) {
    function toRadians(angleInDegrees) {
        return angleInDegrees * Math.PI / 180;
    }
    function toDegrees(angleInRadians) {
        return angleInRadians * 180 / Math.PI;
    }
    function offset(c1, distance, bearing) {
        var lat1 = toRadians(c1[1]); // tslint:disable-line
        var lon1 = toRadians(c1[0]); // tslint:disable-line
        // distance divided by 6378137 (radius of the earth) wgs84
        var dByR = distance / 6378137; // tslint:disable-line
        var lat = Math.asin(// tslint:disable-line
        Math.sin(lat1) * Math.cos(dByR) +
            Math.cos(lat1) * Math.sin(dByR) * Math.cos(bearing));
        var lon = lon1 + Math.atan2(// tslint:disable-line
        Math.sin(bearing) * Math.sin(dByR) * Math.cos(lat1), Math.cos(dByR) - Math.sin(lat1) * Math.sin(lat));
        return [toDegrees(lon), toDegrees(lat)];
    }
    var n = numberOfSegments ? numberOfSegments : 32; // tslint:disable-line
    var flatCoordinates = []; // tslint:disable-line
    var coordinates = []; // tslint:disable-line
    for (var i = 0; i < n; ++i) { // tslint:disable-line
        flatCoordinates.push.apply(flatCoordinates, offset(center, radius, 2 * Math.PI * i / n));
    }
    flatCoordinates.push(flatCoordinates[0], flatCoordinates[1]);
    for (var i = 0, j = 0; j < flatCoordinates.length; j += 2) { // tslint:disable-line
        coordinates[i++] = flatCoordinates.slice(j, j + 2);
    }
    return {
        type: 'Polygon',
        coordinates: [coordinates.reverse()]
    };
}
exports.circleToPolygon = circleToPolygon;
function standardizeGeoJSON(geoJSON) {
    function standardizeGeometry(geom) {
        var coordinateVerbatim = geom.coordinateVerbatim, radius = geom.radius, standardized = __rest(geom, ["coordinateVerbatim", "radius"]);
        if (radius !== undefined) {
            standardized = circleToPolygon(standardized.coordinates, radius, 8);
        }
        return standardized;
    }
    return updateImmutablyRecursivelyWith(geoJSON, function (key, obj) {
        if (key === "geometry")
            obj = standardizeGeometry(obj);
        return obj;
    });
}
exports.standardizeGeoJSON = standardizeGeoJSON;
function geoJSONToTextualFormatWith(geoJSON, name, latLngCoordConverter, coordinateJoiner, coordinateStrToPoint, coordinateStrToLine, coordinateStrToPolygon) {
    function geoJSONCoordToTextual(coords) {
        return latLngCoordConverter(reverseCoordinate(coords));
    }
    function geoJSONCoordsJoin(coords) {
        return coordinateJoiner(coords.map(geoJSONCoordToTextual));
    }
    function geoJSONCoordsToTextualArea(coords) {
        var _coords = coords.slice(0);
        return geoJSONCoordsJoin(_coords);
    }
    function geometryConverterFn(geometry) {
        switch (geometry.type) {
            case "GeometryCollection":
                return geometry.geometries.reduce(function (collStr, _geom) { return "" + collStr + geometryConverterFn(_geom) + "\n"; }, "");
            case "Point":
                return coordinateStrToPoint(geoJSONCoordToTextual(geometry.coordinates));
            case "LineString":
                return coordinateStrToLine(geoJSONCoordsJoin(geometry.coordinates));
            case "Polygon": {
                if (geometry.coordinates.length > 1)
                    throw new Error(name + " doesn't support polygons with interior rings.");
                return coordinateStrToPolygon(geoJSONCoordsToTextualArea(geometry.coordinates[0]));
            }
            default:
                throw new Error("Unknown geometry type " + geometry.type + " for " + name + " conversion");
        }
    }
    function recursiveConvert(geometry, coordinateStr) {
        if (coordinateStr === void 0) { coordinateStr = ""; }
        var reducer = function (_coordinateStr, geoObject) {
            if (geoObject.features) {
                geoObject.features.forEach(function (feature) {
                    _coordinateStr += "" + recursiveConvert(feature);
                });
            }
            else if (geoObject.geometry) {
                _coordinateStr += geometryConverterFn(geoObject.geometry) + "\n";
            }
            else if (geoObject.geometries) {
                geoObject.geometries.forEach(function (_geometry) {
                    _coordinateStr += geometryConverterFn(_geometry) + "\n";
                });
            }
            else if (geoObject.coordinates) {
                _coordinateStr += geometryConverterFn(geoObject) + "\n";
            }
            else {
                throw new Error("Ran into an unknown geoJSON object \"" + geoObject + "\"");
            }
            return _coordinateStr;
        };
        return (Array.isArray(geometry) ? geometry : [geometry]).reduce(reducer, coordinateStr);
    }
    return recursiveConvert(geoJSON).replace(/\n$/, "");
}
exports.geoJSONToTextualFormatWith = geoJSONToTextualFormatWith;
// Pads zeros to start of integer and end of decimal.
function fixWgs84Length(coordinateHalf, intLength, decLength) {
    var coordHalfStr = "" + coordinateHalf;
    var parts = coordHalfStr.split(".");
    var integerPart = ("" + "0".repeat(intLength) + parts[0]).slice(-intLength);
    var decimalPart = ("" + parts[1] + "0".repeat(decLength)).slice(0, decLength);
    return integerPart + "." + decimalPart;
}
function geoJSONToISO6709(geoJSON) {
    function latLngToISO6709String(latLng) {
        function formatCoordHalf(coordHalf, intAmount) {
            var coordHalfStr = "" + coordHalf;
            // Don't add sign to YKJ.
            if (detectCRSFromLatLng(latLng) === "EPSG:2393") {
                return coordHalfStr;
            }
            var sign = "+";
            if (coordHalfStr.indexOf("-") !== -1) {
                sign = "-";
                coordHalfStr = coordHalfStr.slice(1);
            }
            var numberPart = detectCRSFromLatLng(latLng) === "WGS84"
                ? fixWgs84Length(coordHalfStr, intAmount, 6)
                : coordHalfStr;
            coordHalfStr = "" + sign + numberPart;
            return coordHalfStr;
        }
        var delimiter = (detectCRSFromLatLng(latLng) !== "EPSG:2393") ? "" : ":"; // Use ':' delimiter for YKJ.
        return "" + formatCoordHalf(latLng[0], 2) + delimiter + formatCoordHalf(latLng[1], 3) + "/";
    }
    function coordinateJoiner(coords) {
        return coords.join("");
    }
    function coordinateStrToPoint(coords) {
        return coords;
    }
    var coordinateStrToLine = coordinateStrToPoint;
    function coordinateStrToPolygon(coords) {
        return "/" + coords;
    }
    var ISOGeo = geoJSONToTextualFormatWith(geoJSON, "ISO 6709", latLngToISO6709String, coordinateJoiner, coordinateStrToPoint, coordinateStrToLine, coordinateStrToPolygon);
    if (geoJSON.crs) {
        var projString = geoJSON.crs.properties.name;
        if (projString === globals_1.EPSG2393String) {
            ISOGeo += "\nCRSEPSG:2393";
        }
        else if (projString === globals_1.EPSG3067String) {
            ISOGeo += "\nCRSEPSG:3067";
        }
        else {
            ISOGeo += "\nCRS" + projString;
        }
    }
    return ISOGeo;
}
exports.geoJSONToISO6709 = geoJSONToISO6709;
function textualFormatToGeoJSON(text, lineToCoordinates, lineIsPolygon, lineIsLineString, lineIsPoint) {
    var _lineToCoordinates = function (line, idx) {
        try {
            var coords = lineToCoordinates(line);
            if (!coords || coords.length < 1 || coords.some(function (coord) { return coord.length < 2; })) {
                throw new LajiMapError("Coordinate parsing failed", "coordinateParsingError", idx);
            }
            return coords;
        }
        catch (e) {
            throw new LajiMapError("Line coordinate parsing failed", "CoordinateParsingError", idx);
        }
    };
    var asFeature = function (geometry) { return ({ type: "Feature", properties: {}, geometry: geometry }); };
    var features = text
        .split("\n")
        .reduce(function (_features, line, idx) {
        line = line.trim();
        if (!line)
            return _features;
        if (lineIsPolygon(line)) {
            var coordinates = [_lineToCoordinates(line, idx)];
            coordinates[0].push(coordinates[0][0]);
            if (coordinatesAreClockWise(coordinates[0])) {
                coordinates[0] = coordinates[0].reverse();
            }
            _features.push(asFeature({ type: "Polygon", coordinates: coordinates }));
            return _features;
        }
        else if (lineIsLineString(line)) {
            _features.push(asFeature({ type: "LineString", coordinates: _lineToCoordinates(line, idx) }));
            return _features;
        }
        else if (lineIsPoint(line)) {
            _features.push(asFeature({ type: "Point", coordinates: _lineToCoordinates(line, idx)[0] }));
            return _features;
        }
        else {
            throw new LajiMapError("Couldn't detect geo data line format. Line: " + (idx + 1), "LineGeoDataFormatError", idx);
        }
    }, []);
    return { type: "FeatureCollection", features: features };
}
function ISO6709ToGeoJSON(ISO6709) {
    function lineToCoordinates(line) {
        return line.split("/").filter(function (l) { return l; }).map(function (coordString) {
            return coordString.match(/-?\d+\.?\d*/g).map(function (n) { return +n; }).reverse();
        });
    }
    function lineIsPolygon(line) {
        return line.match(/^\//);
    }
    function lineIsLineString(line) {
        var result = line.match(/^(.+(\+|-|:).+\/){2,}$/g);
        return result;
    }
    function lineIsPoint(line) {
        return line.match(/^(\+|-)?\d+\.?\d*(\+|-|:)\d+\.?\d*\/$/);
    }
    ISO6709 = ISO6709.replace(/CRS.*$/, "");
    return textualFormatToGeoJSON(ISO6709, lineToCoordinates, lineIsPolygon, lineIsLineString, lineIsPoint);
}
exports.ISO6709ToGeoJSON = ISO6709ToGeoJSON;
function geoJSONToWKT(geoJSON) {
    function latLngToWKTString(latLng) {
        return latLng.reverse().join(" ");
    }
    function coordinateJoiner(coords) {
        return coords.join(",");
    }
    function coordinateStrToPoint(coords) {
        return "POINT(" + coords + ")";
    }
    function coordinateStrToLine(coords) {
        return "LINESTRING(" + coords + ")";
    }
    function coordinateStrToPolygon(coords) {
        return "POLYGON((" + coords + "))";
    }
    var WKTGeo = geoJSONToTextualFormatWith(geoJSON, "ISO 6709", latLngToWKTString, coordinateJoiner, coordinateStrToPoint, coordinateStrToLine, coordinateStrToPolygon);
    if (geoJSON.crs) {
        var projString = geoJSON.crs.properties.name;
        if (projString === globals_1.EPSG2393String) {
            WKTGeo += "\n" + globals_1.EPSG2393WKTString;
        }
        else if (projString === globals_1.EPSG3067String) {
            WKTGeo += "\n" + globals_1.EPSG3067WKTString;
        }
        else {
            WKTGeo += "\n" + projString;
        }
    }
    return WKTGeo;
}
exports.geoJSONToWKT = geoJSONToWKT;
function WKTToGeoJSON(WKT) {
    function lineToCoordinates(line) {
        return line.match(/.+\({1,2}([^\(\)]*)\){1,2}/)[1].split(",").map(function (spacedPair) { return spacedPair.trim().split(" ").map(function (c) { return +c; }); });
    }
    function lineIsPolygon(line) {
        return line.match("^" + ("POLYGON"));
    }
    function lineIsLineString(line) {
        return line.match("^" + ("LINESTRING"));
    }
    function lineIsPoint(line) {
        return line.match("^" + ("POINT"));
    }
    WKT = WKT.replace(/^PROJCS.*/, "");
    return textualFormatToGeoJSON(WKT, lineToCoordinates, lineIsPolygon, lineIsLineString, lineIsPoint);
}
exports.WKTToGeoJSON = WKTToGeoJSON;
function latLngOrTupleToTuple(latLng) {
    if (isObject(latLng)) {
        return [latLng.lat, latLng.lng];
    }
    return latLng;
}
exports.latLngOrTupleToTuple = latLngOrTupleToTuple;
function latLngTuplesEqual(first, second) {
    return [0, 1, 2].every(function (idx) { return first[idx] === second[idx]; });
}
exports.latLngTuplesEqual = latLngTuplesEqual;
// Copy pasted from leaflet/src/geo/crs/CRS.Earth.js for headless usage.
// distance between two geographical points using spherical law of cosines approximation
function distance(latlng1, latlng2) {
    var rad = Math.PI / 180, // tslint:disable-line
    lat1 = latlng1.lat * rad, lat2 = latlng2.lat * rad, sinDLat = Math.sin((latlng2.lat - latlng1.lat) * rad / 2), sinDLon = Math.sin((latlng2.lng - latlng1.lng) * rad / 2), a = sinDLat * sinDLat + Math.cos(lat1) * Math.cos(lat2) * sinDLon * sinDLon, c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    // return this.R * c;
    return 6371000 * c;
}
function latLngTuplesDistance(first, second) {
    var _a;
    _a = [first, second].map(function (_a) {
        var lat = _a[0], lng = _a[1];
        return ({ lat: lat, lng: lng });
    }), first = _a[0], second = _a[1];
    return distance(first, second);
}
exports.latLngTuplesDistance = latLngTuplesDistance;
function latLngSegmentsToGeoJSONGeometry(_lines) {
    var lines = [];
    _lines.forEach(function (segments) {
        lines.push([]);
        var segmentPairs = segments.map(function (segment, i) {
            var next = segments[i + 1];
            return [segment, next];
        });
        segmentPairs.forEach(function (pair) {
            var line = lines[lines.length - 1];
            var first = pair[0], last = pair[1];
            line.push(first[0]);
            if (pair[1] && !latLngTuplesEqual(first[1], last[0])) {
                line.push(first[1]);
                lines.push([]);
            }
            else if (!last) {
                line.push(first[1]);
            }
        });
    });
    lines = lines.filter(function (line) { return line.length; });
    // TODO we aren't checking for length of zero
    var isMulti = lines.length > 1;
    return isMulti ? {
        type: "MultiLineString",
        coordinates: lines
    } : {
        type: "LineString",
        coordinates: lines[0]
    };
}
exports.latLngSegmentsToGeoJSONGeometry = latLngSegmentsToGeoJSONGeometry;
function geoJSONLineToLatLngSegmentArrays(geometry) {
    function lineStringToSegments(lineString) {
        return lineString.map(function (c, i) {
            var next = lineString[i + 1];
            if (next)
                return [reverseCoordinate(c), reverseCoordinate(next)];
        }).filter(function (c) { return c; });
    }
    return (geometry.type === "MultiLineString" ?
        geometry.coordinates : [geometry.coordinates]).map(lineStringToSegments);
}
exports.geoJSONLineToLatLngSegmentArrays = geoJSONLineToLatLngSegmentArrays;
function detectFormat(data) {
    if (typeof data === "string" && data.indexOf("{") === -1 && data.indexOf("(") !== -1) {
        return "WKT";
    }
    else if (typeof data === "string" && data.indexOf("{") === -1 && data.indexOf("/") !== -1) {
        return "ISO 6709";
    }
    else if (typeof data === "object" || typeof data === "string" && data.indexOf("{") !== -1) {
        if (typeof data === "string") {
            try {
                JSON.parse(data);
            }
            catch (e) {
                throw new LajiMapError("Parsing JSON failed", "ParsingJSONFailed");
            }
        }
        return "GeoJSON";
    }
}
exports.detectFormat = detectFormat;
function detectCRSFromLatLng(latLng, allowGrid) {
    if (allowGrid === void 0) { allowGrid = false; }
    if (isObject(latLng) && latLng.lat && latLng.lng) {
        latLng = [latLng.lat, latLng.lng];
    }
    if (validateLatLng(latLng, wgs84Validator)) {
        return "WGS84";
    }
    else if (validateLatLng(latLng, ykjValidator)
        || latLng[0].length === latLng[1].length && allowGrid && validateLatLng(latLng, ykjGridStrictValidator)) {
        return "EPSG:2393";
    }
    else if (validateLatLng(latLng, etrsTm35FinValidator)
        || allowGrid && latLng[0].length === latLng[1].length && validateLatLng(latLng, etrsTm35FinGridStrictValidator)) {
        return "EPSG:3067";
    }
}
exports.detectCRSFromLatLng = detectCRSFromLatLng;
function detectCRS(data, allowGrid) {
    if (allowGrid === void 0) { allowGrid = false; }
    var format = detectFormat(data);
    var geoJSON = undefined;
    if (format === "WKT") {
        data = data;
        var detection = data.match(/(PROJCS.*)/);
        if (detection) {
            if (detection[1] === globals_1.EPSG2393WKTString)
                return "EPSG:2393";
            else if (detection[1] === globals_1.EPSG3067WKTString)
                return "EPSG:3067";
            else {
                try {
                    proj4(detection[1]);
                }
                catch (e) {
                    throw new LajiMapError("WKT CRS not supported", "WKTCRSNotSupported");
                }
            }
            return detection[1];
        }
        else {
            geoJSON = WKTToGeoJSON(data);
        }
    }
    else if (format === "ISO 6709") {
        data = data;
        var detection = data.match(/EPSG:[0-9]+/) && data.match(/CRS(.*)/);
        if (detection && proj4.defs(detection[1]))
            return detection[1];
        else if (detection)
            throw new LajiMapError("EPSG code not supported", "EPSGCodeNotSupported");
        else {
            geoJSON = ISO6709ToGeoJSON(data);
        }
    }
    else if (typeof data === "object" || typeof data === "string" && data.indexOf("{") !== -1) {
        geoJSON = (typeof data === "object") ? data : parseJSON(data);
        if (geoJSON.crs) {
            var crs = geoJSON.crs.properties.name;
            try {
                proj4(crs);
            }
            catch (e) {
                throw new LajiMapError("GeoJSON CRS not supported", "GeoJSONCRSNotSupported");
            }
            return crs;
        }
    }
    try {
        return detectCRSFromLatLng(data, allowGrid);
    }
    catch (e) {
        var geometrySample = geoJSON;
        while (geometrySample) {
            if (geometrySample.geometries) {
                geometrySample = geometrySample.geometries[0];
            }
            else if (geometrySample.geometry) {
                geometrySample = geometrySample.geometry;
            }
            else if (geometrySample.features && geometrySample.features[0]) {
                geometrySample = geometrySample.features[0];
            }
            else if (!geometrySample.coordinates) {
                geometrySample = undefined;
            }
            if (geometrySample && geometrySample.coordinates) {
                var coordinateSample = geometrySample.coordinates;
                while (Array.isArray(coordinateSample[0]))
                    coordinateSample = coordinateSample[0];
                coordinateSample = coordinateSample.map(function (c) { return "" + c; }).reverse();
                return detectCRSFromLatLng(coordinateSample, allowGrid);
            }
        }
    }
}
exports.detectCRS = detectCRS;
function convertAnyToWGS84GeoJSON(data, validate) {
    if (validate === void 0) { validate = false; }
    return convert(data, "GeoJSON", "WGS84", validate);
}
exports.convertAnyToWGS84GeoJSON = convertAnyToWGS84GeoJSON;
function convert(input, outputFormat, outputCRS, validate) {
    if (input === undefined) {
        return undefined;
    }
    var inputFormat = detectFormat(input);
    var inputCRS = detectCRS(input);
    var geoJSON = undefined;
    if (inputFormat === "WKT") {
        geoJSON = WKTToGeoJSON(input);
    }
    else if (inputFormat === "ISO 6709") {
        geoJSON = ISO6709ToGeoJSON(input);
    }
    else if (inputFormat === "GeoJSON") {
        geoJSON = (typeof input === "object") ? input : parseJSON(input);
        delete geoJSON.crs;
    }
    else {
        throw new LajiMapError("Couldn't detect geo data format", "GeoDataFormatDetectionError");
    }
    if (geoJSON && (geoJSON.features && geoJSON.features.length > 0 || geoJSON.geometry) && !inputCRS) {
        throw new LajiMapError("Couldn't detect geo data CRS", "GeoDataCRSDetectionError");
    }
    if (inputCRS !== outputCRS)
        geoJSON = convertGeoJSON(geoJSON, inputCRS, outputCRS);
    if (outputCRS !== "WGS84")
        geoJSON.crs = getCRSObjectForGeoJSON(geoJSON, outputCRS);
    var result = undefined;
    switch (outputFormat) {
        case "WKT":
            return geoJSONToWKT(geoJSON);
        case "ISO 6709":
            return geoJSONToISO6709(geoJSON);
        case "GeoJSON":
            result = geoJSON;
            if (validate) {
                var _a = validateGeoJSON(geoJSON, outputCRS, validate !== "errors"), errors = _a.errors, _geoJSON = _a.geoJSON;
                if (errors.length) {
                    throw new LajiMapGeoJSONConversionError("GeoJSON validation failed", errors, _geoJSON);
                }
            }
            return result;
        default:
            throw new Error("Unknown output format");
    }
}
exports.convert = convert;
function validateGeoJSON(geoJSON, crs, warnings) {
    if (warnings === void 0) { warnings = true; }
    if (!crs) {
        crs = detectCRS(geoJSON);
    }
    var errors = [];
    var addError = function (e) {
        errors.push(e);
    };
    var addGeoJSONError = function (path, message, fixable) {
        if (fixable === void 0) { fixable = false; }
        if (fixable && !warnings)
            return;
        addError(new LajiMapGeoJSONError(message, path, fixable));
    };
    var validateCoordinate = function (c, path) {
        if (c.length !== 2 && c.length !== 3) {
            addGeoJSONError(path, "InvalidCoordinates");
        }
        try {
            var validator_1 = undefined;
            switch (crs) {
                case "EPSG:2393":
                    validator_1 = ykjValidator;
                    break;
                case "EPSG:3067":
                    validator_1 = etrsValidator;
                    break;
                case "WGS84":
                    validator_1 = wgs84Validator;
                    break;
            }
            validator_1 && validateLatLng(c.slice(0).reverse().map(function (_c) { return "" + _c; }), validator_1, !!"throwMode");
        }
        catch (e) {
            if (e.latOrLng) {
                addError(new CoordinateError(e.translationKey, e.latOrLng, e.half, path));
            }
        }
    };
    var validateRing = function (ring, isHole, _path) {
        ring.forEach(function (c, j) {
            validateCoordinate(c, _path + "/" + j);
        });
        if (!latLngTuplesEqual(ring[0], ring[ring.length - 1])) {
            addGeoJSONError(_path, "PolygonStartAndEndMustBeEqual");
        }
        if (!isHole ? coordinatesAreClockWise(ring) : !coordinatesAreClockWise(ring)) {
            addGeoJSONError(_path, !isHole
                ? "PolygonHoleCoordinatesShouldBeClockWise"
                : "PolygonCoordinatesShouldBeAntiClockWise", !!"fixable");
            return ring.reverse();
        }
        return ring;
    };
    var validator = function (_geoJSON, _path) {
        switch (_geoJSON.type) {
            case "FeatureCollection":
                _geoJSON = _geoJSON;
                if (!_geoJSON.features) {
                    addGeoJSONError(_path, "NoFeatures");
                    return _geoJSON;
                }
                return __assign(__assign({}, _geoJSON), { features: _geoJSON.features.map(function (g, i) { return validator(g, _path + "/features/" + i); }) });
            case "GeometryCollection":
                _geoJSON = _geoJSON;
                if (!_geoJSON.geometries) {
                    addGeoJSONError(_path, "NoGeometries");
                    return _geoJSON;
                }
                return __assign(__assign({}, _geoJSON), { geometries: _geoJSON.geometries.map(function (g, i) { return validator(g, _path + "/geometries/" + i); }) });
            case "Feature":
                _geoJSON = _geoJSON;
                if (!_geoJSON.geometry) {
                    addGeoJSONError(_path, "NoGeometry");
                    return _geoJSON;
                }
                return __assign(__assign({}, _geoJSON), { feature: validator(_geoJSON.geometry, _path + "/geometry") });
            case "Point":
                _geoJSON = _geoJSON;
                if (!_geoJSON.coordinates) {
                    addGeoJSONError(_path + "/coordinates", "NoCoordinates");
                }
                else {
                    validateCoordinate(_geoJSON.coordinates, _path + "/coordinates");
                }
                return _geoJSON;
            case "LineString":
                _geoJSON = _geoJSON;
                if (!_geoJSON.coordinates) {
                    addGeoJSONError(_path + "/coordinates", "NoCoordinates");
                    return _geoJSON;
                }
                _geoJSON.coordinates.forEach(function (c, i) {
                    validateCoordinate(c, _path + "/coordinates/" + i);
                });
                return _geoJSON;
            case "MultiLineString":
                _geoJSON = _geoJSON;
                if (!_geoJSON.coordinates) {
                    addGeoJSONError(_path + "/coordinates", "NoCoordinates");
                    return _geoJSON;
                }
                _geoJSON.coordinates.forEach(function (line, i) {
                    line.forEach(function (c, j) {
                        validateCoordinate(c, _path + "/coordinates" + i + "/" + j);
                    });
                });
                return _geoJSON;
            case "Polygon":
                _geoJSON = _geoJSON;
                if (!_geoJSON.coordinates) {
                    addGeoJSONError(_path + "/coordinates", "NoCoordinates");
                    return _geoJSON;
                }
                _geoJSON.coordinates = _geoJSON.coordinates.map(function (ring, i) { return validateRing(ring, !!i, _path + "/coordinates/" + i); });
                return _geoJSON;
            case "MultiPolygon":
                _geoJSON = _geoJSON;
                if (!_geoJSON.coordinates) {
                    addGeoJSONError(_path + "/coordinates", "NoCoordinates");
                    return _geoJSON;
                }
                _geoJSON.coordinates.forEach(function (coordinates, i) {
                    _geoJSON = _geoJSON;
                    geoJSON.coordinates[i] = _geoJSON.coordinates[i].map(function (ring, j) { return validateRing(ring, !!i, _path + "/coordinates/" + i + "/" + j); });
                });
                return _geoJSON;
        }
    };
    geoJSON = validator(JSON.parse(JSON.stringify(geoJSON)), "");
    return { errors: errors, geoJSON: geoJSON };
}
exports.validateGeoJSON = validateGeoJSON;
function coordinatesAreClockWise(coordinates) {
    var sum = coordinates.map(function (c, i) {
        var next = coordinates[i + 1];
        if (next)
            return [c, next];
    }).filter(function (c) { return c; })
        .reduce(function (_sum, edge) {
        return (_sum + (edge[1][0] - edge[0][0]) * (edge[1][1] + edge[0][1]));
    }, 0);
    var isClockwise = sum >= 0;
    return isClockwise;
}
exports.coordinatesAreClockWise = coordinatesAreClockWise;
function getCRSObjectForGeoJSON(geoJSON, crs) {
    return (!crs || crs === "WGS84") ? undefined : {
        type: "name",
        properties: {
            name: crs === "EPSG:2393"
                ? globals_1.EPSG2393String
                : crs === "EPSG:3067"
                    ? globals_1.EPSG3067String
                    : crs
        }
    };
}
exports.getCRSObjectForGeoJSON = getCRSObjectForGeoJSON;
var LajiMapError = /** @class */ (function (_super) {
    __extends(LajiMapError, _super);
    function LajiMapError(message, translationKey, lineIdx) {
        var _this = _super.call(this, message) || this;
        _this._lajiMapError = true;
        _this.stringify = function (translations) {
            var msg = _this.translationKey && translations[_this.translationKey]
                ? translations[_this.translationKey]
                : _this.message;
            if ("lineIdx" in _this)
                msg += ". " + translations.Line + ": " + _this.lineIdx;
            return msg;
        };
        _this.translationKey = translationKey;
        if (lineIdx !== undefined)
            _this.lineIdx = lineIdx;
        return _this;
    }
    return LajiMapError;
}(Error));
exports.LajiMapError = LajiMapError;
var LajiMapGeoJSONConversionError = /** @class */ (function (_super) {
    __extends(LajiMapGeoJSONConversionError, _super);
    function LajiMapGeoJSONConversionError(message, errors, geoJSON) {
        var _this = _super.call(this, message) || this;
        _this._lajiMapGeoJSONConversionError = true;
        _this.errors = errors;
        _this.geoJSON = geoJSON;
        return _this;
    }
    return LajiMapGeoJSONConversionError;
}(Error));
exports.LajiMapGeoJSONConversionError = LajiMapGeoJSONConversionError;
// Extending error with methods doesn't work, so we have error rendering here.
function renderGeoJSONError(e, translations) {
    var errorElem = document.createElement("li");
    var errorPath = document.createElement("span");
    errorPath.className = "error-path";
    errorPath.innerHTML = (typeof e.path === "string" ? e.path : "").replace(/\//g, ".").substring(1);
    var errorMessage = document.createElement("span");
    errorMessage.className = "error-message";
    errorMessage.innerHTML = translations[e.translationKey];
    errorElem.appendChild(errorMessage);
    if (e.path) {
        errorElem.appendChild(errorPath);
    }
    return errorElem;
}
var LajiMapGeoJSONError = /** @class */ (function (_super) {
    __extends(LajiMapGeoJSONError, _super);
    function LajiMapGeoJSONError(translationKey, path, fixable) {
        if (path === void 0) { path = ""; }
        if (fixable === void 0) { fixable = false; }
        var _this = _super.call(this, "", translationKey) || this;
        _this.render = function (translations) {
            return renderGeoJSONError(_this, translations);
        };
        _this.path = path;
        _this.fixable = fixable;
        return _this;
    }
    return LajiMapGeoJSONError;
}(LajiMapError));
exports.LajiMapGeoJSONError = LajiMapGeoJSONError;
var CoordinateError = /** @class */ (function (_super) {
    __extends(CoordinateError, _super);
    function CoordinateError(translationKey, latOrLng, half, path) {
        var _this = _super.call(this, translationKey, path) || this;
        _this.stringify = function (translations) {
            var msg = _this.translationKey && translations[_this.translationKey]
                ? translations[_this.translationKey]
                : "";
            var coordinateStr = _this.half
                ? translations.Erronous + " " + translations[_this.half === "lat" ? "Latitude" : "Longitude"] + " " + _this.latOrLng
                : translations.Coordinate + ": " + _this.latOrLng;
            return [msg, coordinateStr].filter(function (s) { return s; }).join(". ");
        };
        _this.render = function (translations) {
            var elem = renderGeoJSONError(_this, translations);
            var errorElem = elem.children[0];
            errorElem.innerHTML = _this.stringify(translations);
            return elem;
        };
        _this.latOrLng = latOrLng;
        _this.half = half;
        return _this;
    }
    return CoordinateError;
}(LajiMapGeoJSONError));
exports.CoordinateError = CoordinateError;
function stringifyLajiMapError(error, translations) {
    return error.stringify(translations);
}
exports.stringifyLajiMapError = stringifyLajiMapError;
function renderLajiMapError(error, translations, elemType) {
    if (elemType === void 0) { elemType = "span"; }
    if (error.render) {
        return error.render(translations);
    }
    else {
        var elem = document.createElement(elemType);
        elem.innerHTML = error.stringify ? stringifyLajiMapError(error, translations) : error.message;
        return elem;
    }
}
exports.renderLajiMapError = renderLajiMapError;
function parseJSON(json) {
    try {
        return JSON.parse(json);
    }
    catch (e) {
        throw new LajiMapError(e.message, "JsonParseError");
    }
}
exports.parseJSON = parseJSON;
var wgs84Check = {
    regexp: /^-?([0-9]{1,3}|[0-9]{1,3}\.[0-9]*)$/,
    range: [-180, 180],
    formatter: function (c) { return (+c).toFixed(6); }
};
var wgs84Validator = [wgs84Check, wgs84Check];
exports.wgs84Validator = wgs84Validator;
function formatterForLength(length) {
    return function (value) { return (value.length < length ? value + "0".repeat(length - value.length) : value); };
}
var ykjRegexp = /^[0-9]{7}$/;
var removeStrDecimals = function (c) { return "" + parseInt(c); };
var ykjValidator = [
    { regexp: ykjRegexp, range: [6600000, 7800000], formatter: removeStrDecimals },
    { regexp: ykjRegexp, range: [3000000, 3800000], formatter: removeStrDecimals }
];
exports.ykjValidator = ykjValidator;
var etrsTm35FinValidator = [
    { regexp: ykjRegexp, range: [6600000, 7800000], formatter: removeStrDecimals },
    { regexp: /^[0-9]{5,6}$/, range: [50000, 760000], formatter: removeStrDecimals }
];
exports.etrsTm35FinValidator = etrsTm35FinValidator;
var etrsValidator = etrsTm35FinValidator; // For backward compability
exports.etrsValidator = etrsValidator;
// Valid ykj grid input can not overlap etrsTm35Fin coordinate point. Invalidate cases where x-coordinate length is 7
// digits or y-coordinate doesn't start with '3' or y-coordinate length is 7 digits. This leaves an unlikely corner
// case where the user wants to input 1 m wide or 1 m long rectangle.
var ykjGridStrictValidator = ykjValidator.map(function (validator) { return (__assign(__assign({}, validator), { regexp: /^[0-9]{3,6}$/, formatter: formatterForLength(7) })); });
exports.ykjGridStrictValidator = ykjGridStrictValidator;
var ykjGridValidator = ykjGridStrictValidator; // For backward compability
exports.ykjGridValidator = ykjGridValidator;
var etrsTm35FinGridStrictValidator = etrsTm35FinValidator.map(function (validator, i) { return (__assign(__assign({}, validator), { regexp: i === 0 ? /^[0-9]{3,6}$/ : /^8[0-9]{2,5}$/, formatter: i === 0 ? formatterForLength(7) : function (str) { return formatterForLength(6)((str).substr(1, 7)); } })); });
exports.etrsTm35FinGridStrictValidator = etrsTm35FinGridStrictValidator;
var stripLeadingZeros = function (c) { return "" + parseInt(c, 10); };
function validateLatLng(latlng, latLngValidator, throwError) {
    if (throwError === void 0) { throwError = false; }
    return latlng.every(function (value, i) {
        value = stripLeadingZeros("" + value);
        var validator = latLngValidator[i];
        if (!validator) {
            return true;
        }
        var formatted = +(validator.formatter ? validator.formatter(value) : value);
        var isValid = (value !== "" && value.match(validator.regexp) &&
            formatted >= validator.range[0] && formatted <= validator.range[1]);
        if (!isValid && throwError) {
            throw new CoordinateError(undefined, latlng[i], i === 1 ? "lng" : "lat");
        }
        return isValid;
    });
}
exports.validateLatLng = validateLatLng;
function roundMeters(meters, accuracy) {
    if (accuracy === void 0) { accuracy = 1; }
    return accuracy ? Math.round(Math.round(meters) / accuracy) * accuracy : meters;
}
exports.roundMeters = roundMeters;
function createTextInput() {
    var input = document.createElement("input");
    input.type = "text";
    input.className = "form-control laji-map-input";
    return input;
}
exports.createTextInput = createTextInput;
function createTextArea(rows, cols) {
    if (rows === void 0) { rows = 10; }
    if (cols === void 0) { cols = 10; }
    var input = document.createElement("textarea");
    input.setAttribute("rows", "" + rows);
    input.setAttribute("cols", "" + cols);
    input.className = "form-control laji-map-input";
    return input;
}
exports.createTextArea = createTextArea;
function isObject(obj) {
    return typeof obj === "object" && obj !== null && !Array.isArray(obj) && obj.constructor === Object;
}
exports.isObject = isObject;
function combineColors() {
    var colors = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        colors[_i] = arguments[_i];
    }
    function toDecimal(hex) {
        return parseInt(hex, 16);
    }
    var max = undefined;
    var last = colors[colors.length - 1];
    if (typeof last === "number" || last === undefined) {
        max = typeof last === "number" ? last : 255;
        colors = colors.slice(0);
        colors.pop();
    }
    colors = colors.map(function (color) {
        if (color.length === 4) {
            var _a = color.split(""), hash = _a[0], r = _a[1], g = _a[2], b = _a[3];
            color = "#" + r + r + g + g + b + b;
        }
        return color;
    });
    var rv = colors.map(function (color) { return color.substring(1, 3); });
    var gv = colors.map(function (color) { return color.substring(3, 5); });
    var bv = colors.map(function (color) { return color.substring(5, 7); });
    return [rv, gv, bv].reduce(function (rgb, hexVector) {
        var value = hexVector.reduce(function (combinedDecimal, hex) {
            if (hex === "--") {
                return combinedDecimal;
            }
            if (combinedDecimal === undefined) {
                return toDecimal(hex);
            }
            var decimal = toDecimal(hex);
            var combinedDecimalInt = parseInt(combinedDecimal);
            var newCombined = Math.round(combinedDecimalInt - ((combinedDecimalInt - decimal) / 2));
            return Math.max(Math.min(newCombined, 255), 0);
        }, undefined);
        if (max !== undefined) {
            var initial = toDecimal(hexVector[0]);
            if (value > initial + max) {
                value = initial + max;
            }
            else if (value < initial - max) {
                value = initial - max;
            }
            value = Math.min(value, initial + max);
        }
        var hex = value.toString(16);
        if (hex.length === 1)
            hex = "0" + hex;
        return rgb + hex;
    }, "#");
}
exports.combineColors = combineColors;
function getLineTransectStartEndDistancesForIdx(LTFeature, idx, round) {
    var lines = geoJSONLineToLatLngSegmentArrays(LTFeature.geometry);
    var i = 0;
    var distance = 0;
    var prevDistance = distance;
    lines.some(function (line) {
        prevDistance = distance;
        line.some(function (_a) {
            var start = _a[0], end = _a[1];
            distance += latLngTuplesDistance(start, end);
        });
        if (i === idx) {
            return true;
        }
        i++;
    });
    return [prevDistance, distance].map(function (m) { return roundMeters(m, round); });
}
exports.getLineTransectStartEndDistancesForIdx = getLineTransectStartEndDistancesForIdx;
exports.capitalizeFirstLetter = function (s) { return s.charAt(0).toUpperCase() + s.slice(1); };
function anyToFeatureCollection(_geoJSON) {
    if (!_geoJSON) {
        return { type: "FeatureCollection", features: [] };
    }
    switch (_geoJSON.type) {
        case "FeatureCollection":
            return _geoJSON;
        case "Feature":
            return { type: "FeatureCollection", features: [_geoJSON] };
        case "Point":
        case "Polygon":
        case "LineString":
            return { type: "FeatureCollection", features: [{ type: "Feature", properties: {}, geometry: _geoJSON }] };
        case "GeometryCollection":
            return {
                type: "FeatureCollection",
                features: _geoJSON.geometries.map(function (geometry) { return ({ type: "Feature", properties: {}, geometry: geometry }); })
            };
        default:
            throw new Error("Invalid geoJSON type");
    }
}
exports.anyToFeatureCollection = anyToFeatureCollection;
;
function flattenMultiLineStringsAndMultiPolygons(features) {
    var flattened = [];
    features.forEach(function (f) {
        switch (f.geometry.type) {
            case "MultiLineString":
                f.geometry.coordinates.forEach(function (line) {
                    flattened.push({ type: "Feature", geometry: { type: "LineString", coordinates: line }, properties: f.properties });
                });
                break;
            case "MultiPolygon":
                f.geometry.coordinates.forEach(function (polygon) {
                    flattened.push({ type: "Feature", geometry: { type: "Polygon", coordinates: polygon }, properties: f.properties });
                });
                break;
            default:
                flattened.push(f);
        }
    });
    return flattened;
}
exports.flattenMultiLineStringsAndMultiPolygons = flattenMultiLineStringsAndMultiPolygons;
;
exports.geoJSONAsFeatureCollection = function (geoJSON) { return ({
    type: "FeatureCollection",
    features: flattenMultiLineStringsAndMultiPolygons(anyToFeatureCollection(geoJSON).features)
}); };
